Date	Added

2011/08/06
	* Added missing fields to guild belong info packet 0x16c (ZC_UPDATE_GDID). [Ai4rei]
2011/07/31
	* Fixed quest saving checking only the first 3 objectives for changes regardless of MAX_QUEST_OBJECTIVES (follow up to r14800, since r13973). [Ai4rei]
2011/07/22
	* CMake: Added options BUILD_TXT_SERVERS, BUILD_SQL_SERVERS, BUILD_MAPCACHE. [FlavioJS]
2011/07/21
	* CMake: Only install template files if they don't already exist. [FlavioJS]
	* CMake: Added plugin targets.
	* CMake: Added options BUILD_* to build the converters and individual plugins. (default=OFF)
	* CMake: Added option WITH_CPACK for package creation. (default=ON)
2011/07/20
	* Made GCOLLECT use it's debug functions. [FlavioJS]
	* Turned off garbage collection for GCOLLECT since there's nothing to do with explicit frees.
	* Added malloc_verify_ptr/malloc_usage code for all memory libraries.
	* Added malloc_memory_check for debug purposes, tests memory for errors and memory leaks.
	* Added explicit memory check on malloc_final.
2011/07/19
	* Made NO_MEMMGR only be set as a default value, allowing for simultaneous use with the memory libraries. [FlavioJS]
	* Moved memory library selection to malloc.c to avoid poisoning the namespace of the rest of the code.
	* Removed BCHECK code since it's uneeded. (bcheck is an external batch tool that runs on top of the dbx debugger)
	* Fixed GCOLLECT usage. (missing init and final memory leak check)
	* Fixed DMALLOC usage. (missing options on CYGWIN and verify memory)
	* Renamed malloc_verify to malloc_verify_ptr to avoid conflict with DMALLOC.
	* Changed itemtype from inline to static inline to avoid error with the SunOS compiler.
	* CMake: added option ENABLE_MEMMGR. (builtin memory manager)
	* CMake: added option ENABLE_MEMORY. (memory library)
	* CMake: added option ENABLE_EXTRA_DEBUG_CODE.
	* CMake: added option ENABLE_PROFILER.
2011/07/15
	* Changed the warning message of when setrlimit fails to be more explicit. [FlavioJS] 
	* CMake: added tests for big endian, typecast to union and monotonic clock.
	* CMake: added 'have function' tests for setrlimit, strnlen, getpid and gettid.
	* CMake: added option ENABLE_RDTSC.
2011/07/12
	* CMake: set project language to C, added module FindFunctionLibrary, added search for dl library. (tested with debian-wheezy-i386) [FlavioJS]
	* CMake: added search for math.h, added search for socket/nsl library. (tested with Solaris-201011-x86)
	* Added missing include to socket.c.
	* CMake: added search for ws2_32 library. (tested with MinGW/MSYS)
	* Added missing pcre library for MinGW.
2011/07/11
	* Rev. 14901 Added bonus3 bAddClassDropItem, care of Epoque. [L0ne_W0lf]
2011/07/10
	* Temporary fix for bugreport:4961 (unintended conversion from signed to unsigned). [FlavioJS]
	* CMake: lowered required version to 2.8.3 and moved custom cmake modules to 3rdparty/cmake.
	* Changed limit definitions used in WBUF* and WFIFO* to the intended fixed size alternatives.
	* CMake: added txt-converter targets, added warning for 64bit, added list of available targets.
2011/07/09
	* Added script command 'getmercinfo' for retrieving information about a mercenary of an online character. [Ai4rei]
	* CMake: added search for math library, made CPack existence optional, updated the search for mysqlclient and corrected misspelled variables (tested with FreeBSD-8.2-i386) [FlavioJS]
	* Removed duplicate entries for Gunslinger and Ninja in msg_athena.conf (since r5506). [Ai4rei]
2011/07/07
	* Replaced compress/uncompress inline code (encode_zip/decode_zip) with the respective zlib library calls while keeping 3rdparty calls inside common code (follow up to r14888, related r14808). [Ai4rei]
2011/07/06
	* Changed grfio.c include order and moved zlib include from the header to the source. [FlavioJS]
	* Merged decode_zip/encode_zip from eapp's grfio to replace our direct use of zlib's uncompress/compress.
	* Fixed strict-aliasing warning in mapcache's GetFloat.
	* CMake: src/common builds static libraries common_base/common_sql, that are used as dependencies by the other targets.
	* CMake: normalized variable names, added ability to create a package/installer.
2011/07/05
	* CMake: split txt and sql variants of login-server and map-server. [FlavioJS]
2011/07/04
	* Fixed 'strnlen' still causing warnings in db.c on Debian (follow up to r14855). [Ai4rei]
2011/07/03
	* Corrected npcdb_checkid to exclude border constants 400 (JT_NEW_NPC_START) and 1000 (JT_MON_BEGIN) (since r4425 and r12025, related r4537). [Ai4rei]
2011/07/02
	* Fixed minor stuff in login/char converter VS6 project files (since r14858). [Ai4rei]
	* More instancing updates. [Ai4rei]
	- Improved instance_id validity checking.
	- Fixed instance name being copied with memcpy rather than safestrncpy (since r13901).
	- Removed unused instance data field 'progress_timeoutval' (since r13901).
	* Random updates to instance system. [Ai4rei]
	- Introduced a constant for instance name length.
	- Corrected comments related to instance packets 0x2cb (ZC_MEMORIALDUNGEON_SUBSCRIPTION_INFO) and 0x2ce (ZC_MEMORIALDUNGEON_NOTIFY).
	- Moved instance finalization out of map.c into instance.c
2011/07/01
	* CMake: marked executables as different components and other miscellaneous changes. [FlavioJS]
2011/06/29
	* Added experimental support for CMake. (for now: basic build, no extras, only tested with VS10 and cygwin) [FlavioJS]
2011/06/27
	* Added common/random and 3rdparty/mt19937ar to project files, makefiles and configure script. [FlavioJS]
2011/06/26
	* Fixed a signed literal being assigned to an unsigned variable and other minor cleanups in malloc (bugreport:4765). [Ai4rei]
	* Fixed @mobinfo displaying mvp rewards with 'AegisName' although normal drops use 'Name' item db column (bugreport:4981, follow up to r6346). [Ai4rei]
	* Fixed quest index memory corruption when adding new quests (since r14039, bugreport:4982) [ultramage]
2011/06/25
	* Added Mersenne Twister MT19937 as a random number generator. [FlavioJS]
2011/06/23
	* Made chrif_save always call pc_makesavestatus. (no reason to prevent the call, and was interfering with multi map-server; fixes bugreport:1400) [FlavioJS]
2011/06/22
	* Plagiarized skills are now removed on jobchange (bugreport:4973) [ultramage]
2011/06/19
	* Fixed various sorts of issues with VS6 project files (since r6929, follow up to r14466 and r14638). [Ai4rei]
	- Debug configuration was missing and release had _DEBUG defined (indicates debug configuration).
	- Login-server (SQL) defined PACKETVER=6 (overrides mmo.h).
	- Warning Level was 2, which hides a lot of actual errors.
	- Added projects for mapcache and TXT converter.
	- Removed references unneeded/obsolete libraries/source files.
2011/06/18
	* Fixed using @refresh while having vending or buyingstore open would stuck the character (bugreport:156 , since r1307). [Ai4rei]
	* Fixed missing strlib.h include for compilers without own 'strnlen' implementation (since r14853). [Ai4rei]
2011/06/16
	* Slight speedup on most strdb operations [ultramage]
	* Fixed DBMap's db_dup_key to allocate only as much as necessary (bugreport:4969) [ultramage]
	* Fixed char-converter not being able to compile due to both char.h being included. (caused by last commit) [FlavioJS]
	* Merges from charmerge:
	- Added DBMap::exists. (r14090)
	- Added sv_parse_next, a stepped version of sv_parse (delim-separated parser). (r14100 r14104)
	- Added missing fd check to do_close. (r14145)
	- Normalized, refactored and restructured some code (in preparation for shutdown/reconnect code). (r14145 r14150)
	- Changed the char select request code to allow the char-server to reject it. (player in map-server trying to go to char select) (r14150)
	- Added shutdown support to the servers. (incomplete) (r14152)
2011/06/13
	* Fixed pet's equip would visually disappear when it's walk speed was changed while it was standing (related r14838). [Ai4rei]
2011/06/11
	* Added support for new skill usage notification packet 0x7fb (ZC_USESKILL_ACK2). [Ai4rei]
	* Fixed party invite packet 0xfe (ZC_REQ_JOIN_GROUP) using account id of the inviter rather than party id. [Ai4rei]
	- Added support for new party invite packet 0x2c6 (ZC_PARTY_JOIN_REQ), introduction date guessed.
2011/06/02
	* Fixed a crash in clif_parse_FriendsListAdd, when a player is added that is not online (bugreport:4947, since r14835). [Ai4rei]
2011/05/31
	* Fixed a typo in buyingstore_create. [Inkfish]
2011/05/30
	* Fixed script command 'warpguild' looking for an attached player even when it is not needed (bugreport:4941, since r2674, related r14840). [Ai4rei]
	- Documented special map names recognized by the command.
	* Fixed script command 'warpparty' looking for an attached player even when it is not needed (bugreport:4359, since r14311, related r2674 and r5592). [Ai4rei]
	- This also resolves an issue, where the command fails when the attached player is on a map that has noreturn or nowarpto mapflags set.
2011/05/29
	* Fixed pets' speed would not get updated to normal, after they finished running to their owner (bugreport:1304). [Ai4rei]
	* Fixed NULL pointer in status_change_timer (SC_BERSERK), when the HP subtraction causes the HP drop below 100, but does not exceed remaining HP (bugreport:1150, related r8705, r11786 and r12061). [Ai4rei]
	* Updated script commands 'npcshopitem', 'npcshopadditem' and 'npcshopdelitem' to support cashshops as well (bugreport:4928). [Ai4rei]
	* Fixed players could add themselves to their friendslist through their clones or WPE (bugreport:4909). [Ai4rei]
	* Fixed bonus 'bHPDrainValue' on left hand would work as right hand bonus, when specified with 'bonus' rather than 'bonus2' (bugreport:4939, since r6221). [Ai4rei]
2011/05/23
	* Changed enumerating defines into enumerations (related topic:264007). [Ai4rei]
	- Minor fixups on few macros.
2011/05/17
	* Fixed Super Novices could not be adopted (bugreport:4907, since r12389). [Ai4rei]
	* Improved error reporting during monster database and spawn data reading. [Ai4rei]
2011/05/15
	* Extracted calculations of the number of status points PC gets when leveling up to a function. [Gepard]
	* Removed status point calculations (duplicate) from `pc_resetstate` function. It is now handled by `pc_need_status_point`. [Gepard]
	* Merged pcdb_checkid update from renewal [14810/branches/renewal]. [Ai4rei]
2011/05/14
	* Moved bitfield 'boss' inside 'spawn_data' and 'mob_data' into the respective state struct (from r13813, follow up to r14795). [Ai4rei]
	* Some NPC event related cleaning. [Ai4rei]
	- Made event label deprecation message a warning rather than an error, as the scripts still work regardless of whether '::On' is used or not (since r6592).
	- Introduced constant EVENT_NAME_LENGTH (51) for all event name struct fields to eliminate size inconsistency across all objects (was 50 and 51).
	- Fixed event names, that are considered special attributes, were not wiped when the value was 0 (since r5707).
	* Removed impossible condition in mob_parse_dataset as spawn_data::eventname was/is the same size as mob_data::npc_event (since r5707). [Ai4rei]
	* Fixed map-server printing deprecation message, when monster event label was used as transport for special attributes (small/large monsters etc.) in script command 'monster' and related commands (bugreport:1274, since r6592, related r5707). [Ai4rei]
2011/05/13
	* Random accumulated bits and pieces. [Ai4rei]
	- Added checks/warnings to pc_paycash and pc_getcash (follow up to r12264).
	- Added missing packet_db.txt and packet length table entries for packet 0x0859 (follow up to r14799).
	- Added set of map_id2xx wrappers for map_id2bl for most common map objects, which return NULL when the bl-type is not the expected one (also updated map_id2nd to behave this way).
	- Fixed missing ',' in mob_skill_db.txt example (follow up to r14270).
	- Updated mapcache with recent maps (up to que_lhz).
	- Functions 'msg_txt' and 'job_name' now return a const pointer.
2011/05/08
	* Script command 'query_logsql' now throws a warning when SQL logs are disabled (related r11892). [Ai4rei]
	* Updated/revised description of instance-related script commands (bugreport:4880). [Ai4rei]
	- Fixed 'instance_create' would return -4 (party already instancing) when the requested party was not found.
	- 'instance_create' return value -2 now means 'party not found' rather than 'missing parameter'.
2011/05/01
	* Removed functions 'decode_zip' (ancient) and 'encode_zip' (from r824) from grfio. These were outdated copies of zlib's 'uncompress' and 'compress' respectively (related r1530 and r5152). [Ai4rei]
	* Removed auto-add feature from mapindex code, as map indexes are used for save data, thus need to be constant across server starts (since r4726). [Ai4rei]
2011/04/28
	* Fixed @makehomun not checking for existing homunculus properly and thus allowing to create a homunculus when one is already present but inactive (bugreport:4879, since r10272). [Ai4rei]
	* Updated packet 0x163 (ZC_BAN_LIST) to reflect change in packet layout introduced with 2010-08-03aRagexeRE (bugreport:4881, follow up to r14718). [Ai4rei]
	* Fixed formatted broadcast messages not working with 2010-11-24aRagexeRE and later (bugreport:4872, since r14120). [Ai4rei]
2011/04/27
	* Fixed description for script command 'itemheal' claiming, that this command is responsible for potion visual effects which it is not (item-use causes the client to display these) (since r2397). [Ai4rei]
2011/04/21
	* Extended debugging code for bugreport:3504 (related r14599). [Ai4rei]
2011/04/20
	* Fixed quest_check checking exactly 3 quest objectives instead of MAX_QUEST_OBJECTIVES (since r13959). [Gepard]
2011/04/17
	* Updated packet for the view players' equip feature for 2010-11-24aRagexeRE+ and made it support robes (follow up to r14797). [Ai4rei]
	- Fixed spawn/walking packets using wrong variable for shifting buffer reference (since r14797).
	* Fixed char-server missing some WFIFOHEAD (partially due to r10909 being reverted by r11245, follow up to r9307 and r14618). [Ai4rei]
2011/04/16
	* Added support for visible garments/robes. [Ai4rei]
	- For SQL apply upgrade_svn14797.sql to upgrade table `char`; for TXT no action is necessary, as it upgrades itself.
	- This also fixes NPCs not being visible with clients 2011-01-11aRagexeRE+ (bugreport:4865).
	* Updated field `weapon` in table `char` to default to '0' (bare-handed) rather than '1' (knife) (follow up to r11696). [Ai4rei]
	- Apply upgrade_svn14796.sql to reflect the change on existing setups.
	* Some cleanups related to player and monster states. [Ai4rei]
	- Moved user_font and bg_id out of states as they are data, not states.
	- Reordered members of state structs so that bitfields are packed together (less memory gets wasted).
	- Other insignificant code tweaks.
2011/04/13
	* Added missing 0x369 packet.(info provided by Yommy) [Inkfish]
2011/04/10
	* Added support for clients 2010-11-23aRagexeRE+ and 2011-01-11aRagexeRE+. [Ai4rei]
	- Servers that used packet db version 'default' until now need to be updated to use version '25'.
	* Fixed switching between musical weapons would cancel ongoing dance skills (bugreport:4756, since r3538). [Ai4rei]
	* Fixed @changegm not updating guild window interface after changing the guild leader (bugreport:408, since r2622, related r3185). [Ai4rei]
2011/04/09
	* Moved duel code into a separate file. [Ai4rei]
	* Added *.opt (VS6 workspace cache file) to svn:ignore. [Ai4rei]
	* Changed pc_jobid2mapid to use a 1:1 mapping which is less prone to errors and faster than the previous method (follow up to r14755). [Ai4rei]
2011/04/08
	* Fixed memory corruption when amount of players online approached FD_SETSIZE (topic:262388, bugreport:4856, since 11897). [Ai4rei]
	* Fixed a compile error when socket send shortlists are disabled (s->eof instead of s->flag.eof) (follow up to r11930). [Ai4rei]
2011/04/07
	* Fixed monster skill associated emotions were always ignored when having less than three digits ( = all ) (bugreport:4842). [Ai4rei]
	* Throwing around with packet updates. [Ai4rei]
	- Clarified the description for role-change chatroom packets 0xe0 (CZ_REQ_ROLE_CHANGE) and 0xe1 (ZC_ROLE_CHANGE).
	- Fixed auction window opening packet 0x25f (ZC_AUCTION_WINDOWS) had also a close button packet attached (since r12270).
	- Fixed auction search results packet 0x252 (ZC_AUCTION_ITEM_REQ_SEARCH) obtaining only a WFIFO buffer of 20 bytes, regardless of the amount of results (since r12301).
	- Fixed auction search result item type was .W instead of .L, which also eliminates the unknown field after it (since r12301).
	- Fixed an odd packet in clif_Auction_close, which is supposed to have layout of 0x25e, while using 0x25d as packet type (since r12323).
	- Resolved unconfirmed fields in clif_party_show_picker (follow up to r13987).
	- Updated packet layouts for auction in packet_db.
2011/04/06
	* Resolved some pc_setparam issues. [Ai4rei]
	- Fixed HP/MaxHP/SP/MaxSP could be set to arbitrary values, thus disregarding configuration limits and causing client crashes on certain conditions (bugreport:4177).
	- Fixed HP/SP not getting adjusted to MaxHP/MaxSP respectively, when the max. value is reduced below the value of the cur. value.
	- Fixed STR/AGI/VIT/INT/DEX/LUK values could be set beyond character's max. stat limit.
	- Fixed Gender not being limited to male/female.
	* Fixed script command 'warpwaitingpc' not checking, whether or not the player still has required amount of Zeny (since r14765). [Ai4rei]
	- Fixed warping through 'warpwaitingpc' to savepoint would take the fee twice ( missing {} ).
	- Fixed random warping through 'warpwaitingpc' would not take away fee Zeny at all.
	* STABLE IS NOW THE OLD TRUNK. THE NEW TRUNK IS NOW FOR BLEEDING-EDGE AND/OR UNTESTED CHANGES. [Paradox924X]
2011/04/05
	* Moved detection of monotonic clock support to the configure script, which also checks, whether or not it actually works (bugreport:1003, related r11912 and r11983). [Ai4rei]
	* Paying and obtaining Zeny (pc_payzeny/pc_getzeny) no longer silently reverses the effect for negative amounts, that is, getting Zeny instead of paying up and vice versa (since r8273, related r8072). [Ai4rei]
2011/03/29
	* Added TargetName values to VS2010 project files to prevent MSB8012 warnings (follow-up to r14562). [Gepard]
2011/03/28
	* Prevented SC_EXPBOOST, SC_JEXPBOOST and SC_ITEMBOOST (used by Battle Manuals and Bubble Gum) from being dispelled by Gospel. (bugreport:4836) [Paradox924X]
2011/03/27
	* Added separate character state for vending (like for buyingstore), instead of vender_id != 0 (follow up to r14682, related r14713). [Ai4rei]
	* Added support for tracking state of client command /effect through packet 0x21d (CZ_LESSEFFECT). [Ai4rei]
2011/03/25
	* Fixed battlegrounds chat packet 0x2dc (ZC_BATTLEFIELD_CHAT) being sent with the battleground id rather than the account id of the talking player (since r13593). [Ai4rei]
2011/03/22
	* Documentation updates and fixes. [Ai4rei]
	- Added documentation for script commands 'bg_getareausers' and 'bg_get_data' (bugreport:3034).
	- Fixed documentation for script command 'waitingroom2bg_single' (bugreport:4770, since r14373).
	- Documented optional parameter 'npc name' for script command 'waitingroom2bg'.
	* Fixed possible client crash when monster is class-changing to mob_avail'd one. [Gepard]
2011/03/20
	* Random accumulated tweaks and fixes. [Ai4rei]
	- Added a error message to npc_enable, to spot disablenpc/enablenpc/hideoffnpc/hideonnpc on non-existing NPCs (related r14750).
	- Replaced inlined npc_name2id code with calls to npc_name2id.
	- Open Buying Store skill is now exempted from noskill mapflag like Vending as well (bugreport:4815, follow up to r14713).
	- Fixed signed constant being returned as unsigned value in get_percentage (bugreport:4765, since r12679).
	- Replaced strlen checks, which checked whether or not a string is empty, with first-byte checks.
	- Fixed enabling 'fakename' not clearing party and guild name and cleaned up atcommand 'fakename' code.
	- Cleaned up party/guild name code in clif_charnameack (follow up to r14737).
	* Fixed battleground kvm02 and kvm03 scripts referring to NPCs in the custom battleground kvm (bugreport:4812, since r14369). [Ai4rei]
	- Fixed kvm02 printing different amount of points, than it actually gives.
	* Updates the to configure script. [Ai4rei]
	- Added check, whether or not '-Wno-pointer-sign' can actually be used (caused warnings with g++).
	- Math library is no longer considered required, when math functions are available without it (made configure fail on platforms, where no separate math library is present).
2011/03/19
	* Removed leftovers of old charcommand config (follow-up to r13403). [Gepard]
	* Added check to ensure character `rename` status will be saved if changed. [Gepard]
	* Fixed Beast Strafing (HT_POWER) damage formula provided by Playtester (bugreport:4675, since r4392). [Gepard]
2011/03/15
	* Fixed pet database reading displaying wrong amount of read entries per file (bugreport:4797). [Ai4rei]
	* Fixed canceling item appraisal window (Magnifier and Identify) would prevent players from using any follow up skills (bugreport:4809, since r14545). [Ai4rei]
	* Fixed monsters getting warped when stepping on an NPC warp when at least one of the bits of setting 'mob_warp' was set (bugreport:4766, since r12757). [Ai4rei]
2011/03/14
	* Fixed a typo in npc_touchnext_areanpc (NPC's map being used as it's x-coordinate), which caused ::OnTouch_ invokation to affect different area than intended (bugreport:4814, since r14097). [Ai4rei]
2011/03/13
	* Script commands documentation updates. [Ai4rei]
	- Added missing description for script command 'cooking' provided by Masao (bugreport:3372, follow up to r13628).
	- Fixed wrong item levels being listed in the description to script command 'produce'.
2011/03/08
	* Fixed @item2 and script command 'getitem2' not taking MAX_REFINE define into consideration (bugreport:4804). [Ai4rei]
	* Fixed @str/@agi/@vit/@int/@dex/@luk commands setting a stat to 0 (rather than 1), when exact amount is subtracted (bugreport:4803, since r14493). [Ai4rei]
2011/03/07
	* Cleaned up packet dumping code. [Ai4rei]
	- Replaced utils function 'dump' with 'WriteDump' (files) and 'ShowDump' (console), and used those to replace inlined code in clif (related r10947).
	- Fixed clif_parse_debug not printing anything, when it is used with a variable length packet.
	- Added ability to dump invalid packets through define DUMP_INVALID_PACKET (clif.c).
	- Removed code to dump all incoming packets, as that can be achieved with the DUMP_UNKNOWN_PACKET code as well when needed (from r1009).
2011/03/06
	* Implemented search store info system (aka. vending and buying store search) together with related items. [Ai4rei]
	- Requires 2010-08-03aRagexeRE or later and can be disabled in 'conf/battle/feature.conf'.
2011/03/05
	* Fixed possible crash in script_reportdata, when a script string becomes NULL for whatever reason. [Ai4rei]
2011/03/04
	* Fixed recursive map_quit invocation when a buying store is auto-closed (login when @autotrade/logout) (bugreport:4796, since r14724). [Ai4rei]
2011/03/02
	* Updates to the super novice's guardian angel prayer effect and related handling code. [Ai4rei]
	- Removed the server-side chat tracking code (since r492) responsible for invoking the effect, since this functionality is handled by the client (invocation also processed by the server). This also fixes the missing 7 lines requirement on the server-side handling (bugreport:4786).
	- Updated the checks in the client-invoked code part and documented the packet.
	- Now only the prayer in client-side data\msgstringtable.txt (lines 791~794) applies.
	- The prayer is no longer blocked by noskill-restrictions.
	- Exp at 0% and 100% no longer causes the effect to trigger.
	- Fixed the exp percent check to also check one digit after the decimal point (requirement is 10.0% not 10%).
2011/03/01
	* Fixed packet 0x839 (new guild member expel notification) was expected on clients 2010-06-08aRagexeRE~2010-07-30aRagexeRE, although those do not implement it (bugreport:4789, since r14718, related r14368). [Ai4rei]
2011/02/26
	* Reduced MAX_GUILD_STORAGE from 1000 to 600 (like MAX_STORAGE), since storage with 1000 items causes too large packets that are dropped then, which in turn gives the impression that the items are lost (follow up to r14503). [Ai4rei]
	- Note: When updating an existing server, keep in mind that excess items in guild storage get lost, when MAX_GUILD_STORAGE is reduced.
2011/02/23
	* Updates to various custom stuff that buying stores might/are expected to support (follow up to r14713). [Ai4rei]
	- Buying store no longer works on novending maps/cells (bugreport:4778).
	- MANNER_NOROOM mute flag now affects buying stores as well (like vending).
	- Enabled @autotrade for buying stores.
	* Fixed whispering to NPCs (::OnWhisperGlobal) not working for NPCs whose unique name is different from the display name (bugreport:4776, since r2624). [Ai4rei]
2011/02/20
	* Fixed SP regen not stopping when Maximize Power (BS_MAXIMIZE) is in effect. [Ai4rei]
	* Fixed missing </File> end-tag in VC8 map-server sql project file (since r14713). [Ai4rei]
2011/02/19
	* Updated guild expel notification packet 0x15c (ZC_ACK_BAN_GUILD) for clients 2010-06-08aRagexeRE and newer to 0x839. [Ai4rei]
	* Removed '.txt' from log config info messages, as the values already have an extension (since r197, related r196). [Ai4rei]
	* Fixed gcc compile warnings in char-server and console plug-in (bugreport:4771, topic:208746, since r9631 and r14700). [Ai4rei]
	* Fixed buying stores could be opened and sold to regardless of distance between seller and buyer (since r14713). [Ai4rei]
	* Fixed 'feature.conf' not getting loaded and a typo buying store feature setting name (follow up to r14713). [Ai4rei]
	* Implemented buying store system (aka. reverse vending, purchase shop) together with related skill and items, without NPCs. [Ai4rei]
	- For SQL apply upgrade_svn14713_log.sql to upgrade tables `picklog` and `zenylog`; for TXT no action is necessary.
	- Requires 2010-04-20aRagexeRE or later and can be disabled in 'conf/battle/feature.conf'.
2011/02/17
	* Merged enumeration update from renewal [14699/branches/renewal] for a future commit. [Ai4rei]
2011/02/16
	* Updated configure/make scripts to resolve various issues. [Ai4rei]
	- Added detection whether or not -fPIC switch is required when compiling shared objects (plug-ins) to resolve compile issues on 64-bit platforms (topic:208746).
	- Native 'strnlen' implementations are now detected and disable the one in strlib (bugreport:1261).
	- Define 'DB_MANUAL_CAST_TO_UNION' is now set when necessary (bugreport:1261).
2011/02/15
	* Added support for client GM command /check (related r12076). [Ai4rei]
2011/02/14
	* Fixed drop list of map flag 'pvp_nightmaredrop' not getting cleared upon @reloadscript (bugreport:4282, follow up to r14668). [Ai4rei]
	* Fixed GMs with GM level equal to 'lowest_gm_level' being treated as normal players in 'gm_can_party' check (bugreport:4162, since r13143). [Ai4rei]
	* Fixed a crash when script 'npctalk' is given too long string (bugreport:4759, related r2145). [Ai4rei]
	- Fixed related buffer overflows in message related clif functions (since r1182, r14270).
2011/02/09
	* Fixed script command 'bpet' (Pet Incubator) displaying an empty egg list when attempting to hatch a pet while already having one out (bugreport:3313). [Ai4rei]
2011/02/08
	* Moved script constant manipulation code into separate functions script_get_constant / script_set_constant. [Ai4rei]
	- Added protection against overwriting existing names in script constant creation code.
2011/02/07
	* Added support for new delayed character deletion. [Ai4rei]
	- Asks for birth date associated with the account and has a waiting time of 24 hours by default (setting).
	- For SQL apply upgrade_svn14700.sql to upgrade table `char`; for TXT no action is necessary, as it upgrades itself.
	- This completes support for clients 2010-08-03aRagexeRE and later.
	* Updated login sql engine version, missed during `birthdate` addition (follow up to r14672).
	* Updates to various client packets. [Ai4rei]
	- Renamed clif_set0199 and clif_send0199 to clif_map_property and clif_map_property_mapall respectively and added an enumeration for currently known map properties.
	- Renamed clif_set01D6 to clif_map_type and added an enumeration for currently known map types.
	- Resolved undocumented field of packet 0x22e (ZC_PROPERTY_HOMUN) to attack range.
	- Fixed aspd field of packet 0xbd (ZC_STATUS) getting filled with karma value.
	- Removed commented clif_skillinfo (duplicate of clif_item_skill).
	- Other minor comment updates and 'FIXME' assignments.
2011/02/06
	* Replaced 'nameid < 500' checks in script commands 'countitem', 'countitem2' and 'autoequip' with stricter ones. [Ai4rei]
	- This should stop meaningless itemdb_search warnings from said commands when an invalid item id is used.
2011/02/05
	* Fixed NPCs with closing parenthesis in their name could not be duplicated (bugreport:3235). [Ai4rei]
	* Fixed closing 'switch' curly not causing script EOL processing to trigger, leading to the script line after the switch being handled as belonging to the curly-less statement block (bugreport:3273, since r3422). [Ai4rei]
	* Removed unnecessary getlogincount.pl, mapcheck.sh and mapchecker.sh tools (topic:262934). [Ai4rei]
2011/02/02
	* Fixed non-windows 'findfile' utils function missing a 'closedir' call (bugreport:4739, since r1629). [Ai4rei]
2011/01/31
	* Inventory and Cart item arrays are no longer getting compacted on each log-in/teleport/warp. [Ai4rei]
	- This also resolves yet another issue caused by r14685 (bugreport:2604).
	* Various accumulated cleanups and fixes. [Ai4rei]
	- Improved the compile speed for files which include common/socket.h on windows builds (related r10471).
	- Moved FIFOSIZE_SERVERLINK define from common/mmo.h to common/socket.h (since it is a server connection FIFO size setting).
	- Fixed script command 'areamobuseskill' canceling monster's skill cast before it determined it's new target, which could be 'none' (bugreport:3272, since r13897).
	- Added a protection against attempts to read an empty backup / write to a full backup in skill_dance_switch as per TODO from r11347.
	* Fixed faulty WFIFO reallocation causing memory exhaustion (bugreport:4737, since r1816, related r11503, r11571, r11886 and r12232). [Ai4rei]
2011/01/30
	* Fixed equipped items' bonus no longer working after log-in until next status recalc, due to missing pc_setequipindex which was previously called by pc_checkitem (bugreport:2604, since r14685). [Ai4rei]
2011/01/29
	* Removed @aw/@away which duplicates and collides with client's /am (away message) (bugreport:1235, topic:163083, since r4351). [Ai4rei]
	* Fixed a map-server crash when invalid items are deleted (option 'item_check') from a logging-in character (bugreport:2604). [Ai4rei]
	- This removes the pc_checkitem call from pc_authok, as the check is done in clif_parse_LoadEndAck as well, after first status calc has taken place.
	- Inventory list is now sent before pc_checkitem in clif_parse_LoadEndAck, so that deleted items do not show up as 'unknown item'.
2011/01/27
	* Fixed @accept not checking, whether or not a duel is already full (bugreport:2740, since r4111). [Ai4rei]
	* Resolving allow/deny IP rules not working (bugreport:2632). [Ai4rei]
	- Fixed 'mask' being filled with 'ip' when standard mask was specified (since r9647).
	- Fixed 'ip' and 'mask' (bit mask) being stored in wrong byte order (network order instead of host order) (since r10162).
2011/01/26
	* Fixed buyers, that are currently in a vending shop could be fooled into buying an item at different price than they see by reopening the vending shop (bugreport:4728). [Ai4rei]
	- This implements the official vending shop unique id handling (previously mistaken for char id), made compatible with packets before it's introduction (follow up to r14234).
2011/01/24
	* Added documentation for undocumented bonuses (bugreport:4727, follow up to r302, r354, r485, r699, r928, r1116, r6221, r7982, r10031, r13596 and r14018). [Ai4rei]
2011/01/23
	* Some cleaning here and there. [Ai4rei]
	- Fixed a typo in basejob_baseclass_upper sample script (since r3893).
	- Fixed (for sake of consistency) usage of 'sd' before corresponding nullpo check in party_invite (bugreport:2752).
	- Fixed atcommand config reading would not cap level for charcommands, when using atcommand level as fallback (bugreport:2961, since r13409).
	- Removed orphaned clif_mob_hp declaration from clif.h (bugreport:2788, since r2092).
	- Removed unnecessary look-up in itemdb_available macro, as dummy_item is considered unavailable.
	- Removed leftover shortlist linked-list struct (followup to r10507).
2011/01/19
	* Fixed solo dance/star gladiator warm AoE no longer following the owner and cloaking wall rules no longer working (bugreport:4720, since r14671). [Ai4rei]
2011/01/16
	* Fixed a map-server crash, when a script attempts to call a local function, which has only a forward declaration. Such functions now count as script parse error (bugreport:4009, since r3422). [Ai4rei]
	* Fixed definitions of local functions would set a label reference, even when their name was already taken (follow up to r14600, since r3422).
2011/01/15
	* Various accumulated insignificant fixes to documentation, examples and comments. [Ai4rei]
2011/01/14
	* Added 'birthdate' field to account data. For SQL apply upgrade_svn14672.sql to upgrade table `login`; for TXT no action is necessary, as it upgrades itself. [Ai4rei]
	- Control panel developers are encouraged to enable players to modify this value, as it is required for new character deletion (2010-08-03aRagexeRE and later, not yet implemented).
	* Removed unconditional redundant status change checks before status_change_end calls (follow up to r12890). [Ai4rei]
	* Replaced remaining occurences of '-1' with 'INVALID_TIMER', where appropriate (follow up to r12998). [Ai4rei]
	* Removed 'gui' plug-in (support plug-in for 3rd party eAthena GUI front-ends) (topic:262934). [Ai4rei]
2011/01/13
	* Fixed mapflags 'restricted', 'nocommand', 'bexp' and 'jexp' still not getting completely initialized upon @reloadscript (bugreport:4710, follow up to r14548). [Ai4rei]
	* Removed ladmin (remote administration tool), all related support code and the checkversion.pl tool with it's support code, which was shared with ladmin (topic:262934, related bugreport:1147, bugreport:1889, r9408 and r9610). [Ai4rei]
	* Fixed chrif-packet processing considering free/unused packet IDs incorrectly as variable length packets (-1 = variable length, 0 = disabled packet). [Ai4rei]
	* Added support for creating account through the console-plugin on login-server (replaces ladmin functionality unavailable through atcommands). [Ai4rei]
	* Reformatting and minor cleanups to console-plugin related code. [Ai4rei]
2011/01/10
	* Fixed script command 'cleararray' setting 1 element more, than it is told to (bugreport:2047, since r12253). [Ai4rei]
	- Fixed 'inaccessible element 127' issue in 'cleararray', 'setarray' (since r10813) and 'copyarray' (since r14608) script commands (bugreport:864, related r12253, follow up to r14608).
	* Fixed monster level not getting updated in monster name (option 'show_mob_info'), when a monster levels up (option 'mobs_level_up') (follow up to r8644, related r187). [Ai4rei]
	* Made script command 'charisalpha' always return 1 when 'isaplha' is true, rather than to return the return value of 'isalpha' which is only defined as zero/non-zero and can be different from 1 (bugreport:2024, related r2003). [Ai4rei]
2011/01/09
	* Fixed packet_len entry for packet 0x289 (ZC_PC_CASH_POINT_UPDATE) not matching the actual size used in clif_cashshop_ack (bugreport:4701, since r14639, follow up to r12264). [Ai4rei]
2011/01/08
	* Fixed script command 'progressbar' resuming fails on second invocation, when there was no script pause between the first and second call (bugreport:4698, since r14024). [Ai4rei]
	* Fixed kill steal protection result in skill casting (unit_skilluse_id2) not getting evaluated (bugreport:1808, since r12203). [Ai4rei]
	- Moved kill steal protection in skill casting to be only executed, after the actual target has been determined and validated (since r12203).
	* Applied fix provided by Valaris to make /pvpinfo actually work. (bugreport:1785, since r1602). [Ai4rei]
	- Filled-in missing packet fields and documented the packet. Note, that this command does not show anything outside of PvP maps (client-side limitation).
	* Fixed @homlevel usage message stating, that deleveling is possible, although it is not (bugreport:1485, since r10272). [Ai4rei]
	- The command now fails, if it is given a zero or negative value.
2011/01/07
	* Fixed @alootid using 'autolootitem' (internal name) in it's usage message (bugreport:1445, since r12203). [Ai4rei]
2011/01/06
	* Fixed script command 'deletearray' deleting incorrect amount of array elements from arrays with empty elements (bugreport:4628). [Ai4rei]
2011/01/05
	* Fixed ends of statement blocks missing script EOL processing, thus causing 'next line' label (-) to misbehave in statement blocks without additional curly braces (bugreport:4417, since r3422). [Ai4rei]
2011/01/04
	* Added support for removal of trailing comments to sv_readdb (bugreport:4680). [Ai4rei]
2011/01/01
	* Fixed local files could not be aliased with resnametable.txt in grfio (bugreport:2203, since r5152). [Ai4rei]
	* Cleanups to grfio. [Ai4rei]
	- Replaced strncpy with safestrncpy (bugreport:3080).
	- Ensured, that all local paths are normalized and work whether or not the data dir ends with '/'.
	- Local files are no longer added to the GRF+alias file list (apparently served to cache file size, with no performance gain).
	- Buffer for files is no longer allocated with 1024 extra bytes, but only 1 for zero-termination of text files.
	* Updates to map cache generator tool. [Ai4rei]
	- Removed unmaintained grfio library copy and made the tool use the one in /common instead (related r12726).
	- Updated makefile to use compile options/libraries determined by configure (bugreport:1109).
	- Fixed error messages from the tool and grfio library overlapping each other (bugreport:2403).
2010/12/31
	* Pending trade requests no longer prevent a character from trading someone else instead (official). [Ai4rei]
	- This fixes trade window displaying wrong name when attempting to deal multiple characters (bugreport:344).
2010/12/30
	* Fixed improper use of itemdb_search. It does not return NULL but a dummy item, if the item id is invalid. [Ai4rei]
2010/12/29
	* Made remaining csv databases (guild, castle, homunculus, itemdb, mercenary) use sv_readdb, where applicable (follow up to r14524, r14526 and r14532). [Ai4rei]
	- Few databases remain unchanged, which have either a custom layout or are otherwise incompatible with sv_readdb.
	* Collection of random insignificant changes. [Ai4rei]
	- Added progress indication on map-server shutdown when objects are removed from maps, as it takes significant amount of time to complete.
	- Moved ers_free in db_obj_vclear, so that the node pointer is not used for comparison after it has been freed.
	- Some documentation of shop packets.
	* Fixed 'console' plugin not working on Windows, due to NULL passed to CreateThread instead of required pointer to thread id variable. [Ai4rei]
	- Fixed 'console' plugin causing delete_timer error when it fails to load, due to uninitialized variable.
	* Renamed plugin.def to sample.def and added 'sample' plugin exports into it, as it's purpose is nothing than a sample right now.
	- Also added .def files for 'gui' and 'pid' plugins as MSVC does not export everything automatically and missing event export cause the plugins silently failing.
	- Added VS6, VS8 and VS9 projects for compiling plug-ins, which can be used on Windows.
	* The plug-in system will now report, if it cannot import an event function.
2010/12/28
	* Fixed char-server making assumptions about RFIFO data length in character deletion packet (since r10909). [Ai4rei]
	* Fixed login-server discarding RFIFO data, when the length is 1 byte; minimum packet size is 2 bytes (since r5027).
	- Fixed login-server not skipping packet 0x2728's data on failure (since r12043).
	* Removed unmaintained and broken 'adduser' tool (topic:262284). [Ai4rei]
2010/12/27
	* Fixed skill_can_produce_mix not checking, whether or not the produced goods can actually be stored (bugreport:4674). [Ai4rei]
2010/12/26
	* Reverted r14565, as the database version is already properly commented in source and is overwritten upon first sync of account.txt anyway. [Ai4rei]
	* Cleaned up script command checkweight. [Ai4rei]
	- Replaced some code parts with calls to pc_checkadditem and pc_inventoryblank (follow up to r13735).
	- Fixed item id not getting checked for validity properly.
	* Moved MAX_AMOUNT check in pc_checkadditem to the top of the function, to prevent unnecessary inventory scan before it.
	* Fixed opening other player's vending terminating currently running NPC conversation. Vending is now unavailable when talking to an NPC (bugreport:2208). [Ai4rei]
	* Fixed vending not accepting 0 Zeny as sell price. The client asks for confirmation when you attempt to sell items at 0 Zeny (bugreport:2595, since r918 and r11344).
	* Fixed items, that get dropped at 100% chance, being reported in @iteminfo as 'available in the shops only' (since/replaces r3482). [Ai4rei]
	* Updated commands @delitem/#delitem. [Ai4rei]
	- No longer deletes stackable items one by one (bugreport:1914).
	- Fixed pets not getting deleted when a pet egg was deleted.
	- Fixed outdated usage message (since r13403).
2010/12/25
	* Fixed two-hand weapons not getting recognized as such upon equipping, causing respective one-hand weapon's base ASPD values being used instead (bugreport:4659, related r12599). [Ai4rei]
	* Updated script commands delitem and delitem2. [Ai4rei]
	- Items are now deleted only if there is enough of them (as per r14395, related r13368).
	- Not equipped items are now actually prioritized over equipped ones (related r200).
	- Fixed item id not getting checked for validity.
	* Fixed a compile error in txt-converter-char caused by 'save_log' being declared by both SQL and TXT (bugreport:4671, since r14619). [Ai4rei]
	* Made SQL char-server options 'chars_per_account' and 'char_del_level' work on TXT as well (follow up to r1063 and r8420). [Ai4rei]
2010/12/24
	* Added support for new /remove and /recall packets for 2010-08-03aRagexeRE and newer. [Ai4rei]
	* Synchronized TXT/SQL char-server code a bit. [Ai4rei]
	* Fixes to char-server. [Ai4rei]
	- Removed unnecessary #includes from TXT and synchronized them with SQL.
	- Fixed TXT having start Zeny of 500 instead of 0 by default (follow up to r4409 and r8420).
	- Fixed TXT using 1024 instead of NAME_LENGTH for 'unknown_char_name' (follow up to r2191).
	- Fixed SQL potentionally attempting to disconnect a player for account_id == 0 in changesex packet.
	- Fixed SQL looking for option 'db_path' in 'inter_athena.conf' instead of 'char_athena.conf'.
	- Fixed char select not sending a reply packet, when selected character was not found.
	- Made use of safestrncpy instead of strcpy, strncpy and memset for copying strings where appropriate.
	- Removed unused function 'chardb_final' in TXT (since r4878).
	- Removed unnecessary WFIFOHEAD in char deletion in SQL (since r11245, related r9307 and r10909).
2010/12/23
	* Fixed server processing the sell list (deleting items and giving zeny) for script-controlled shops (OnSellItem), causing the controller script to fail (bugreport:4656, since r6557). [Ai4rei]
	- This also makes the server first check the sell list and only continue, if all items can be processed, thus no longer causing incomplete deals and the need for client disconnection in such case (since r6557).
2010/12/22
	* NPC shop buy list received from the client is now validated for scripted shops (OnBuyItem), before the control is transfered to the script, as well (bugreport:3680, since r5841, related r8525). [Ai4rei]
	* Resolved random compiler warnings. [Ai4rei]
	- Silenced pointer size mismatch gcc warning for variables passed to script_setarray_pc (bugreport:4661, since r14613).
	* Fixed sql mapreg loading code specifying output buffer size for SqlStmt_BindColumn without zero-terminator, leading to truncations of variable names and/or their values when using the maximum length (bugreport:1939, since r11245). [Ai4rei]
2010/12/21
	* Added script_setarray_pc for setting temporary character array variables outside of script.c without requiring them to use script-interal code (add_str and reference_uid). [Ai4rei]
	- Applied script_setarray_pc to assignment of dynamic shop arrays (related r5841).
	* Replaced in-place generation of uid of script array elements with reference_uid macro (follow up to r10813). [Ai4rei]
	* Fixed dynamic shop arrays @bought_nameid, @bought_quantity, @sold_nameid and @sold_quantity not getting reset to zero before use, thus providing attached script with wrong/old data, if it did not clear them by itself in previous call (bugreport:1574, since r5841). [Ai4rei]
	* Removed 'strsignal' forward-declaration from 'sig' plugin to prevent random gcc distributions from failing to compile due to mismatched declaration already present in <string.h> (bugreport:4644, topic:262284, follow up to r14591). [Ai4rei]
	- Removed WIN32 conditions in non-WIN32 code in 'sig' plugin (follow up to r4380).
2010/12/19
	* Fixes to the dynamic shop sample script. [Ai4rei]
	- Fixed wrong check in ::OnSellItem, causing not-enough-items condition not getting detected (since r11829).
	- Fixed an exploit in ::OnSellItem, causing Zeny to be given to the player, even if the items fail to delete (since r5842).
	- Fixed missing 'close' in ::OnSellItem (since r5842).
	- Replaced 'end' with 'close' in ::OnBuyItem (since r5842, followup to r11829).
	* Replaced maximum script array size literals with a define (constant). [Ai4rei]
	- Fixed an off-by-one mistake in copyarray, allowing to copy 1 element more into the target array, than allowed (since r10813).
2010/12/18
	* Renamed item array in 'struct guild_storage' from 'storage_' to 'items' to match 'struct storage_data' (related r12933). [Ai4rei]
	* Bunch of intif_parse_LoadGuildStorage fixes. [Ai4rei]
	- Fixed guild storage not being sorted, when the storage had to be requested first (follow up to r14605).
	- Fixed missing check, whether or not the character has already an open storage (follow up to r4562).
	- Fixed missing GM trust check, whether or not the player is allowed to use guild storage (follow up to r3481).
	* Fixed character storage no longer being sorted (bugreport:1982, since r12950). [Ai4rei]
	- Guild storage is now sorted before being displayed rather than after being saved...
	- Merged storage_gsortitem into storage_sortitem.
	- Added option 'client_sort_storage' to control storage sorting (disabled by default, like on official servers).
	* Updates to handling of hair color/style and cloth color of characters. [Ai4rei]
	- Moved limit shortcut defines from mmo.h to battle.h, as they are only required in files, which include battle.h (since pre-svn 2004/10/15).
	- Moved hair style/color validation from char-server to map-server. This enables use of non-default limits as specified in battle config, rather than being restricted to hard-coded ones (bugreport:150).
	- Cleaned up related capping of values in pc_changelook (related r1708).
	* Fixed usage of literals for map name length in character list packet (since r14368). [Ai4rei]
2010/12/17
	* Made the 'player not attached' script error also report the function it occured in, if available. [Ai4rei]
	* Fixed a crash, when script command 'doevent' is called without an attached player (bugreport:3973). [Ai4rei]
	* Fixed label definitions silently overwriting built-in script functions (bugreport:2806, follow up to r8027). [Ai4rei]
	* Added temporary check to skill_delunitgroup to prevent crashes when 'group' is NULL and added some debug messages to track down the source of the crash (bugreport:3504). [Ai4rei]
	* Spellchecked script_commands.txt. [Ai4rei]
	* Random script engine clean-ups that have accumulated over time. [Ai4rei]
	- Resolved unnecessary script_getnum re-evaluation in a loop in script command 'npcshopdelitem' (since r7120).
	- Script commands 'menu', 'select' and 'prompt' now warn, when there are more menu options, than the client can handle correctly (TODO from r10316).
2010/12/16
	* Reverted r14525 (introduction of SV_READDB_MAX_FIELDS) because it causes confusion to certain group of users and depends on MAX_LEVEL since r14526. [Ai4rei]
	- Made sv_readdb be able to process any amount of columns instead.
	* Fixed a mistake in sv_split, causing CR being recognized as EOL character, even when only LF was specified (since r12459). [Ai4rei]
2010/12/15
	* Corrected type of second argument of script command 'setbattleflag' from string to number (bugreport:4640, topic:261833, since r5407, related r14577). [Ai4rei]
	* Fixed missing check in cooking, causing cooking kit requirement could be bypassed by sending 0x25b (CZ_REQ_MAKINGITEM) directly (bugreport:4642, since r13628). [Ai4rei]
2010/12/13
	* Fixed plugin 'sig' not being compilable on Mac OS X, due to different return value type of 'strsignal' (bugreport:4637). [Ai4rei]
2010/12/12
	* Fixed homunculus_autoloot not working with skill/item granted drops and loot (bugreport:4452, since r12203). [Ai4rei]
	* Fixed killed monsters were assumed to be killed by homunculus only, if no damage log entries were elligible for exp distribution, even when no homunculus took part in damage dealing (bugreport:4452, since r12203). [Ai4rei]
	* Added enumeration for monster damage log field 'flag'. [Ai4rei]
	* Removed disabled backup of script command 'isequipped' (since r1605). [Ai4rei]
	* Made script engine's DEBUG_DISASM block use script_op2name, rather than hardcoding operator names as per TODO from r13083 (related r9569, follow up to r10667). [Ai4rei]
	* Cleaned up MOTD reading (related r292 and r4552). [Ai4rei]
	- Added a warning for common client crash caused by the sequence ' :' in MOTD.
	* Fixed impossible condition in soundeffect script command (since athena-dev-2.1.1-mod1046, related r5841). [Ai4rei]
	* Updates to the playBGM functionality (since r14335). [Ai4rei]
	- Removed impossible condition in playBGM script command (from soundeffect).
	- Removed unused code (retrieving of a bl) in playBGMall (from soundeffectall).
	- Made playBGMall default to 'entire server' when both map name and coordinates are omitted instead of printing an error.
	- Updated documentation for playBGM and playBGMall to match actual behavior.
	- Removed unused parameter 'bl' in clif_playBGM.
2010/12/11
	* Fixed script command setd always assuming value parameter to be a string, which causes hexadecimal and octal numbers not being handled properly (topic:261833, followup to r14577 and r14578). [Ai4rei]
	* Updates to dynamic server information `ragsrvinfo` on SQL. [Ai4rei]
	- Fixed exp and drop rates (int) getting truncated (short) when sent to char-server.
	- Removed `motd` from `ragsrvinfo` as it is not dynamically changed by the server and as such can be read by 3rd party applications directly from conf/motd.txt if required.
	* Added support for checking argument data type of built-in script functions (bugreport:1701, topic:261833, related r14573). [Ai4rei]
	* Fixed error message in intif_parse_mercenary_received printing wrong struct size (bugreport:4633, since r13116). [Ai4rei]
2010/12/10
	* Replaced buildin_getpartyname_sub, buildin_getguildname_sub and buildin_getguildmaster_sub, which create only unnecessary overhead, with equivalent inlined code. [Ai4rei]
	- Fixed a memory leak in getguildmasterid, when the guild leader was not online (bugreport:2743).
	- Command getguildmasterid no longer requires the guild leader to be online.
	* Fixed bAutoSpellOnSkill bonuses not working independently of each other (bugreport:4617, since r13596, related r14536). [Ai4rei]
	* Revised argument declaration of all script commands according to the actual functions' argument usage. [Ai4rei]
	- Fixed many script commands with fixed amount of optional parameters to no longer accept any amount of arguments (faulty declaration).
	- Corrected use of dummy parameter for guildopenstorage in scripts.
2010/12/09
	* Removed some of the duplicate, storage-related packet code. [Ai4rei]
	- Removed clif_guildstoragelist and adjusted clif_storagelist to be able to handle any kind of storage.
	- Removed clif_guildstorageitemadded in favor of clif_storageitemadded.
	- This also fixes clif_guildstorageitemadded sending old update packet for clients prior 20090603, although packet 0x1c4 (ZC_ADD_ITEM_TO_STORE2) was added before PACKETVER 5 (before 2003-11-03aSakexe, exact addition date unknown) (since r14286).
2010/12/08
	* Applied some script command documentation updates and fixes as already done inside the wiki. [Ai4rei]
	- Updated description for 'next', 'return', 'attachrid', 'detachrid', 'itemskill', 'openstorage', 'skilleffect', 'donpcevent', 'day', 'night', 'atoi' and 'axtoi' to resolve inaccuracies, missing information or unverified behavior.
	- Clarified the purpose of the 'jump_zero' and 'getelementofarray' script commands.
	- Fixed 'changebase' stating, that it only works in item scripts (since r2402).
	- Fixed 'kickwaitingroomall' stating, that it is not properly linked into the script engine, thus not working (since r13732).
	- Updated the description for 'cutin' so that it does not give the impression, that the client is able to display multiple illustrations at once, and being less confusing about the maximum size of illustrations.
2010/12/07
	* Fixed txt-converter-login was no longer compilable with supplied project/make files, due to missing reference to function exists in utils.c (bugreport:4626, since r14528). [Ai4rei]
	* Applied svn:eol-style to VS2010 project files (follow up to r14562). [Ai4rei]
	* Reverted r14563, due to multiple issues which render the source malfunctioning or uncompilable. To be redone later (bugreport:4627). [Ai4rei]
	* Removed unnecessary reference operator from scanf calls passing character strings as arguments in adduser tool. [Paradox924X]
	* Revert of r14564. The value wasn't an arbitrary account id but rather the file format version. Added comment specifying this. [Paradox924X]
	* Removed arbitrary account id from atop account.txt (Since r13000). [Paradox924X]
	* Changed almost all instances of sprintf() to snprintf(). [Paradox924X]
	* Further corrections to doc/item_bonus.txt (bugreport:4624). [Ai4rei]
	- Added documentation for bUnbreakableGarment, bUnbreakableWeapon, bUnbreakableArmor, bUnbreakableHelm, bUnbreakableShield, bUnbreakableShoes, bBreakWeaponRate and bBreakArmorRate (follow up to r485, r915, r1116, r13819).
	- Fixed bIgnoreDefEle having race constants listed instead of element constants (since r12804).
	- Fixed bUnstripable* not mentioning, that the bonus parameter is meaningless (follow up to r1382).
2010/12/06
	* Corrected description for bonuses bHealPower and bHealPower2 stating skill names being supported, although the bonus does not accept 'skill' as parameter (bugreport:4619, since r13821). [Ai4rei]
2010/12/05
	* Rev. 14559 Added support for bonus bAddItemHealRate, which works for all healing items care of Epoque. [L0ne_W0lf]
2010/12/04
	* Fixed party booking search increasing result counter, even when no results were found, causing crashes from r14516 onwards (bugreport:4615, since r14412). [Ai4rei]
2010/12/03
	* Fixed soul linkers not receiving taekwon angel buffs upon level up (bugreport:3585, since r3657 and r3660, related r6294). [Ai4rei]
	* Corrected 'chance' in description for bonuses bAddMonsterDropItem and bAddMonsterDropItemGroup (bugreport:4063, partially since r1572). [Ai4rei]
	* Removed leftovers of the item_value_db.txt feature (bugreport:2031, since athena-dev-2.1.1-mod377, followup to pre-svn 2004/05/29). [Ai4rei]
2010/12/02
	* Various code tweaks and updates related to item types. [Ai4rei]
	- Replaced item type literals with their appropriate constants.
	- Added itemdb_typename to replace the ugly "BUG!" filled array in @iteminfo (since r1741, follow up to r14550).
	- Made the item database parser verify item type for validity.
	- Added item type constants to const.txt for use in scripts (getiteminfo).
	* Added support for IT_CASH to @iteminfo, logging filters and item drop rate adjustment. Added 'show_picker.item_type'-specific IT_CASH value to it's description (follow up to r14549). [Ai4rei]
	* Rev. 14549 Added item type IT_CASH (item type 18) Requires user confirmation before using/generating item(s). [L0ne_W0lf]
	* Fixed mapflags not getting initialized upon @reloadscript (bugreport:2247, since r1275). [Ai4rei]
	* Removed redundant check in food vs. cash food status change overriding code, partially suggested by xazax (related r14437 and r14510). [Ai4rei]
	* Added an error message when a client connection exceeds the socket write buffer, so that it does not appear to be closed for no apparent reason (follow up to r13469). [Ai4rei]
	* Random clif.c fixes and cleanups. [Ai4rei]
	- Fixed clif_homskillup using sd before nullpo check (since r9297 and r9307).
	- Merged code responsible for disabling pets in GvG and spawning them as per TODO (related r12002).
	- Fixed base and job exp not being sent to the client for new connections (follow to r14505).
	- Fixed Magnifier (item) and Identify (skill) attempting to identify an item, even when cancel is pressed, causing skill failed message.
	* Added defines for guild notice sizes (MAX_GUILDMES1 and MAX_GUILDMES2). [Ai4rei]
	* Added clif_starskill (packet 0x20e, ZC_STARSKILL) to host the packet previously implemented by clif_feel_info, clif_hate_info, clif_mission_info and clif_feel_hate_reset (related r4352, r4375 and r9162). [Ai4rei]
	- This also fixes sd->bl.id being sometimes supplied for monster_id in this packet.
	* Various additions and updates to the comments and documentation of packets in clif. [Ai4rei]
	- Renamed clif_01ac to clif_skillunit_update to make it look less 'mysterious'.
	* Removed clif_weather_sub and clif_misceffect2 in favor of clif_specialeffect_single and clif_specialeffect (all of them are ZC_NOTIFY_EFFECT2). [Ai4rei]
	* Rev. 14540 Monsters spawned with mob-generating items now have MD_ANGRY applied to them. [L0ne_W0lf]
2010/12/01
	* Added packet 0x1b1 (ZC_SHOWDIGIT). [Ai4rei]
	* Confirmed packet 0x291 (ZC_MSG) to be general-purpose msgstringtable.txt packet and updated all functions using it (related r12245 and r13126). [Ai4rei]
	* Fixed using main chat nick longer than 15 characters would cause a buffer overflow (bugreport:2671, since r5013). [Ai4rei]
	* Fixed bAutoSpellOnSkill bonuses could not be chained (bugreport:4421, since r13596). [Ai4rei]
	* Fixed NPC_TALK message being displayed with EOL character attached (bugreport:4596, since r14270). [Ai4rei]
	* Reverted change from r14533 and restored the 3rd field of mob_avail.txt being optional (bugreport:4599, since r14532). [Ai4rei]
	* Monster database reading now utilizes sv_readdb. [Ai4rei]
2010/11/30
	* Fixed out-of-bound access to percentrefinery array causing refine bonuses stop working (bugreport:4598, since r14526). [Ai4rei]
	* Fixed class being used instead of idx in status_readdb_job2 (bugreport:4597, since r14526). [Ai4rei]
	* Moved function 'exists' (file presense check) to utils.c, so that it is available to code outside of lock.c [Ai4rei]
	- Fixed associated F_OK and R_OK defines causing 'already defined' warnings on MinGW (since r1361).
	* Resolved missing script documentation (bugreport:4578). [Ai4rei]
	- Added documentation for bonus bAutoSpellOnSkill (follow up to r13596).
	- Added documentation for script command progressbar (follow up to r14024).
	* Made job_db1.txt, job_db2.txt, size_fix.txt and refine_db.txt reading use sv_readdb. [Ai4rei]
	- NOTE: Any MAX_LEVEL (map.h) increase requires at least same increase of SV_READDB_MAX_FIELDS (strlib.c) as well.
	* Added SV_READDB_MAX_FIELDS define for configuration of the sv_readdb limit. [Ai4rei]
	* Made skill_tree.txt reading use sv_readdb. [Ai4rei]
	- Added define for skill entry requirements.
	- Reports duplicate skills within same job class.
	* Added a define for star gladiator feel/hate info array length (follow up to r8721 and r11840). [Ai4rei]
	* Fixed script command getusers causing 'player not attached' errors when asking for character count in entire server (bugreport:4591, since r14495). [Ai4rei]
2010/11/29
	* Resolved issues with item delay system. [Ai4rei]
	- Fixed random crashes caused by map_session_data corruption due to out-of-bounds access to item_delay array (bugreport:4568, since r14455).
	- Fixed item delay database not being compatible with @reloaditemdb. Item delays are now reset upon reloading, much like a restart would do (bugreport:4589).
	- Fixed trailing commented lines in db/item_delay.txt could cause 'too many entries' error to be displayed.
	- Fixed last entity of a cash food item not being recognized as cash food, thus not receiving use delay, due to access to deleted inventory slot (since r14426).
	- These changes also fix a warning regarding variable 'i' in pc_useitem being potentionally uninitialized (bugreport:4559).
2010/11/28
	* Added an option to re-roll the /dice emotion server-side, to prevent cheats during events (bugreport:4194). [Ai4rei]
	* Added emotion_type enumeration for clif_emotion constants. [Ai4rei]
	- Made clif_parse_Emotion use clif_emotion, rather than having it's code inlined.
	* Added clr_type enumeration for vanish effect constants. [Ai4rei]
	* Resolved multiple issues with the party booking system (bugreport:4573, since r14412). [Ai4rei]
	- Fixed recruitments were limited to party leaders.
	- Fixed recruitment index was party id instead of an auto-increment value, causing sorting by age not working.
	- Fixed search result packet being sent on recruitment creation (probably to work-around next problem).
	- Fixed packet 0x0805 not getting sent, because of commented entries in packet_db.txt (packet ver. restriction of clif_send).
	- Fixed recruitment creation notice being sent to the recruiter only.
	* Removed 'negative clrtype is used for skipping unauthed objects from saving' introduced in r9975, as it is no longer required/used (follow up to r12223). [Ai4rei]
	* Made the party booking search pass results as array of pointers, rather than array of indexes, which require further lookup. [Ai4rei]
	* Replaced literal constants related to the party booking system with defines. [Ai4rei]
	* Fixed pets derived from immobile monsters not being able to walk (bugreport:3377, since r13789). [Ai4rei]
	- This also fixes pets using original monster walk speed, instead of the one defined in pet db.
	- Fixed pets not being able to attack (pet_attack_support and pet_damage_support) when derived from a monster, which is not able to attack.
2010/11/27
	* Fixed a crash uncovered with r14501, caused by outdated local variables when a script is about to suspend or terminate (bugreport:4577). [Ai4rei]
	* Fixed a crash when using food status bonuses with cash food status bonuses (bugreport:4582, since r14437). [Ai4rei]
2010/11/26
	* Fixed description of bCriticalAddRace having 'race' and 'crit' parameters interchanged (bugreport:4383, since r1116 and r1382, related r12804). [Ai4rei]
	* Changed 'killerrid' and 'killedrid' from player vars to player params (bugreport:3249) [ultramage]
	- Now stored in player session data, so they don't get saved on logout anymore.
	- Added sql upgrade script 'upgrade_svn14507.sql' to remove the now unused player variables.
	* Some updates and fixes to script command documentation. [Ai4rei]
	- Fixed small inaccuracy in description for homevolution (bugreport:125).
	- Added ~AnnieRuru~'s fixes to item scripts, variables, and commands addtimer and addnpctimer (bugreport:373).
	- Fixed documentation for function command in regard of passed arguments and return value. (bugreport:373).
	- Simplified description for getusers, by hiding internal mechanics of the command, which are irrelevant to a scripter (bugreport:2545).
	- Added description for setfont and mercenary-related commands (bugreport:3034).
	- Added documentation for ?: operator and "global" labels provided by Gepard (bugreport:3650).
	- Added documentation for operators -, ~ and ! (bugreport:3650).
	* Fixed base and job exp not getting reset on (de)leveling through commands (bugreport:85). [Ai4rei]
	- Fixed level up related functions not updating client-side exp information, causing the exp percent value display random values.
	- Fixed party system not getting notified of level-ups through parameter changes.
	* Fixed auto-generated statpoint table missing 3 status points (since r1107). [Ai4rei]
2010/11/25
	* Too large client packets, which would otherwise cause the client to crash, are now dropped and reported (bugreport:4391). [Ai4rei]
	* Fixed a crash when an unknown map is encountered during parsing a 'script' npc and the script has mismatched curly braces (bugreport:4423, since r11502). [Ai4rei]
	* Fixed script commands attachrid and detachrid not updating the attached character's information about currently running script, causing errors with dialog-based scripts or preventing characters from walking (bugreport:4571). [Ai4rei]
2010/11/24
	* Fixed party booking search not interpreting level 0 as 'all levels' and using level as upper rather than lower bound (bugreport:4537, since r14412). [Ai4rei]
	* Display a message showing the user where to change MAX_ITEMDELAYS when they have too many entries in the item_delays db. Follow-up to r14455. [Paradox924X]
	* Fixed pets with player sprites causing the client to crash while looking for non-existing resources (topic:260895, follow up to r14488). [Ai4rei]
	* Fixed calls to pc_delautobonus assuming map_session_data::autobonus2 and map_session_data::autobonus3 arrays having the same size as map_session_data::autobonus (since r13915). [Ai4rei]
2010/11/23
	* Added script command pushpc, which is required by newer scripts. [Ai4rei]
	- Moved knockback-part of skill_blown into unit_blown, to allow unconditional knockback required by pushpc without copy-pasting code.
	* Various small cleanups. [Ai4rei]
	- Fixed truncation warnings in @statuspoint, @skillpoint and @str/@agi/@vit/@int/@dex/@luk (since r14436).
	- Fixed data type inconsistency in @statuspoint and @skillpoint (since r5762, related r13541).
	- Silenced truncation warnings in CR_ACIDDEMONSTRATION damage calculation and cardfix application (since r13700).
	- Reformatted unit_blown to make it look cleaner (follow up to r14492).
	* Labels longer than 23 characters will no longer cause the server to exit immediately (bugreport:4563, since r1213). [Ai4rei]
	* Fixed script command getusers causing map server to crash when called with type 0 without attached character (bugreport:4565). [Ai4rei]
	- Lack of character is now reported like other script commands do. Additionally invalid types are reported as well.
2010/11/22
	* mail_deliveryfail no longer attempts to log (since r12910) and give items (since r11855), when there is no item attached to the mail (bugreport:3239). [Ai4rei]
	* Fixed a crash when shutting down char-server (TXT only), after it failed to load storage save data (since r1275). [Ai4rei]
	* Batch files (Windows) now detect whether the server crashed, aborted or shutdown cleanly (Ctrl+C or @mapexit) and print appropriate message, instead of always assuming, that the server crashed (bugreport:3476, since r1818). [Ai4rei]
	* Fixed map server getting notified of hair, hair color, gender, class and level changes from a char server (TXT only) twice (since r2986). [Ai4rei]
	* Fixed saving/loading errors with compilers (such as VC6, MinGW), which do not recognize %ll format (since r14242). [Ai4rei]
	- This also fixes guild leader name being displayed and saved as "(null)" in the guild member list.
	* Fixed guild and guild member exp truncation issue (bugreport:4130, since r14242). [Ai4rei]
	- Fixed guild member position, hair, hair color, gender, class and level could potentially become corrupted due to shorts being read as ints (partially since r2986).
	* Fixed disguising as player clone causing the client to crash while looking for non-existing NPC sprites (bugreport:4428, since r14387, related r14383). [Ai4rei]
	* Fixed Rogue skill Steal Coin working on boss monsters (bugreport:2442). [Ai4rei]
	* Fixed map-server displaying 'PK Mode' notice only for pk_mode 1 (since r8402). [Ai4rei]
2010/11/21
	* Added msinttypes (rev. 26, http://msinttypes.googlecode.com/svn/trunk/) portability framework for Visual C++ compilers (related bugreport:4059). [Ai4rei]
	* Added 64-bit variants of the socket and buffer I/O macros. [Ai4rei]
	* Added enumeration RC2_* for mob data 'race2' (bugreport:4561). [Ai4rei]
	- Fixed race2-related bonus arrays using RC_MAX, rather than race2 maximum (since r6221, related r1277).
	- Fixed bSubRace2 lacking bounds check (since r1257).
2010/11/20
	* Fixed @doom and @doommap spamming packets for the visual effect on invoker unnecessarily over whole map and server respectively. The effect is now displayed on each killed character (bugreport:871, since r311). [Ai4rei]
	* Fixed login-server account engine initialization not getting checked, whether it succeeds or not (bugreport:4361, since r12700, related r13000). [Ai4rei]
	- Failure to retrieve account engine and initializing it is now considered fatal and causes the server to exit immediately.
	- Fixed two data type inconsistencies, while being at it.
	* Made atcommand declarations use ACMD_FUNC macro (bugreport:4252, related r11607). [Ai4rei]
2010/11/19
	* Various VC6-related fixes and tweaks. [Ai4rei]
	- Fixed a typo in VC6 project files, that prevented login-server from compiling (bugreport:4061, since r12727).
	- Fixed usage of 'long long' in Sql_P_BindSqlDataType preventing SQL VC6 projects from compiling (bugreport:1741, since r10779).
	- Fixed usage of 'long long' in strtoull preventing VC6 projects from compiling (bugreport:4059, follow up to r14245).
	- Made strtoull default to base 10 and actually process base 8, to match the normal behavior of this function (bugreport:4059, follow up to r14245).
	- Fixed functions in db.c not being returned as pointer, causing warnings on VC6.
	* Fixed plug-in version getting checked against itself and a wrong operator being used for the check (bugreport:3952, since r9631). [Ai4rei]
	* Fixed WFIFOL being used instead of WFIFOW for a short field of packet 0x2710 (bugreport:2819). [Ai4rei]
	* Made script command getmapxy print a warning, if an invalid type is supplied (related r69, r8459). [Ai4rei]
	* Fixed pc_marriage not checking spouse character job for baby class. [Ai4rei]
	* Removed ; from INTPTR_* defines (since r13449). [Ai4rei]
	* Fixed a crash when SqlStmt_ShowDebug is given NULL pointer as statement handle (since r10753, related r10818). [Ai4rei]
2010/11/16
	* Added a missing argument to a warning containing a format specifier. [Paradox924X]
2010/11/15
	* Follow-up to r14456. Default initialize atk_rate to 0 instead of 100 to match new effect of bonus bAtkRate. [Paradox924X]
2010/11/14
	* Rev. 14463 Updated quest_read_db. [L0ne_W0lf]
	- Reports entries when read by server at start up like other DBs.
	- Will now skip blank lines instead of reporting false errors.
	- Will report when entries are > MAX_QUEST_DB.
2010/11/10
	* Made bAtkRate add the rate rather than setting it. (bugreport:4499) [Paradox924X]
	* Added an item_delay database usable for item-specific use delays. [Paradox924X]
2010/11/09
	* Use packet 0xe7 instead of 0x1f5 within clif_tradestart() when there is no trade_partner (or an invalid one) specified even for PACKETVER >= 6. (bugreport:4544) [Paradox924X]
	* Follow-up to r14368. Load last_map from SQL on char load so the information is available during char select for PACKETVER > 20100721. Patch based on Ai4rei's. (bugreport:4429) [Paradox924X]
2010/11/08
	* Notify players involved in a trade that it has been canceled when one player changes maps/logs out or otherwise becomes unable to participate in the trade. [Paradox924X]
	* Send the actual level of the person you're trading with rather than limiting it by the max_lv/aura_lv settings. [Paradox924X]
2010/11/07
	* 'Exp gained' packets are now sent regardless of @showexp. @showexp can be enabled regardless of PACKETVER. [Gepard]
	* Applied clif_equiplist fix by Ai4rei to prevent client crash when equipment is broken/repaired and PACKETVER >= 20100629. Follow-up to r14368. (bugreport:4459) [Gepard]
2010/11/02
	* Fixed an issue where two ushorts were being strcmp'd. Follow-up to r14442. (bugreport:4523) [Paradox924X]
	* Ensured character data is saved even when last map is the only value that has changed during save time. (bugreport:2218) [Paradox924X]
	* Applied fix by Ai4rei to reintroduce mapName within charinfo packet when PACKETVER >= 20100803. Follow-up to r14432. (bugreport:4413) [Paradox924X]
	* Updated script doc to appropriately describe the effects of close/close2 when used without a window on screen. (bugreport:898) [Paradox924X]
	* Applied patch by xazax to clean up various bits of code across mapserver code. (bugreport:4512) [Paradox924X]
2010/11/01
	* Changed Normal and Cash Food statuses so they do not stack and overwrite the other if the level (val1) is the same or higher. (bugreport:4519) [Paradox924X]
	* Modified certain atcommands to use 64 bit arithmetic before capping a value to correct boundary logic for overflowing values. [Paradox924X]
2010/10/21
	* Removed unused 'indoors' mapflag. [Gepard]
2010/10/17
	* Fixed wrong char info packet size for clients after 2010-07-27. (bugreport:4413) [Gepard]
2010/10/13
	* Prevented direct transformation into dummy jobs via @jobchange command. (bugreport:4227) [Paradox924X]
	* Prevented @stpoint and @skpoint from causing overflows. [Paradox924X]
2010/10/11
	* Implemented official cash food behavior, including use delay, not being dispelled (including on death),
	  distinct status effects and icons from the ordinary food types. (bugreport:2560) [Paradox924X]
	* Applied ultramage's fix to prevent a segfault when a mob dead event triggered by a land-based skill causes the player to warp. (bugreport:4426) [Paradox924X]
2010/10/10
	* Applied Ai4rei's patch to prevent an invalid rid from being attached to the execution of a script. (bugreport:4470) [Paradox924X]
	* Added NULL initialization to info variable in map_readfromcache() to satiate compiler. (bugreport:4399) [Paradox924X]
	* Applied Ai4rei's patch to eliminate unnecessary and redundant castle data saving. (bugreport:4471) [Paradox924X]
	* Added a missing const qualifier to a variable. (bugreport:4472) [Paradox924X]
	* Rev. 14418 Follow up from r14413, should take care of the errors from bugreport:4472. [L0ne_W0lf]
	* Pull `name` from character table instead of using `master` from guild table when loading guild data. [Paradox924X]
	* Use `char_id` rather than `master` when checking if a guild needs to be deleted during character deletion. [Paradox924X]
2010/10/06
	* Rev. 14413 Touched up the party booking patch, seems I forgot some lines in clif.c...and managed to duplicate a line in map.c. [L0ne_W0lf]
2010/10/05
	* Rev. 14412 Added Spira's Party Booking System implementation [L0ne_W0lf]
2010/09/20
	* Fixed when devoter is killed by the redirected damage, devotee takes the whole damage. (follow up to r14406)[Inkfish]
2010/09/18
	* Rev. 14409 Added bard/dancer songs and duets to the nodispell list. (bugreport:4411) [L0ne_w0lf]
	* Applied Ai4rei's patch for the skill WE_CALLPARTNER (bugreport:4437)
2010/09/12
	* All direct damages such as reflected damage or Tarot Card damage should not be redirected. (follow up to r14400)[Inkfish]
2010/09/08
	* All mobs whose display sprites are those of a job id will now appropriately be identified to the client as players, not mobs. [Paradox924X]
	* Updated License from GNU GPLv2 to GNU GPLv3. [Paradox924X]
2010/09/07
	* Added MD_TARGETWEAK to list of modes not to give a player when calculating player data.
	- This makes evilclones aggressive towards players. (bugreport:3280) [Paradox924X]
	* Ensure a pointer is valid within map_readfromcache() before attempting to access its members. [Paradox924X]
2010/09/06
	* Rev. 14400 Implemented Icescope's fix for devotion, reflect damage is no longer absorbed by the devoter. (bugreport:3189) [L0ne_W0lf]
	* As a folow up to r14301, increased MAX_REG_NUM to 256, to prevent possible data loss.
2010/08/28
	* Force a map_quit() call on the session data after a block/ban/changesex/acc deletion to remove leftovers of a player's session
	  caused by when the fd has already been set to eof (player is not connected) but session data is kept (e.g. autotrading). [Paradox924X]
	* Replaced a map_moveblock() call with a call to unit_movepos() to prevent an exploit. [Paradox924X]
2010/08/26
	* Rev. 14395 instance_npcname will now error if the NPC being looked up is not found, care of ramsey. [L0ne_W0lf]
	* delitem/2 will now send the close button when failing to find all neccecary items to delete.
	- Still do to, items should not be deleted as-found, and should be deleted once counted
	  and in the event of delitem failure, nothing should be consumed. This is a design flaw
	  in eathena, and should be fixed as soon as possible.
2010/08/21
	* Rev. 14393 Follow up to r14392, forgot to remove the old snprintf. [L0ne_W0lf]
	* Rev. 14392 Mob chat now strips "#unique" names off monsters, curtosy of Daegaladh. [L0ne_W0lf]
2010/08/20
	* Rev. 14390 Commented out code from r14388, as this breaks NPCs that rely on running global events in duplicates. (IE: WoE scripts) [L0ne_W0lf]
	* Removed processing for undocumented and unused event 'OnCharIfInit' which is essentially an alias for event 'OnInterIfInit'. [Paradox924X]
	* Made it so global events don't get executed in duplicates to prevent unnecessary reprocessing of events that only need to be run once.
	  This potentially reduces the total number of global events by hundreds, even thousands. [Paradox924X]
	* Added a few missing updates to the last packet update to properly support player clones and disguising. [Skotlex]
2010/08/19
	* Rev. 14384 Follow up to r14383, changed use of clif_font_area to clif_font, seems Skotlex forgot them. [L0ne_W0lf]
	* Added support for packets 0x7fa, 0x7f7, 0x7f8, 0x7f9. These are for renewal
	  clients and fixes deletion of ammo/displaying of Homunculus HP/SP bars on recent RE clients. [Skotlex]
2010/08/18
	* Rev. 14381 Added bonus3 bAdd/SubEle, which allows you to specify a battle flag as well! Dun dun dun! [L0ne_W0lf]
	- The bonuses are addititive to existing bAdd/SubEles, as that's how it appears to work.
2010/08/16
	* Fixed an exploit where unauthorized GMs can give zeny through auction. [Inkfish]
	* Rev. 14378 Attempting to tackle, and fix some simple errors in skills. [L0ne_W0lf]
	- Stormgust hit counter no longer resets under new casts of stormgust.
	- RG_STEALCOIN will now cause the monster to aggro player on success. (bugreport:3547)
	- SL_WIZARD will now consume one crystal fragment per reflected hit. (bugreport:3603)
	- WZ_FROSTNOVA will now ignore targets in area that are already frozen. (bugreport:3980)
	- SL_KAAHI will no longer use SP if player has full health already. (bugreport:3918)
	- CG_TAROTCARD "The Lovers" will heal source player instead of target. (bugreport:4171)
	* Merged Shinryo's patch which speeds up map-cache loading (with a few changes, see eA forum thread #253218 for details) [Skotlex]
2010/08/14
	* Rev. 14373 Quest log kill count now updated properly. (Added from topic 253813) [L0ne_W0lf]
2010/08/11
	* Documented Battleground commands with as much information as I've got. [L0ne_W0lf]
2010/08/03
	* Merged quite a bit of the RagexeRE eA Compatibility patch (eA topic 222623) to support the more recent clients. [Skotlex]
2010/07/27
	* Rev. 14367 Implemented three new mercenary skills. [L0ne_W0lf]
2010/07/27
	* Rev. 14365 Updated npc_randomattack, it now does 100*skillevel percent damage. [L0ne_W0lf]
	* Added patch from Paradox to allow a skill to use a random element for damage. See skill DB for info.
2010/06/27
	* Rev. 14358 Follow up to r14357. Moved where sd is checked for existance in specialeffect2. [L0ne_W0lf]
	* Rev. 14357 Updated specialeffect2 to accept player names. (follow up to r14353) [L0ne_W0lf]
	* Bascilica now allows boss-flagged monsters to knock you back as per official.
2010/06/27
	* Rev. 14356 Follow up to r13895, added a battle.conf setting to control if ranges should be checked with autocasts. [L0ne_W0lf]
	  'autospell_check_range', by default is set to no, as this is official behavior. This also affects autospellwhenhit.
	* Sonic Blow autocast now stops players attacking when it triggers. It's possible there is more depth to this 
	  on official servers, and should 'stop' attacking on regular casts as well. It appears so far that this is the
	  only skill that behaves this way.
	* Modified the default value for homunculus_auto_vapor in source to 1.
	* pvp_points are no longer calculated in the gvg_dungeon flagged maps.
2010/06/22
	* Rev. 14353 Added support for NPC names in the 'specialeffect' script command, go go copy/paste! [L0ne_W0lf]
2010/06/20
	* Fixed codepage indicators being included in NPCs' whispervars. [Gepard]
2010/06/18
	* Added support for NPC/PC names in 'emotion' script command. [Gepard]
2010/06/14
	* Rev. 13442 Blocked being able to use the skill CR_DEVOTION on players under the status SC_HELLPOWER. [L0ne_W0lf]
	- Additionally, users afflicted by the status can also no longer use Token of Siegfried to self-res.
	* Added Manuk, Splendide and SC_HELLPOWER statuses to the status effects that can't be dispelled.
	* Changed SC_SPEEDUP0 to use the correct status icon SI_MOVHASTE_HORSE.
	* Changed SI_SPEEDUP1 to use the correct status icon SI_SPEEDPOTION1.
2010/06/13
	* 'clif_hpmeter' shouldn't send the packet to the player himself. [Inkfish]
2010/06/10
	* Rev. 14336 Updated SC_ITEMBOOST to work similar to how it used to in r11351. [L0ne_W0lf]
	- Will not boost drop rates past 90%, but ignores those already greater than.
	- Now uses val2 in the sc_start as the drop rate modifier, see item_db for example.
2010/06/09
	* Added support for packet 0x7fe which changes the bgm temporarily for a single player [Rikter/Yommy]
	* Added 2 script commands, playBGM and playBGMall, documented use in doc/script_commands.txt [Rikter/Yommy]
2010/06/01
	* Rev. 14329 Corrected warnings (and errors on some compilers) from r14327. [L0ne_W0lf]
	* Rev. 14327 Implemented the Manuk and Splendide item status effects, thanks to Epoque. [L0ne_W0lf]
2010/05/31
	* Added support for using 'town', 'autotrade', 'allowks', 'monster_noteleport', 'pvp_nocalcrank' and 'battleground' mapflags in scripts (bugreport:4226). [Paradox924X]
	* Replaced all occurrences of 'leaved' with 'withdraw'. [Paradox924X]
	* Rewrote and optimized clif_hpmeter to employ map_foreachinarea() rather than an iteration over every session (bugreport:3956). [Paradox924X]
	* Rewrote and reorganized checks in @autotrade to check and display most useful information first (bugreport:4253). [Paradox924X]
2010/05/30
	* Damaged reflected from skills will now be shown as multiple hits if the skill used was multi-hit. [Paradox924X]
2010/05/29
	* Rev. 14313 Added a pc_isdead check to warpparty. Only warp and mapwarp (moveto, warpallpcinthemap, and warpwaitingpc aegis script equivilents) should revive players when placing them on new maps. [L0ne_W0lf]
	* Rewrote/optimized script command warpparty. [Paradox924X]
	- Added support for an optional extra parameter "from_mapname" to restrict effect of warpparty to only those on a specific map.
2010/05/28
	* Rev. 14310 Fixed it so you can't add opositions during woe se. [L0ne_W0lf]
2010/05/20
	* Rev. 14301 Increased gobal_reg_value to 256 from 96. [L0ne_W0lf]
	* Upped the max quest db entries allowed to 1500.
	* Added remaining status icons to status.h (mostly 3rd job icons.)
2010/04/28
	* Fixed OnTouch doesn't trigger on hiding character. (bugreport:4208) [Inkfish]
2010/04/23
	* Merged a few updates for supporting renewal clients (thanks to Diablo): [Skotlex]
	- Updated packets for char-select screen, trade item add, guild storage item add, vending list.
	- Allow client to change item-share party settings
2010/04/12
	* Fixed SuccessRemoveCards removing Armor Enchant. (bugreport:4014) [Inkfish]
2010/03/31
	* Rev. 14277 Moved /npc/sample/ to /doc/sample. These are examples, not actual npcs. [L0ne_W0lf]
2010/03/23
	* Rev. 14270 Implemented NPC_TALK (Credit to SnakeDrak and Daegaladh) [L0ne_W0lf]
	- Also added in the ability to use '@npctalkc' as a GM command.
2010/03/21
	* Added missing checks to stop an infinite free cash point exploit. (bugreport:4139) [ultramage]
2010/03/02
	* Fixed an exploit where the buyer can end the auction himself. [Inkfish]
2010/02/27
	* Fixed Posion Status killing monsters with low max hp(like plants). [Inkfish]
2010/02/19
	* Fixed racial bonuses for RC_NONDEMIHUMAN applying to right cardfix value (cardfix) instead of left cardfix value (cardfix_) in the case of melee attacks where left_cardfix_to_right is set to 'no'. [Paradox924X]
	* Fixed NPC_INVINCIBLE can be dispelled. (bugreport:4046) [Inkfish]
	* Fixed a compliation warning. [Inkfish]
2010/02/09
	* Expanded range for cached and stored-in-db guild member exp (devotion) from uint32 to uint64. (bugreport:3983) [Paradox924X]
	* Capped value when sending to client to INT_MAX to prevent confusion. [Paradox924X]
2010/02/07
	* Bleeding doesn't kill non-player characters. [Inkfish]
2010/02/06
	* Added official packet to display received expirience. [Inkfish]
2010/01/30
	* Added support for PACKETVER 20100105, which updates the vending related packets on this and later clients. [Skotlex]
2010/01/28
	* Rev. 14232 SN_SHARPSHOOTING is no longer affected by AC_VULTURE. (Bugreport:3909) [L0ne_W0lf]
	- Removed the mercenary version from there as well, as it's not needed.
	* Fixed target skill doesn't autocast on hit when hit by AoE. [Inkfish]
2010/01/24
	* Prevented the changing of alliances to oppositions during WoE. (bugreport:3923) [Paradox924X]
2010/01/23
	* Prevented pc_skill with a value of 2 for 'flag' from granting a skill level that surpasses MAX_SKILL_LEVEL. (bugreport:4022) [Paradox924X]
2010/01/19
	* Snatch should warp you anyway even if the target died. [Inkfish]
	* Snatch now checks the distance between source and target in case it kills the target and then warps the respawned one. [Inkfish]
2010/01/16
	* Fixed items don't grant skill if you had this skill before and then changed your job. [Inkfish]
2010/01/14
	* Fixed change cart packet doesn't check for skill. [Inkfish]
	* Added new packets for Plagiarism. [Inkfish]
2009/12/27
	* Fixed Meteor Assault and Spread Attack have twice the chance to trigger AutoSpellOnSkill. [Inkfish]
2009/12/03
	* Prevented online user count from going negative. (bugreport:3913) [Paradox924X]
2009/12/02
	* Rev. 14183 Semi-revert of 14182, moved ALL_WEWISH up under SA_GRAVITY instead, as I hadn't noticed it does exactly what the new case did. [L0ne_W0lf]
	* Rev. 14182 Added skill ALL_WEWISH. This skill in older clients plays a song, however in current clients it does not. The effect (AL_ANGELUS) still shows. [L0ne_W0lf]
2009/11/26
	* Moved log_sql_init() call up in map-server-init to after after map_sql_init() call to prevent unnecessary processing before a potential quit. [Paradox924X]
	* NPC event code cleanups. [Inkfish]
	- removed the 'OnMyMobDead' dead code. It's never supported though documented.
	- removed the 'feature' that events only trigger when the player is in the OnTouch area IF it's specified. 
		It's never documented and breaks official scripts.
	- some cleanups and bug fixes to OnTouch_.
	* Fixed warping in OnPCDieEvent revives people with 0 hp.
2009/11/25
	* Fixed strnpcinfo(1) returning blank strings when NPC names did not have a hidden portion of the display name. (bugreport:3758) [Paradox924X]
2009/11/23
	* Fixed player keeps bleeding when dead. [Inkfish]
	- If battle_config.invincible_nodamage is true, reflected damage to targets in invincible status is now 1.
2009/11/22
	* Added 'ipban_cleanup_interval' option which determines how often expired IP bans are cleaned from the database. (bugreport:3734) [Paradox924X]
	* Modified ipban_check() to only include ipbans that haven't already expired. (bugreport:3734) [Paradox924X]
2009/11/20
	* Cleaned up mapreg dirty-marking code to only mark the mapreg as dirty when it actually is. (bugreport:3735) [Paradox924X]
2009/11/19
	* Applied the renewal client support patch from Diablo (eA forum topic 222623).
	  By default eA still supports sakexe/ragexe clients. In order to support the 
	  renewal clients you must:
	- 1: Change the default packet version to "default" in db/packet_db.txt
	- 2: Change the supported PACKETVER in src/common/mmo.h to the most recent one 
	- 3: recompile. [Skotlex]
	* Added support for strcharinfo(3) to retrieve the player's map, as getmapxy 
	  can be a bit unwieldy when you just want this information. [Skotlex]
	* Added script command "searchitem" which enables scripts to do item searches 
	  based on name (can be useful for creating query NPCs). [Skotlex]
09/11/09
	* Fixed mob is removed from map right after his rebirth. [Inkfish]
	* Fixed dead event does not trigger when a mob has rebirth skill and dies for the second time. [Inkfish]
09/11/08
	* Added a flag to indicate if the script of an autobonus was parsed for the sake of resourse saving. [Inkfish]
09/11/04
	* All Songs/Dances now create a 3 second delay before Adaption can be used. [Inkfish]
	* Fixed unit still not being able to move when fiberlock is removed by Magnetic Earth. [Inkfish]
09/11/02
	* Rev. 14119 Added battle_config.mob_slave_keep_target config option (monster.conf) [L0ne_W0lf]
	- When yes (default) MVP slaves will always keep their prior targets.
	- When no the old behavior of switching to the closest target is enabled.
	* Updated MAX_MOB_DB to 4000 (Monsters are starting to appear in the 2k ranges)
	* Changed default respawn time (when 0) to 500 from 5000.
	* Quick fix to char command checking gm level of the target player instead of the command user (bugreport:3255). [Inkfish]
	* Disalbed @jump/@jumpto usage when dead. [Inkfish]
09/11/01
	* Rev. 14115 Implemented the fix for Slim Pitcher working on WoESE objects (bugreport:3618). [L0ne_W0lf]
	* Added SC_SPIRIT to the list of buffs that are dispelled when the player logs out.
09/10/27
	* Fixed quest will never get erased when it's the only quest you have. [Inkfish]
	* Cast time of Emergency Call is doubled if you master of High Jump. [Inkfish]
	* High Jump can't be used on PvP maps. [Inkfish]
09/10/26
	* Implemented NPC_VAMPIREGIFT and NPC_WIDESOULDRAIN. [Inkfish]
09/10/25
	* Rev. 14101 The status SC_INVINCIBLE now reduces all damage to 1. [L0ne_W0lf]
	- Official behavior, and allows players to cancel NPC_ALLHEAL casts.
	- If battle_config.invincible_nodamage is true, reflected damage is still 0.
09/10/25
	* Implemented the official version of 'OnTouch' named as 'OnTouch_' and it can be defined in script_athena.conf. [Inkfish]
	* Adapted 'map_foreachinarea' to 'map_forsomeinarea' so that it allows you to specify the count of bl you wanna operate on. [Inkfish]
09/10/24
	* Reverted the previous change to OnTouch not triggering for invisible chars [ultramage]
	* 'OnTouch' script shouldn't trigger when you are invisible.(same as warps) [Inkfish]
	* Fixed character doesn't stop walking when walking into OnTouch area of an NPC who doesn't have an OnTouch label. [Inkfish]
09/10/18
	* Removed the char_rename setting in favor of a PACKETVER define [ultramage]
	* Inverted the way renames are counted: '0' now means 'no renames left' (the default)
	* Please make sure your database matches this new behavior before starting the server.
09/10/10
	* Added character rename function. [Inkfish]
	* NPCs' names should only be 24 characters long including EOS. [Inkfish]
09/10/06
	* Fixed rental items can be moved into guild storage from cart. [Inkfish]
09/10/04
	* Implemented new packets for rental items (from Jobbie and Natz and fixed by me). [zephyrus]
	* Rental items now can be moved to storage and cart. [zephyrus]
	* Autotrade cannot be used when user is dead, and it's not dispelled if user dies to prevent abuse. [zephyrus]
	* Fixed pc_checkitem to do a proper item check and remove. [zephyrus]
09/10/02
	* Fixed a damage underflow.(bugreport:3624) [Inkfish]
	* Marionette Control now has an infinite duration.(bugreport:2542) [Inkfish]
09/09/23
	* Added supports for Soul Bound. [Inkfish]
09/09/21
	* Disabled ip checking during auth, since it lead to a lot of confusion. [ultramage]
09/09/17
	* Duration of SC_STONE is not reduced by MDEF. [Inkfish]
	* LexAeterna is allowed to be used on petrifying targets. [Inkfish]
	* Mobs won't attack back if StoneCurse fails. [Inkfish]
09/09/13
	* Progressbar aborts when player is attacked. [Inkfish]
	* Do not stand if damage is from yourself or has no source.(bugreport:3582) [Inkfish]
	* Any mobs killed by party members within view range are taken into account in questlog. [Inkfish]
	* 'unit_walktobl' now uses at least 1 as the range since 'unit_can_reach_bl' always sets the target coordinates 1 cell away from the target block. [Inkfish]
09/09/12
	* Clarified the names of some questlog functions and eventually implemented kill counts updating. [Inkfish]
09/09/04
	* QuestLog Fix. [Inkfish]
	- mob id no longer stores in sql.
	- counts won't increase if you have killed sufficient mobs.
09/08/25
	* Implemented Progress Bar.(topic:207933) [Inkfish]
09/08/21
	* Fixed Teleport through Hocus-Pocus skips menu. (bugreport:3513) [Inkfish]
09/08/20
	* Added bMagicHPGainValue and bMagicSPGainValue. [Inkfish]
	* Fixed the wrong packet length makes client choke when add_quest packets are sent. [Inkfish]
09/08/18
	* Some fixes for Heat [Inkfish]
	- Heat and other ground skills' activation won't cancel combo wait. (bugreport:3228)
	- Heat should work with hp/sp drain bonus. (bugreport:3507)
	- Heat consumes 10 sp if the attack doesn't connect. (bugreport:3038)
09/08/17
	* Equipment DEF penalty shouldn't be applied to players in Mental Strength. (bugreport:3454) [Inkfish]
09/08/14
	* Fixed self skills affecting target unit when used within combo delay for Asura and Flying Kick. (bugreport:3495) [Inkfish]
09/08/11
	* Fixed changequest behavior(before: completequest+setquest, now: erasequest+setquest) [Inkfish]
09/08/10
	* Fixed autospell and autobonus will still trigger even if the chance is 0. [Inkfish]
	* Disabled "show_party_share_picker" functioning on client older than 20071002 to prevent from disconnection. (bugreport:3457) [Inkfish]
	* Fixed units other than players and mercenaries using Devotion will cause crashes. (bugreport:3475) [Inkfish]
09/08/01
	* Questlog code cleanup. [Inkfish]
	* Fixed range check on autospell and autospell2. [Inkfish]
	* Implemented official behavior of party_show_share_picker. [Inkfish]
	* Fixed a typo on reading no_equip list. [Inkfish]
09/07/28
	* Kaahi heals no matter if attack connects. (bugreport:2440) [Inkfish]
	* Fixed a typo causing skillitem always resets skill delay. (bugreport:3431) [Inkfish]
	* Fixed damage_level is not calculated properly on normal attack. [Inkfish]
	* Kaahi is supposed to be canceled on logout. [Inkfish]
09/07/25
	* Rewrote Quest Log system. [Inkfish]
	* Fixed message display for FullStrip and SelfProvoke. (bugreport: 3011, bugreport: 3415) [Inkfish]
09/07/21
	* Added proper bounds of INT_MIN to INT_MAX for hp/sp when being sent to/from status_damage/status_heal for negative values because of INT_MAX being (-INT_MIN - 1). [Paradox924X]
09/07/17
	* Dead branches no longer check for players' level. (bugreport:3378) [Inkfish]
	* The Lovers Card won't teleport anyone on PVP/WoE/BG maps. (bugreport:3371) [Inkfish]
09/07/11
	* Some updates for range check. (bugreport:3339) [Inkfish]
	- Monsters shouldn't use skills if the target is within its attack range but is out of the skill range.
	- Monsters' skill range is no longer 9 by default. 
	- Range for players' attacks and skills should always have a circular check.
09/07/07
	* Skills with multiple hits should do 1 damage per hit to plants. [Inkfish]
09/07/04
	* TK_POWER shouldn't count the player him/herself for the skill. [Inkfish]
	* Fixed a wrong check of Intimidate on hp. (bugreport:3305)[Inkfish]
	* Extended ATF_SKILL to ATF_MAGIC and ATF_MISC. [Inkfish]
09/07/03
	* Martyr's Reckoning can be perfect dodged. [Inkfish]
	* Casting Flying Kick while running and in the spurt status doubles the damage dealt without spurt status. (bugreport:1898) [Inkfish]
	- TODO: bonus on running is still not correct.
09/07/02
	* Updated autobonus [Inkfish]
	- added documentation for autobonus.
	- invoke status_calc_pc after execution so that client display gets refreshed if neccessary.
09/06/30
	* Fixed when dynamic_mobs is active, reloading script right after the last player having left a map leads to permanet mobs not spawning on that map. [Inkfish]
09/06/29
	* Fixed attack not counted as connect when dodged and got damage from skill bonus like Weaponry Research. [Inkfish]
09/06/28
	* Implemented script command "autobonus". [Inkfish]
	- "autobonus" is similar to "bonusautoscript", however it has a timer of its own.
	- Updated itemdb changing items bonus using "bonusautoscript + sc_start" mode to "autobonus + bonus" mode.
	- Remove bonusautoscript and status changes that was needed by bonusautoscript and is no longer in use.
09/06/23
	* Minor update to atcommand_jailfor and atcommand_char_ban's modif_p var incrementation for minute-based bans/jails. [Paradox924X]
09/06/20
	* Changed Asura Strike/Jump Kick to target skill to get rid of the "target delay". (bugreport:2174) [Inkfish]
09/06/19
	* Implemented script command "areamobuseskill" and skill NPC_INVINCIBLE and NPC_INVINCIBLEOFF. (topic:217330) [Inkfish]
	* Using items no longer cancels invincibility(but using target and ground skills through items does). (bugreport:3259) [Inkfish]
	* Fixed Butterfly Wings not working during GVG. (bugreport:3264) [Inkfish]
09/06/16
	* Fixed an exploit that makes guild skill get higher level than the max defined in guild_skill_tree. (bugreport:3241) [Inkfish]
	* Turn Undead won't apply aftercast delay when casted on a "living" entity. (bugreport:1740) [Inkfish]
	* Autocasts should always fail if the target is outside the skill range or an obstacle is in between. (bugreport:3201) [Inkfish]
	* The Lovers should affect the target instead of the caster. (bugreport:3252)[Inkfish]
09/06/15
	* Skill through items will not be blocked when 90% overweight. (bugreport:3246) [Inkfish]
	* Now you can drop items when hiding. [Inkfish]
	* Now you can't logout when hiding, cloaking or chase walking. [Inkfish]
09/06/14
	* Fixed a crash due to group being redeleted when players are performing an ensemble and one of the partner's sp run out. [Inkfish]
09/06/13
	* If both Double Attack and critical attack have chance to trigger within one attack, Double Attack takes priority. (bugreport:3231) [Inkfish]
	* Fixed Butterfly Wings not working on maps blocking Teleport. (bugreport:3236) [Inkfish]
09/06/12
	* Fixed "arrow_atk" flag never being reset results in arrow consumption on itemskills and autocasts. (bugreport:3233) [Inkfish]
	* Fixed itemskill not bypassing Silence, SteelBody, Berserk and the like. (bugreport:3232) [Inkfish]
	* Fury and Asura no longer disable SP regen on any other classes than Monk/Champion.(bugreport:3200) [Inkfish]
09/06/11
	* Fixed TaTaMiGaEShi(Improvised Defense) not working. [Inkfish]
	* Implemented new cooking success formula. Now cooking experience starts at 0.(bugreport:2439) [Inkfish]
09/06/09
	* Fixed applying autocasts with negative rate before the positive one made it fail to remove the autocast. [Inkfish]
09/06/08
	* Rev. 13869 Follow up to r13867, corrected the newly added MD_TARGETWEAK. Monsters with this mode will now only target players five level LOWER than itself. [L0ne_W0lf]
09/06/08
	* Fixed bHPGainValue and bSPGainValue worked on all types of attacks and was only activated on mob's death.(bugreport:3193) [Inkfish]
	* Added a configuration for whether damage of EarthQuake with single target can be reflected. [Inkfish]
	* Fixed Wizard Spirit can block reflected magical damage other than Kaite's.(bugreport:3161) [Inkfish]
	* Fixed Kaite works against bosses.(follow up to r13857) [Inkfish]
09/06/07
	* Magical damage reflection now works against boss monsters and only on target skill(but EarthQuake with one target is an exception). [Inkfish]
	* Changed hardcoded "5" to MAX_ARROW_RESOURCE in skill_arrow_create preventing proper usage. (bugreport:3025) [Paradox924X]
	* Implemented "cooking exp" that increases the success chance of cooking by 0.05% per try and the max bonus is 20%. [Inkfish]
09/06/05
	* Job_Battle_Manual and Battle_Manual can be used simultaneously. [Inkfish]
	* Fixed "sleep" after "attachrid" (a different rid) halts the script. [Inkfish]
09/06/04
	* Fixed turning off a skill needed to meet the requirements. [Inkfish]
	* Skills used through items which don't have aftercast delay or cast time now don't overwrite the former canact_tick. [Inkfish]
	* Multiple autoscripts now can trigger at once. [Inkfish]
	* Applied a temp fix for autoscripts crashing server. [Inkfish]
	* Implemented SC_JEXPBOOST (thanks to GMJobbie for the diff) and SC_IGNOREDEF. [Inkfish]
	* SC_DEFRATIOATK won't affect boss monsters. [Inkfish]
	* Fixed skip_teleport_lv1_menu made lv2 skip menu as well. [Inkfish]
	* Rev. 13843 Updates to ST_PRESERVE and a few other minor details! [L0ne_W0lf]
	- Recasting Preserve no longer toggles the skill off while active.
	- Preserve is no longer saved on log-out or mapserver changes.
	* Added SC_CRITICALWOUND and SC_SLOWCAST to negative statuses not saved with battle_config.debuff_on_logout&1
	* Implemented the skills NPC_HELLPOWER and NPC_WIDEHELLDIGNITY, as per my personal experiences with the skill on iRO.
	* Increased MAX_MOBSKILL to 50, as Satan Morroc has over 40 active skills now.
09/06/03
	* Some clean ups on autocast and itemskill code. (see topic:220921 for some info) [Inkfish]
	- Autocasted Teleport now skips the menu.
	- Fixed nullpo info when defensive autocasts are triggered. (follow up to r13815)
	- Fixed Warp portal used in item script never worked.
	- Item skills now bypass skill delay check.
	- Implemented SM_SELFPROVOKE. 
	- Updated item db using 'itemskill' for some items.
	* Basic skills will never be reset. [Inkfish]
09/06/02
	* Rev. 13840 Implemented the Party Buff cash skills. [L0ne_W0lf]
	* Fixed Mystical Amplification having unlimited duration [Playtester]
	* Fixed skills used through items and Hocus-pocus consume requirements if you have them. (bugreport:3164) [Inkfish]
09/06/01
	* Fixed Fiberlock sometimes fails due to the long interval of skill_unit_timer. It may never fail now, though this may not be official. (bugreport:3136) [Inkfish]
09/05/30
	* Fixed gemstones are still required when players equipped Mistress Card. (bugreport:3147, follow up to: r13815) [Inkfish]
	* Fiberlock only catches targets the moment its casted. [Inkfish]
	* Multiple autocasts can go off at a time now. [Inkfish]
	* Splash damage doesn't get modified by percentual modifier now. [Inkfish]
	* Monster's Spiral Pierce is again...elemental. [Inkfish]
	* Fixed Hocus-pocus always fails. (bugreport:3143, follow up to: r13815) [Inkfish]
09/05/29
	* Added new bonuses bHealPower and bHealPower2. [Inkfish]
	* Heal skills code clean up. [Inkfish]
	- bSkillHeal can affect offensive heal now. 
	- bSkillHeal2 can affect AppleIdun and SlimPitcher now.
	* Added new bonuses bUnbreakableGarment and bUnbreakableShoes. [Inkfish]
	* Some more fixes to skill condition issues. [Inkfish]
	- Fixed skills fail when MAX_INVENTORY reached.
	- Fixed spiritballs not being removed correctly in some situation.
09/05/28
	* Fixed some skill condition issues. [Inkfish]
	- HP is now checked at the end of cast.
	- Lv 6-10 StoneCurse doesn't consume gems when it fails.
	- Tarotcard's aftercast delay will still be applied if it fails.
09/05/26
	* skill_check_condition clean up (bugreport:2770, bugreport:2957, bugreport:3010) [Inkfish]
	- Weapon, SP, HP and state are checked at the beginning of cast.
	- Required items and ammos are checked at the end of cast.
	- SP and status change required are removed at the end of cast without checking again.
	- Required items are removed only if the skill is successfully used.
	- Autocasts won't check for requirements but will remove them if you have them(except for SP/HP).
09/05/25
	* Fixed losing skill list after base change. (bugreport:3106) [Inkfish]
	* Now we can use 'boss_monster' to summon whatever monsters that need to be radared by Convex Mirror. (bugreport:2653) [Inkfish]
09/05/24
	* Taro Card can now break shoes and garment and won't affect dead target. (bugreport:2513) [Inkfish]
09/05/23
	* Splash attacks do cause additional effects except for autocasts. (bugreport:2661) [Inkfish]
09/05/22
	* Fixed some behaviors of additional effects (bugreport:3100,bugreport:2661) [Inkfish]
	- Coma can now be blocked by such skills as SafetyWall, Pneuma and Basilica.
	- Equipment breaking behaves exactly like coma.
	- Skill's self damage may now causes coma, equipment breaking and autospell/autoscript.
	- GrandCross now allows you to drain hp/sp.
	- Splash attack doesn't cause any status effects or autocasts any more.
	* The delay icon doesn't appear during casting now.
	* Status icon of ASPD potions doesn't overriding each other now.
	* NPC_STOP now stops both sides and will be canceled if either side teleports or dies.(bugreport:3099)
09/05/20
	* Now fiberlocking a fiberlocked target doesn't renew the timer but instead increases its fireweakness [Inkfish]
	- This makes doublecasting firebolts on a double fiberlocked target having double damage from both 2 bolts possible = =(bugreport:3061)
09/05/19
	* Added missing packet 0x2c9 and fixed 0x2da's length error. [Inkfish]
	* Fiberlock now can trap multiple enemies on the same cell and its triggering area was reduced to 1x1. [Inkfish]
	* Miracle should only be dispelled on map change. [Inkfish]
	* Fixed the three hits of EarthQuake not being calculated seperately. [Inkfish]
09/05/18
	* Item-bonuses now use the official default durations for status changes [Playtester]
	* status calc code cleanup [ultramage]
	- Inverted the status calc code order, so that status_calc_bl optionally invokes status_calc_pc/mob/whatever instead of every status_calc_* calling status_calc_bl.
	- Inlined functions status_calc_bl_sub_pc, status_calc_bl_sub_hom and status_calc_bl_sub_mer into status_calc_bl.
	- Restructured status_calc_bl to require as little bl type-specific branching as possible.
	- Split status_calc_bl into two layers - the inner does the battle status calculations, while the outer deals with running appropriate base status calculations, remembering old values and handling client updates.
	- The status_calc_bl function is now the single entry-point for all status calculations.
	- status_calc_bl will now trigger a client update only on attributes that actually changed.
	- If hp or sp changes during status_calc_bl, it will now properly refresh on the client.
	- Removed SCB_PC, now SCB_ALL should be used instead.
	- Revived the unused status calc flag SCB_BASE to indicate that a base status recalculation should be done first (that's what the status_calc_* functions are for).
	- Defined a new symbolic bitmask SCB_BATTLE (SCB_ALL - SCB_BASE) in case someone needs to only calculate the battle status (currently unused).
09/05/17
	* Monocell, Instant Death and Class Change will now fail on bosses (bugreport:2907) [Playtester]
	* Eske and Eska now affect friendly guardians and slaves. (bugreport:2131) [Inkfish]
09/05/15
	* AutoSpellWhenHit now triggers on normal+skill by default (bugreport:1652) [Playtester]
	* Removed the undocumented custom level feature from monster spawn lines (bugreport:3076) [ultramage]
09/05/13
	* Fixed combo wait was not canceled when TK's Kick skill was successfully used. (bugreport:1345) [Inkfish]
	* PNEUMA, BASILICA and SAFETYWALL no longer protect you from such negative status changes as COMA, STUN, FREEZE and etc. (bugreport:1346) [Inkfish]
09/05/12
	* Fixed Aid Potion can heal the Emperium (bugreport:164) [Inkfish]
09/05/11
	* Fixed a crash when mob uses self-destruct skill (bugreport:2874) [Inkfish]
09/05/10
	* Magnetic Earth will never stack (bugreport:2568) [Inkfish]
	* Fixed Joint Beat incorrect DEF reduction (bugreport:3051) [Inkfish]
09/05/09
	* Fixed GX's skill level modifier is missing [Inkfish]
	* Fixed some known and unknown player attached NPC timer problems [Inkfish]
	- Attached timer now can be stopped properly.
	- Attached timer will now stop if the NPC is unloaded. (bugreport:2510)
09/05/07
	* Fixed up the base success rate of normal strip skills [Playtester]
	- normal strip skills: 5% + 5%*level
	- Full Strip: 5% + 2%*level
	* Fixed splash damage from Baphomet Card might miss. [Inkfish]
	* Check if group unit is expired before processing it. (bugreport:3054) [Inkfish]
	* Fixed Grand Corss outdated behavior (bugreport:1590) [Inkfish]
	- use new damage formula
	- DEF is reduced to 2/3 during cast time
	- block shields switching within attack duration
	- monsters don't damage themselves any more
	- intervals between hits are 300ms
	* Added check on stackable items to 'checkweight' (bugreport:1569, bugreport:2756, bugreport:2994) [Inkfish]
	* Fixed flee penalty wasn't applied for battleground and wouldn't be restored on map change [Inkfish]
	* Fixed players can pull water from ME cell (follow up to r13730) [Inkfish]
2009/05/04
	* Added the md5() script command. [brianluau]
	* Now if a dead player is moved for whatever reason, he'll be alive with 1 HP. (bugreport:70) [Inkfish]
	* Players now are allowed to copy the skills the level which is beyond the skill_db max. [Inkfish]
	* Fixed some behaviors for Waterball (bugreport:3024) [Inkfish]
	- High level Waterball used by players doesn't increase the number of balls.
	- Monsters can't pull water from cells with Magnetic Earth.
2009/05/03
	* Updated item_db.sql and mob_db.sql from recent changes to both. Thanks to Peter once again! [Jguy]
	* Do not log damage if it's done by mob itself (bugreport:2933) [Inkfish]
	* Fix 'awake' not working (bugreport:2580) [Inkfish]
	* Fix several npctimer issues (bugreport:1619, bugreport:1730) [Inkfish]
	* Players now cannot be revived during pvp respawn delay [Inkfish]
	* Block equipments switching for some skills (bugreport:2900) [Inkfish]
	- cannot change equipments during Arrow Vulcan's cast time
	- cannot change equipments within Desperado's attack duration
2009/05/02
	* Spirit of Bard and Dancer now only works for mastered skills (bugreport:3037) [Playtester]
	- also fixed an outdated comment in the source code
2009/04/27
	* Fixed break equipment debuff working on bosses (bugreport:3023) [Playtester]
2009/04/25
	* Fixed Monster Spiral Pierce not being reduced by Ghostring Card (bugreport:3013) [Playtester]
	- it is forced neutral as its a MISC skill for monsters and doesn't take weapon element
	* First attempt to fix up the strip skills, please make sure these fixes work (bugreport:3011) [Playtester]
	- the minimum rate of strip skills is now 5% for all levels
	- duration of strip skills depends on the dex difference between target and caster and can be reduced to 0
	- strip skills can now affect bosses (if duration doesn't get reduced to 0 due to their high dex)
	- strip skills do a fixed -25% ATK, -15% DEF, -40% VIT or -40% INT independant of skill level
	- autocasting Full Strip has a duration now (if dex is high enough)
2009/04/20
	* Fixed safestrncpy trashing the memory before dst when n == 0. (since r10667) [FlavioJS]
2009/04/15
	* Monster Spiral Pierce is now a ranged misc attack [Playtester]
	- it always gets blocked by Pneuma, but never by Safety Wall
	- Defender doesn't reduce its damage
	- Range-Def item bonuses reduce its damage
2009/04/14
	* Cooking success chance is now affected by DEX and LUK [Playtester]
	- "cooking exp" still needs to be implemented
	- also fixed a small issue when whispering to someone in autotrade
2009/04/01
	* Removed online_check config options. (always active now) [FlavioJS]
	* Clarified char_maintenance config option.
	* Changed packet 0x2712. (added request_id)
	* Changed packet 0x2713. (added sex, request_id, version, clienttype; removed email, expiration time, gmlevel)
	* Delayed user count check and mmo_char_send006b to when the account data arrives.
	* Created auxiliary function MD5_Salt.
2009/03/31
	* Gunslinger Tracking can be canceled if you get hit.
	* Gunslinger Disarm always shows skill animation.
	* Removed custom firetrap effect from Gunslinger mines. [ultramage]
2009/03/27
	* Fixed a problem that blockskill timer failed when there was more than one on a skill [Playtester]
	- please test this, now Asura should be blocked 2 seconds after EVERY Snap
2009/03/26
	* Fixed Spirit of Assassin not reducing the aftercast delay of Sonic Blow [Playtester]
	* Assumptio can neither be cast nor dispelled on monsters anymore [Playtester]
2009/03/23
	* Added support for new status change packet, uses new setting display_status_timers in client.conf. [Sara]
2009/03/18
	* Updated item_db.sql with the perl script [Playtester]
2009/03/08
	* Fixed a couple bugs with marionette control [Brainstorm]
	- Reduces caster max hp by 1000.
	- Job and Equipment bonuses counts toward the 99 limit.
	- Fixed stat overflow on baby targets with stats over 80 (bugreport:2232).
	- Fixed clowns being able to cast it on another bard/clown (same for gypsy/dancer) (bugreport:166).
	- Caster is no longer blocked from using items.
	* Added several mail id checks to prevent a map server crash (bugreport:2837)
2009/03/02
	* Blade Stop status no longer prevents item use and equip changing.
	* Against non-players, Blade Stop skill will now only activate if the attacker is at most 2 cells away (1 if barehanded).
2009/03/01
	* Fixes from 2008/10/13 bugreport:2077 (Only commiting because nobody did until now and those bugs would get lost)
	* Fixed monster's Spiral Pierce, now it is always blocked by Pneuma.
 	* Fixed Monk Absorb Spirits mana recovery per spirit absorbed, 7, not 10.
 	* Fixed Monk spirit balls not being removed on death (like happens with gunslingers).
 	* Fixed Swordman Auto-Berserk sp cost, 1, not 5. Should be 0, but eA wont allow the skill to work.
2009/03/01
	* Ankle Snare cannot be knocked back anymore (bugreport:2804) [ultramage]
2009/02/25
	* Wrong variable being used in StringBuf_Vprintf. (follow up to r13386, fixes bugreport:2798) [FlavioJS]
2009/02/23
	* Made mob_delayspawn check the spawn_timer in the mob. [FlavioJS]
	* Added missing delete_timer's every time spawn_timer is being set. (except when allocating)
	* Made mob_timer_delete check the deletetimer in the mob.
	* Added missing delete_timer's every time deletetimer is being set. (except when allocating)
	* Consolidated is_atcommand() and is_atcommand_sub() [SketchyPhoenix]
	- replaced gmlvl arg with a flag arg for internal/player generated checks. (dummy sds that used this arg are given gm levels)
	- each command check runs through is_atcommand() and is checked for its origin (internal or player generated)
	- charcommands are also parsed in this function.
	- script atcommand/charcommand function calls to is_atcommand() have been updated
	- also updated some clif/map functions calls to is_atcommand()
	* charcommands should now log properly with the target of the command included.
2009/02/20
	* Increased variable size for status/skill points to remove the 65k cap (bugreport:1579) [ultramage]
	* Modified WFIFOSET to trigger a fatal error when trying to send a packet that is too big. [FlavioJS]
2009/02/19
	* Fixed improper filling of w4 in npc_parsesrcfile when there are less than 4 fields. (bugreport:1063) [FlavioJS]
	* Simplified atcommand_spiritball. (deprecated msg_txt 204 and 205)
2009/02/06
	* Follow up to r13485. (bugreport:2741) [FlavioJS]
	- @spiritball creates spiritballs without timer (limited to the array size instead of 500)
2009/01/25
	* Changes to the configure script: [FlavioJS]
	- added option --enable-profiler (supports gprof)
	- added option --enable-64bit (don't force 32bit)
2009/01/24
	* Changed pc_spiritball_timer and pc_addspiritball: (bugreport:2705)
	- don't make assumptions about the calling order of timers
	- ensure that sd->spirit_timer is ordered by expiration time
	* Changed the variables of the mapcache structs to fixed size equivalents.
	* Changed all uses of struct skill_unit_group* to group_id in status_change_entry's. [FlavioJS]
2009/01/23
	* Changed npc_get_new_npc_id to ensure that it never returns invalid/used ids. [FlavioJS]
	- npc_get_new_npc_id is used to generate ids for npcs/mobs/homunculus/mercenaries/pets.
	  If the server runs for long enough (years to months or less, depending on settings),
	  the auxiliary variable npc_id will eventually overflow and go negative, then go 
	  through the range of object ids, then through the range of account ids.
	  This can lead to all sorts of random crashes and memory leaks.
2009/01/22
	* Changed val4 of SC_BLADESTOP from a block_list pointer to an id. [FlavioJS]
2009/01/21
	* Added a limit of 1MB of pending data in the write fifo for non-server sockets.
	  Connections that go over the limit are closed.
	* Replaced the fake timer heap (sorted array) with a real heap. (improves performance) [FlavioJS]
2009/01/20
	* Added a generic binary heap implementation based on defines. [FlavioJS]
	* Fixed pc_statusup2 to correctly update the client's stat window [ultramage]
2009/01/15
	* Updated script_commands.txt with the book reading command. [SketchyPhoenix]
	* Added/reworded/removed comments out of r13450
2009/01/14
	* Added client login packets 0x01fa and 0x027c. [FlavioJS]
	* Other minor cleanups.
	* #commands used by nonGM players now appear in the chat like normal rather 
	  than being processed and ultimately failed, printing out failed command messages 
	  that should be visible to only GMs.
2009/01/13
	* Cleaned up command @users/#users: [FlavioJS]
	- displays everything on the target user (self for @users)
	- uses a static array instead of a temporary DBMap
	- displays percentages with precision of 0.01%
	- uses safesnprintf instead of sprintf
2009/01/12
	* Mobs with nonzero spawn time can now be cached as well (bugreport:1197)
	* Fixed dynamic mobs being unloaded without stopping their respawn timer
	* Added regen_db to reduce hp/sp processing delays (bugreport:2256) [ultramage]
	* #command parsing cleaned up. [SketchyPhoenix]
	- Fixed charname reading problems from r13441 
	- Corrected agitend typo to agitend2 (bugreport:2654)
2009/01/05
	* Fixed @mobsearch and @showmobs (bugreport:2481) [ultramage]
	- now only search for mobs on the same map as the caller
	- now properly distinguish between dead and alive mobs
	* Added @charcommands to return a list of available charcommands (bugreport:2630) [SketchyPhoenix]
2008/12/31
	* Changes to the script engine: [FlavioJS]
	- new stack datatype script_retinfo for C_RETINFO to hold all the return state info 
	  that was being stored in the stack. (the script engine in 64bit-ready now)
	- pop_stack is responsible for adjusting all the stack pointers.
	- push_* returns the created script_data.
	- 'return' only converts to value scope variables of the current scope.
2008/12/30
	* Changes to the script engine: [FlavioJS]
	- script ends when run_func can't find the buildin command. (script engine error)
	- run_script_main doesn't change RERUNLINE to RUN automatically,
	  the buildin command that set it is responsible for that now.
	  The buildin command can use this to detect a rerun.
	- created functions to alloc/free a script_state.
2008/12/28
	* Added missing command #delitem. [SketchyPhoenix]
	* Fixed charcommand behavior where those that can accept a name with no additional parameters 
	  being able to execute under said player's name with the name as a parameter. (bugreport:2601)
2008/12/25
	* Extended sv_escape_c to escape '\a','\b','\t','\v','\f','\?' characters 
	  to their respective representations instead of octal. [FlavioJS]
2008/12/22
	* Added a few missing atcommands. [SketchyPhoenix]
	* Added more commands to configurations (bugreport:2565)
	* Added a missing charcommand symbol config to atcommand configs.
	* GM command configs under the old format will have a warning printed back to the console as being deprecated.
	* Other fixes/cleaning partially resolving bugreport:2549
2008/12/20
	* Extended how duplicates work: (based on Orcao's work in bugreport:2361) [FlavioJS]
	- you can duplicate warps/shops/cashshops/npcs (before only npcs could be duplicated)
	- warp duplicates inherit the target location
	- shop/cashshop duplicates inherit the item list
	- npc duplicates inherit the script code (backward compatible behaviour)
	- updated script_commands.txt with the information
2008/12/17
	* Removed charcommand code and allowed atcommand code to support its functionality. [SketchyPhoenix]
	- Charcommands still retain their '#' symbol but now looks for a character name as the first parameter instead of last.
	- Atcommand configs now support charcommand level configurations by comma seperation (e.g. 60,99).
	- As a result of this, all atcommands that don't affect multiple users already (@kickall, @doom, @mapexit) are capable of remote usage.
2008/12/01
	* Fixed rare crash when using Flying Kick on clones (bugreport:2506) [ultramage]
	* Corrected Flying Kick's debuff rules to match official servers
	- only works on players
	- soul linkers and stalkers with Preserve active are immune
	- only removes Berserk Potion, Kaahi, Kaite, 1HQ, AAR and Soul Links
2008/11/27
	* Fixed a memory leak when returning a string variable in the script engine. [FlavioJS]
	  (since r9864/r9865, fixes bugreport:2488)
2008/11/24
	* Fixed a va_end using the wrong variable. (from r13383, fixes bugreport:2483) [FlavioJS]
2008/11/22
	* Readded code that was removed from atcommand_showmobs by mistake in the previous commit. (r13383)
	* Hunted down improper uses of va_list variables.
	* Hunted down the simpler 64bit pointer truncations. [FlavioJS]
2008/11/18
	* Rev. 13375 Autotrade characters will no longer get caught by Urgent Recall. (bugreport:2447) [L0ne_W0lf]
2008/11/11
	* Updated script_commands.txt [FlavioJS]
	* Made scripts terminate with an error: (fixes bugreport:2429)
	- when delitem/delitem2 tries to delete more items than the player has
	- when trying to set Zeny to a negative number.
2008/11/09
	* Added a check to make sure killed monster's level was greater than half of the mercenary owner's level before incrementing mercenary's killcount. (bugreport:2410) [Paradox924X]
2008/11/07
	* Rev. 13358 Changed how mobcount works since it wasn't counting last mob death. (bugreport:2419) [L0ne_W0lf]
2008/11/06
	* Fixed 'Char creation denied' message not being sent properly. [FlavioJS]
	- Number 2 didn't exist in old clients so it used the default message,
	  now it exists so the wrong message is displayed.
	- Changed 2 to 0xFF to get the default message.
2008/11/05
	* Fixed issue preventing you from changing to the original cart when using Change Cart. (bugreport:2383) [Sara]
2008/10/29
	* Novice skill, Trick Dead, will no longer be granted to classes upon reset (save for Novice and Baby) (bugreport:2312) [SketchyPhoenix]
2008/10/28
	* Made script command "unequip" call status_calc_pc. Thanks to Orcao. (bugreport:2368). [Paradox924X]
2008/10/27
	* Fixed all overflow checks and made the code a bit cleaner from r13322. [Paradox924X]
	* Removed leftovers of "bLoseSPWhenUnequip" and "bDamageWhenUnequip". [Paradox924X]
2008/10/24
	* Added protection from segfault by int overflow in charcommand heal and fixed a typo in atcommand heal. (Follow-up to r13321) [Paradox924X]
	* Added protection from segfault by int overflow in atcommand heal. (bugreport:1886) [Paradox924X]
	* Commented out unused function clif_marriage_process. [Paradox924X]
2008/10/21
	* Added a check to make sure a player wasn't in a guild when they accepted a guild invitation. [Paradox924X]
2008/10/18
	* Corrected a target checking problem brought about with Kaizel/Osiris combination. [SketchyPhoenix]
2008/10/16
	* Added missing char_sql/int_mercenary files to txt-converter's Makefile.in. [FlavioJS]
2008/10/15
	* Fixed ipban sql connecting to the sql server when disabled. [FlavioJS]
2008/10/11
	* Using Kaizel in conjunction with Osiris Card should now work. (bugreport:2251) [SketchyPhoenix]
	* #monsterignore should turn off now. (bugreport:2306) [SketchyPhoenix]
2008/10/09
	* Rev. 13272 Updated NPC_REBIRTH. Has it's own values, and no longer leeches off SL_KAIZEL. [L0ne_W0lf]
2008/10/06
	* Rev. 13264 Damage count on rebirthed mobs is now reset. (Valaris)  [L0ne_W0lf]
	* Rev. 13263 voided out clif_blown as per Valaris' instruction.  [L0ne_W0lf]
	* Rev. 13262 SC_WEIGHT50 and 90 are no longer removed on death. (bugreport:2316) [L0ne_W0lf]
2008/10/04
	* Delete ST_LOGIN auth in chrif_disconnectplayer (followup to r13256, bugreport:2292) [FlavioJS]
2008/10/03
	* Fix for "yet another online check bypass technique". (bugreport:2292) [FlavioJS]
2008/10/01
	* Rev. 13252 Kaupe will now trigger from mobs, homuns and mercenaries, as well. (bugreport:2297) [L0ne_W0lf]
	* Rev. 13251 Removed 'casttime' adjustment from offensive ressurection. Follow up to r13225. [L0ne_W0lf]
	* Kaahi will now override override higher existing levels previously casted. (bugreport:2296)
2008/09/27
	* Fixed clif_changelook betraying the presence of gm-hidden players (bugreport:2283) [ultramage]
2008/09/11
	* Rev. 13226 Corrected Lex Divina not showing animation on fail. (bugreport:1740) [L0ne_W0lf]
	* Rev. 13225 Corrected Offensive Res using Turn Undead cast time. (bugreport:1704) [L0ne_W0lf]
2008/09/11
	* Rev. 13204 Made the mail check on login read from msg_athena.conf. [L0ne_W0lf]
2008/09/09
	* Rev. 13202 Added commands related to WoE SE, allowing it to run independantly of WoE. [L0ne_W0lf]
	- Added: @agitstart2, @agitend2, agitstart2, agitend2, and agitcheck2.
2008/09/05
	* Rev. 13192 Updated mmo.h, increased merc max count to 36. [L0ne_W0lf]
	* Fixed save crash related to non-guilded mercenaries.
2008/09/01
	* Removed hardcoded equip position names from getequipname (bugreport:2156)
	- now it's the npc's responsibility to store and display the names
2008/08/28
	* Fixed @cash/@points not handling negative values properly (bugreport:2132) [ultramage]
2008/08/26
	* Fixed @agjgmlvl bug preventing its use on other players. (bugreport:2124) [SketchyPhoenix]
	* pc_isGM() checks in gm_cant_party config checks will now check against being lower or higher than lowest_gm_level config.
2008/08/25
	* Fixed homun sp regen bug introduced on r12953 bugreport:2071 [Brain]
	* Fixed: several compiler warnings [akrus]
2008/08/20
	* Rev. 13098 Implemented Brainstorm's and SketchyPhoenix's fixes for Flying side kick. [L0ne_W0lf]
	- Skill will now remove KA-type statuses and not remove stalker's link while preserved.
2008/08/19
	* Fixed a storage saving issue with txt charserver (bugreport:2084) [ultramage]
	- caused by incorrect idb_ensure -> idb_get change (see r12950)
	- removed redundant account_id variable from storage data
	- cleaned up the very messy txt storage handling code
	* Added global sql settings 'sql.*' to inter_athena.conf.
	* Made account, ipban and loginlog use the global sql settings when the hostname is empty.
	* Commented 'ipban.sql.*' and 'account.sql.*' so they default to the global settings.
	* Removed deprecated settings 'case_sensitive' and 'add_to_unlimited_account' from in login_athena.conf.
	* Made inter_athena.conf be imported from login_athena.conf instead of being handled separate.
	* Changed ipban to get the failed login attempts of an ip from loginlog
	  (respects if loginlog is enabled or not). [FlavioJS]
2008/08/16
	* Added a mapreg txt->sql converter script to /tools, because the sql
	  mapserver doesn't read the txt mapreg savefile anymore and people
	  will most likely want to preserve their global variables.
	- script is php-based and requires the php_mysql module
	- script produces a series of INSERT statements, ready to be imported
2008/08/15
	* Split off mapreg code from script.c [ultramage]
	- new mapserver files, mapreg.h, mapreg_txt.c, mapreg_sql.c
	- removed MAPREGSQL from project files / makefiles
	- mapreg storage engine is now fully dependent on the server type
	- added config settings mapreg_txt and mapreg_db to inter config
	- added get_str() function to complement add_str()
	- fixed txt mapreg code allowing too long variable names
	* Removed gm_cant_party_max_lv. It now uses gm_cant_party_min_lv as the threshold. (bugreport:2051) [SketchyPhoenix] 
2008/08/11
	* Fixed right-click npc unload not unloading duplicates (bugreport:2014)
2008/08/09
	* Fixed @noks leaking internal buffer contents (bugreport:1528)
	* Now Novices without lvl5 basic skill can be partied (bugreport:1131)
	* Fixed login printing raw passwdenc passwords to console (bugreport:826) [ultramage]
	- added strlib function bin2hex()
	- cleaned up the md5calc interface a bit
2008/08/07
	* Added another GM trust config for party invitations (bugreport:2004) [SketchyPhoenix]
2008/08/04
	* Added configs for quest table name adjustment (bugreport:1778)
2008/08/02
	* Player shops will not close on death anymore (bugreport:1955)
2008/08/01
	* Removed unused guardian hp columns from the castles table in main.sql.
	* Corrected incorrect use of the datetime column in the `login` table. [ultramage]
	* Quagmire now will affect boss monsters, but more info is required to code the debuff exceptions properly. [Brainstorm]
2008/07/31
	* Fixed: added 'E'-type zenylogs in sql table (bugreport:1957) [akrus]
	- added sql file upgrade_svn13025_log.sql
	* Improved: added --enable-debug=gdb option in configure script to use gdb optimized debug mode [akrus]
	* Removed the mob controller system, now a customization (see topic:194375) [ultramage]
	* Fixed: commented out loginlog in convert engine sql tables (loginlog table is in logs database now) [akrus]
2008/07/30
	* Fixed TXT storage code handling storage incorrectly (bugreport:1928)
	* AccountDB_TXT will now correctly read inconsistent EOLs (bugreport:1934)
	* Removed the IRC bot system, now a customization (see topic:194306)
2008/07/29
	* Renamed struct 'skill' to 's_skill' to remove naming collisions.
	* Added defines for mercenary skill ranges.
	* Added a mapping of mercenary skills to the skill db (700-799 atm).
	* Fixed Sql object not initializing default values properly.
	  Fixed Sql_Free producing timer deallocation errors when called
	  without first establishing a database connection.
	* Corrected upgrade_svn12975_view.sql not assigning default values
	  to the two dummy columns; please drop the view and re-run the script.
2008/07/27
	* Fixed md5 passwords not working
	* Possibly corrected a guild saving problem (bugreport:1908)
	* Removed some leftover code that shouldn't have been merged [ultramage]
	* Fixed a memory leak in mmo_auth_tosql (extra sql statement being allocated).
	* Added missing option 'log_db_db' to loginlog_config_read(loginlog_sql.c).
	* Fixed a memory leak in account_db_sql_destroy. [FlavioJS]
	* Changed the way GM levels are handled
	- removed conf/gm_account.txt
	- added the gm level column to the txt savefile (after 'email' column)
	- gm level information is now transferred along with account data
	* Merged the /loginmerge branch [ultramage]
	- the login server storage, ipban and logging systems have been abstracted
	  and now provide a common interface; the rest has been merged into a
	  single login server core (no more login/login_sql duplicity)
	- storage systems are now added via compiler options (WITH_SQL / WITH_TXT)
	- multiple storage engines can be compiled in at the same time,
	  and the config option account.engine defines which one will be used.
	- due to MySQL autoincrement limitations, accounts with id '0' will not
	  be supported; account IDs from this point on should start from '1'.
	- login_log() functions now again record IP addresses in dotted format,
	  not as 4-byte integers (undo from r6868).
	- removed config options that defined column names in the login table
	- removed `memo` and `error message` columns from login db/savefile
	- moved `loginlog` table to the logs database
	- added sql files upgrade_svn12975.sql and upgrade_svn12975_log.sql
	- due to changes to the login table layout, I added an !optional! sql
	  file (upgrade_svn12975_view.sql) that will provide a certain degree
	  of backwards compatibility with existing software;
	  read the instructions inside carefully!
	- moved third-party includes/libs to a separate directory
	- updated project files / makefiles

2008/07/20
	* Simplified the search in pop_timer_heap and added more debug info to help 
	  determine the source condition of timer errors. (bugreport:1860)
	* Fixed crash in skill_castend_id. (bugreport:1860) [FlavioJS]
	* Corrected #storagelist target typo (bugreport:1873) [SketchyPhoenix]
	
2008/07/16
	* Added a check to make sure only released timers are acquired from the free list.
	* Changed TIMER_MAX_INTERVAL to 1 second (was set to 1 minute by mistake). [FlavioJS]
	* Fixed TK_JUMPKICK, should not jump over objects and cliffs.
	- This also might fix them being able to jump barricades on WoESE. [Brainstorm]
	
2008/07/15
  * Updated WoE Time Explanation for Sunday. [Paradox924X]
	* Corrected wrong data loading order in txt storage code [ultramage]
	* Fixed pop_timer_heap using max heap comparisons instead of min heap comparisons
	  and protected timer functions against improper use. (should fix bugreport:1833 bugreport:1841) [FlavioJS]

2008/07/14
	* Made homunculi have doubled regen rates (they regen twice as fast) defined on battle configs. [Brainstorm]
	* Corrected compiler warning and error made from r12952 and r12953, respectively. [SketchyPhoenix]

2008/07/13
	* Modified storage data loading (bugreport:1425) [ultramage]
	- storage is now loaded/saved along with character status
	- as a consequence, a lot of storage handling code was removed
	- there is no more locking done within storage data
	- mapservers no longer cache the data (solves muiltimapserver exploit)
	- loading storage on char select may decrease charserver performance
	* Added missing picklog case [Konard]
2008/07/12
	* Fixed a bad check on NPC_EVILLAND, actually healing players instead of doing damage. [Brainstorm]
2008/07/10
	* Users can't click floating npcs directly. (quick fix for bugreport:1814) [FlavioJS]
2008/07/09
	* Fixed SG_FUSION hp penalty (0.5% to 2%), bugreport:1805 [Brainstorm]
	* Added const to the return value of get_timer.
	* Added a maximum timer interval. Avoids server shutdowns being delayed 
	  for ~10 seconds under some circumstances on windows.
	* Replaced the fake timer heap (ordered array) with a binary min heap. [FlavioJS]
2008/07/07
	* First attempt at implementing the official walk speed system
	- separated speed modifiers into bonuses, penalties and other statuses
	- no bonuses stack, instead the maximum is taken
	- no penalties stack, instead the maximum is taken
	- Union, Riding and Pushcart are the only other statuses that stack
	- both bonuses and penalties are linear modifiers of the base walk speed
	- 'other' statuses are applied after bonuses and penalties
	* Changed many equations to match official walk speed system
	- Steel Body now sets a fixed walk speed of 200 (bypassing everything else)
	- Defender now caps the walk speed to a minimum of 200
	- Slow Grace now uses official equation for aspd/walk speed decrease
	- Pushcart's speed penalty is now halved
	- Free Cast now changes walk speed to a fixed value, bypassing bonuses and penalties
	- Wedding clothes now have a penalty of +100%, not +200%
	- rogue's Tunnel Drive and stalker's Chasewalk ignore all penalties
	- taekwon's Running is now 5% faster
	- Frenzy is now 5% faster
	- Gospel's offensive slowdown is now +75% instead of +33%
	- Quagmire now slows down by +50% instead of +100%
	- Gatling Fever now slows down by +100% instead of +33%
	- Cloaking modifier is now a bonus/penalty, depending on presence of wall
	- Longing for Freedom overrides the song/dance penalty (bugreport:416)
	- Bard/Dancer Spriit now properly affects song/dance penalty (bugreport:1019)
	- item-granted speedup no longer stacks with speed bonuses (topic:145019)
	- removed some status code that pre-calculated speed bonuses/penalties,
	  to make calculations more localized and less messy (see song/dance code)
	* Removed stop/slowdown effect from Grimtooth (bugreport:1806)
	* Players autotrading will not be able to receive whispers (bugreport:1804) [SketchyPhoenix]
2008/07/06
	* Slight cleanup of item-based walk speed bonuses [ultramage]
	- removed bSpeed bonus code (was just disabled until now)
	- changed speed_rate to use base value 0% instead of 100%
2008/07/05
	* Moved the mob killmonster flag to a more appropriate area. (bugreport:1795) [SketchyPhoenix]
2008/07/04
	* Fixed AM_PHARMACY produce chances based on info gathered by flaviojs, aegis zone ep 11.2, of 20070629 [Brain/FlavioJS]
	* Rev. 12912 Homunculus will no longer auto-vaporize on master death. [L0ne_W0lf]
	- Added config option to allow for this to be turned on or off.
	* Added missing 'E' logs to mail system [Lupus]
2008/07/03
	* Removed aspd penalty from Free Cast since tests show it's not there,
	  even though RO sites claim it is
	* Adjusted Free Cast code so that its walk penalty gets calculated in
	  status_calc_speed and nowhere else [ultramage]
	* Fixes regarding bugreport:1727 (undead element/race skill behaviors) follow up on revisions r12820 r12821 and r12822 [Brainstorm]
2008/06/24
	* Rev. 12891 Increased Item group limit for new item groups. [L0ne_W0lf]
2008/06/23
	* Fixed: replaced TYPEs with ENGINEs in SQL files (for better compatibility, TYPE is a synonym) [akrus]
2008/06/22
	* Extended script command 'set' to return the variable reference (topic:190602). [FlavioJS]
	* Fixed a bug where the "OnMyMobDead" event wouldn't trigger if the mob was killed and never attacked. (bugreport:1725) [SketchyPhoenix]
	* Reworded a comment in can_copy to make more sense.
	* Modified *killmonster and *killmonsterall to support a new argument that will allow it to kill monsters using the new OnMyMobDead behavior (in order to avoid breaking older scripts) (bugreport:1734)
2008/06/19
	* Added Sirius_White's fix for sense working on emperium. (bugreport: 1679) [SketchyPhoenix]
	* Fixed SC_CHANGEUNDEAD behavior: Blessing and Increase AGI deals 1 damage and does not apply buffs to those inflicted by it.
2008/06/18
	* Added a fix for refresh properly displaying dead and sitting players. [SketchyPhoenix]
	* Fixed basilica behavior not knocking back monsters 2 cells should one attempt to enter the field.
	* Fixed cash shop not using points to make up the cash difference when purchasing an item.
2008/06/17
	* Forgot to commit source modification from r12833 (Updated Novice grounds.) [L0ne_W0lf]
2008/06/16
	* Made the socket limit not be set in cygwin, which has bogus behavior. (bugreport:1684) [FlavioJS]
	* Made the socket limit be set to the maximum allowed value when setting to FD_SETSIZE fails.
2008/06/14
	* Fixed Icewall not restoring the original cell type [ultramage]
	* Fixed PF_FOGWALL working on Boss monsters. [Brainstorm]
2008/06/13
	* Fixed Evil Land working versus undead element instead of undead race.
	* Fixed Grandcross and darkgrandcross, should only cause blind against undead race.
		Also confirmed that ME, evil land, sanctuary, grandcross/DGC and status recovery are versus element, not race.
	* Removed confusion effect part from AL_CURE, it doesnt work on official anymore.
	* Partial revert of signum crucis modification, it doesnt work against players, but work on ELEMENT undead monsters.
	* Corrected dc_serviceforyou bonus values based on irowiki (better have fansite info than 100% guessed info).
	* Fixed dc_humming only recieving half the bonus from dancing lessons.
	* Fixed some skills working on undead element when they were supposed to work on undead race. [Brainstorm]
		Skills Fixed: Cure, Signum Crusis, Blessing, Demons Bane, Divine Protection.
		Skills needing confirmation: Magnus Exorcismus, Evil Land, Sanctuary, Status Recovery, GrandCross, Dark GrandCross, Head Crush

2008/06/12
	* Added check to prevent crashing on logmes with no player attached
	  (bugreport:1648) [ultramage]
	* Added support for skill names to script commands: [FlavioJS]
	- skill, addtoskill, guildskill, getskilllv, getgdskilllv, itemskill, 
	  petskillattack, petskillattack2, petskillsupport, skilleffect, 
	  npcskilleffect, unitskilluseid, unitskillusepos
	- bonus/bonus2/bonus3/bonus4/bonus5 for bonuses bAutoSpell, bSkillAtk, 
	  bSkillHeal, bAutoSpellWhenHit, bAddSkillBlow, bCastrate
2008/06/11
	* Added partylock/guildlock checking for @changeleader/@changegm
	  (bugreport:72) [ultramage]
2008/06/10
	* Fixed double attack working with unarmed attacks, as reported by Lone Wolf. [Brainstorm]
	* Added experimental code to set the socket limit at runtime. [FlavioJS]

2008/06/09
	* Fixed SN_SHARPSHOOTING doing 100% atk less damage than it should, bugreport:1654
	* Fixed Active Guild skills not working when WoE is OFF, follow up on r12770, bugreport:1653 and bugreport:1637
	* Fixed Fire Pillar (and any future splash damage magical trap) not working on Land Protector.
	* Fixed reject sword having a infinite duration, bugreport:695 [Brainstorm]

2008/06/08
	* Implemented the two-handed staff/rod type
	* Corrected definition of 'delitem' and 'delitem2', which prevented the
	  optional accountid parameter from working (bugreport:1512) [ultramage]
	* Fixed SA_DISPELL removing SC_CRITICALWOUND. [Brainstorm]
2008/06/07
	* Swapped the W_SHOTGUN and W_GATLING weapon type IDs [ultramage]
	* Fixed GD_EMERGENCYCALL not working inside gvg castles when WoE is off, bugreport:1637 fix by Meyraw [Brainstorm]
	* Kaite should not work against high-level mobs (bugreport:1623)
	* Fixed 'soundeffectall' not reading its params correctly [ultramage]
	* Fixed PF_DOUBLECASTING casting % bugreport:140 
	* Fixed a few properties of NPC_CHANGEUNDEAD bugreport:79 [Brainstorm]
2008/06/01
	* Added Ai4rei's "gm can view all players' equips" feature [ultramage]
2008/05/31
	* Crashfix to attach/detach timers, thanks to Konard (fixed recent crashes) [Lupus]
2008/05/28
	* Updated Ankle Snare duration (bugreport:1438) [Playtester]
	- agi now has only half the effect on the duration (100 agi reduces it by 50%)
	- minimum duration is 5 seconds no matter what
	* Fixed stat values displaying incorrectly when increasing them
	  past 255 (wraparound, ack packet only has 1 byte) [ultramage]
2008/05/26
	* Updating configure script: [FlavioJS]
	- fixed memory manager using the argument of the last enable/disable option (any option)
	- other minor changes
	* Increased the allowed packet size for chat messages [ultramage]
	- changed the capacity of the message column in chatlog (see sql update)
2008/05/25
	* Increased storage space to 600 [Playtester]
2008/05/24
	* Updated sql files to latest [Toms]
2008/05/16
	* Fixed 64bit timestamps messing up auction/storage (bugreport:1454)
	* Added sd state to track party creation/invitation (bugreport:1180)
2008/05/13
	* Fixed a mistake in r11344 that caused the 'my shop' window to display
	  info about cards slotted in items incorrectly (bugreport:1502)
2008/05/12
	* Fixed a script engine problem where warping away while having a menu
	  window open and talking to an another npc with a menu would produce
	  menu option count mismatch errors (bugreport:1208)
2008/05/10
	* Fixed @showmobs not working (bugreport:1487)
2008/05/09
	* Added correct extended info packets for items that are being moved
	  into storage or cart. This caused items to visually lose their
	  properties once they have been moved from inventory (bugreport:250).
	  The modification is mostly copypaste but it works nicely [ultramage]
2008/05/07
	* Corrected default guild positions not being saved during guild creation.
	* Did some cleanup of the splash code, the NPC_WIDE* skills now send the
	  'preamble' packet, which for the most part correct their skill animation
	  display.
	* Fixed Sense messing up with Spiderweb.
	* Added Throw tomahawk to the list of items that do not trigger the
	  equipment breaking code.
	* Probably fixed Moonlight petals pushing back the casters.
	* Infinite Endure won't be passed on to devoted characters.
	* Infinite Endure is no longer saved on logout.
	* Added check to avoid gms opening vending shops if they don't have the
	  required level.
	* Fixed the flee penalty not applying when you walk into a gvg map. [Skotlex]
2008/05/03
	* NPC_GUIDEDATTACK is not supposed to bypass pneuma/safetywall [ultramage]
2008/05/02
	* Fixed missing iterator destruction in the map_foreach* functions (followup to r12684).
	* Added backward compatible handling of PACKETVER 8 and 9. (followup to r12539)
	* Changes to map_foreach* functions: [FlavioJS]
	- removed the unecessary use of va_copy in map_foreachpc
	- applied the same function pattern to map_foreachmob and map_foreachiddb
	- created map_foreachnpc
	- extended the behaviour of map_foreach* functions to stop iterating when func returns -1
	* Replaced the very ineffective clif_foreachclient() with map_foreachpc() since they essentially do the same thing (bugreport:1174).
	* Rewrote map_foreachpc() so that its callback function signature now uses a more natural 'sd' instead of a DBKey/void* pair.
	* Rewrote atcommand_users() to use a single function, instead of depending on two helper functions and global objects.
	* Added a custom implementation of the va_copy macro for systems that don't provide it.
	* Fixed varargs not being used correctly in foreach() calls in db.c (bugreport:551).
	* Replaced the integers+checking approach in r12679 with usage of floating point arithmetic.
	* Applied search&replace to use the new name of the function.
	* Implemented get_percentage() for compact and safe calculation of percentual values.
	* Fixed integer arithmetic overflows that were occuring in several supernovice checks (bugreport:1135). [ultramage]
2008/05/01
	* Updated mob_db.sql to latest [Toms]
2008/04/30
	* Rev. 12676 Corrected several effect descriptions. [L0ne_W0lf]
2008/04/28
	* Cleaned up char server set online/offline/char select functions. (r12670) [Kevin]
2008/04/27
	* Fixing some timestamp type difference warnings...
	* Removed the calc_times() no-op (bugreport:1289).
	* Corrected r12662 where a guild break would trigger the OnGuildBreak event for all castles (even of other guilds).
	* Corrected some x64 compilation warnings in ers/malloc files.
	* Cleaned up a case of bad variable reuse.
	* Cleaning up the itemdb reload mess (see r12635, r12643, r12650, r12661, r12662, r12663): [ultramage]
	- the player data inventory-itemdb index is now refreshed using pc_setinventorydata()
	- mobdb will no longer initialize with nonexistent items, and mobs will no longer drop them in case of a reload
	- the clif_buylist() function once again hides invalid npc shop items
	- it is no longer possible to purchase nonexistent items from a npc shop
	- npc shop loading will not abort if there is a nonexistent item entry, it will just skip over it 
2008/04/26
	* Added script function hasquest. [Kevin]
	* Fixed OnGuildBreak. [Kevin]
	* Cleaned up auth system after change back to map server request.
	- Created function set_char_charselect to get rid of some of the "special case" variables.
	- Removed code that involved the char server sending auth data at char select.
	- Changed char select code to update the instance of the char data in the DB
	  to fix map/sex info not being propagated to auth request. [Kevin]
	* Rev. 12657 Added WoE SE castles to castles.txt in save-tmpl. [L0ne_W0lf]
2008/04/25
	* Updated item_db.sql to latest
	* Fixed bugreport:1223 (Invalid Items In Shops Are Processed Incorrectly)
	* Modified delitem/delitem2 to have the same behaviour as getitem/getitem2 (optional
	  account_id parameter) bugreport:1035
	* Modified doc in consequence [Toms]
2008/04/23
	* Fixed script strings not being handled properly (only skipped the \).
	* Added skip_escaped_c to strlib.c/h.
	* Fixed sv_unescape_c not handling hex/octal escapes properly.
	* Script parse errors displayed with one ShowError instead of several ShowMessage's. [FlavioJS]
2008/04/22
	* Changed itemdb_reload to clear the database before reloading, so it is possible
	  can remove an item from the DB without restarting the server (bugreport:1348) (r12635). [Kevin]
	* Fixed a "bug" in sv_readdb under windows and cygwin configured as "Unix/binary" for text
	  files ('\r' is read and empty lines are not skipped) bugreport:1382 bugreport:1401 [Toms]
2008/04/21
	* Changed the data field of timers from int to intptr.
	* Added intptr/uintptr to cbasetypes.h (integers with the same size as a pointer). [FlavioJS]
	* Rev. 12631 Changed Sacrifice status to end on caster's death, not at 25% HP. [L0ne_W0lf]
	- Should also fix over-flow damage returning to sacrificed targets. Partially fixes bugreport:1332
	* Updated sql files to latest [Toms]
2008/04/19
	* Made some cleanup in changesex [Toms]
	* Fixed a bug in (init/start/stop)npctimer [Toms]
2008/04/18
	* Fixed a bug when unloading a npc near a shop.
	* Fixed npc_buylist not giving/checking the good item when it was an
	  item_avail in the shop (the real one was added in inventory).
	* Implemented config setting 'vending_over_max', to let people configure
	  the behavior of vending items over the MAX_ZENY limit [ultramage]
	* Fixed mapserv crash, thanks to Konard [Lupus]
2008/04/17
	* Modified sv_readdb to be able to process non-native line terminators (bugreport:1382) [ultramage]
2008/04/16
	* Fixed an issue in r12575 where 'not setting char offline when going from mapserver to charserver' also caused a permanent account lockout if the player pressed 'cancel' in the char select screen.
	* Merged some recent changes from SQL to TXT, as someone didn't bother to do it.
	* Ifdefed the quest data request code as SQL-only (this was causing server disconnects whenver someone logged in). [ultramage]
2008/04/15
	* Use the same code for script commands getitem & getitem2 as @item to avoid
	  bug in bugreport:1324 (non-stackable items are stacked) [Toms]
	* Removed all _ in the second name in item_db.txt and updated item_db.sql [Toms]
	* Added a forward declaration of the struct quest instead of including mmo.h [Toms]
	* Corrected some invalid syntax in skill_db.txt (wrong usage of commas)
	* Renamed BA_FROSTJOKE to BA_FROSTJOKER (aegis server-side name)
	* Implemented a generic framework for parsing delimited db files
	- allows specifying min/max column ranges and max number of rows to read
	* Cleaned up pc.c a bit [ultramage]
	* Updated item_db.sql to latest [Toms]
2008/04/14
	* Fixed a possible crash in char_sql. (since r12575, later modified in r12590). [FlavioJS]
	* Fixed a memory leak in mapif_quests_fromsql [Toms]
	* Fixed a typo in char_sql/char.c [Toms]
	* Fixed a bug in the disconnection part char-server (not sending you offline) [Toms]
	* Changes to the configure script: [FlavioJS]
	- added options --with-MYSQL_CFLAGS and --with-MYSQL_LIBS to allow manual setting of those variables
2008/04/13
	* More major updates to the quest log system. [Kevin]
	* Followup to r12579 (all other players appeared as female on sql branch). [FlavioJS]
	* Some major updates to the quest system, beginning to move it
	  over to the inter server instead of char server. (r12581) [Kevin]
	* Added an include in clif.h to avoid a complaint of gcc [Toms]
	* Quick&dirty reversal of the inter-server behaviour introduced in r3255/r3256:
	- the behaviour enabled a desynch between the char-server and the map-server
	- now the map-server asks the char-server to authenticate the auth info
	  (the char-server doesn't send the auth info immediatelly)
	* Changes to the configure script: [FlavioJS]
	- clarified how --with-zlib is used
	- added --enable-packetver to set the PACKETVER define (used often enough 
	  to get it's own option, but unnecessary since it can be set with CFLAGS)
	- added -g compiler option to --enable-debug
	* Changed LOG_ALL definition to really log everything [Toms]
2008/04/12
	* Login will no longer set character offline when going from map
	  to character select. (r12575) [Kevin]
2008/04/11
	* The max_account_id packetver detection mechanism will never cause any connection problems ever again. (bugreport:388)
	* Reverted the `login` table changes from r12464 [ultramage]
	* Finished most of the quest log code, still bits here and there
	  but it's ready for testing. (r12558) [Kevin]
2008/04/10
	* More quest log code. [Kevin]
	* Client not marked online until map receives auth request from the client
	- and is approved. Also added some online/offline sets to the auth system
	- that were being skipped.(r12552) [Kevin]
	* Modified the charservers to use a DBMap instead of a cyclic array for auth data.
	* Merged the auth fix from r12473 to TXT as well.
	* Removed the no-op from r12547. [ultramage]
	* Rev. 12550 Reverted the change to MAX_SQUARE_LAYOUT. [L0ne_W0lf]
	* Rev. 12548 Updated NPC skill "Evil Land". More gravity wtfage. [L0ne_W0lf]
	- Based on visual observation, and experience with it on iRO Sakray.
2008/04/09
	* Clif functions and basic data structures for questlog system. (r12544) [Kevin]
2008/04/08
	* Fixed party invitation ack messages not displaying (bugreport:1308)
	* Modified PACKETVER for recent clients to use a YYYYMMDD date format
	  instead of a simple sequence number (allows adding versions inbetween)
	* Small party/guild creation cleanup. Added packet comments. Removed fake reply packet usage. [ultramage]
2008/04/07
	* Rev. 12529 Updated MAX_GUARDIANS to support an insane amount of guardians. [L0ne_W0lf]
	* Immunity to magic now makes you immune to the SC effect as well. (r12527) [Kevin]
	* Made script command 'flagemblem' and guild_emblem_change send an update 
	  of the emblem_id to the players in the area.
	- known bug: ui components that are displaying the emblem at the time 
	  (emblem in flag npc and emblem over head in gvg maps) are not updated,
	  but putting the mouse over the target shows the new emblem
	* Modified script command 'guardian':
	- returns the id of the guardian
	- if guardian index isn't supplied, it generates a temporary guardian
	* Implemented support for temporary guardians (not saved with castle).
	* Added missing includes from r12520. [FlavioJS]
	* Party/guild names can no longer be less then 2 characters long. (r12521) [Kevin]
	* Removed the 'wait close' timer that closed a session's socket after 5 seconds.
	  This was causing random disconnects when logging in. (bugreport:1330) 
	* Improved the Mental Sensing fix from r12507 to not start the status at all, instead of starting it and ignoring it later on.  [ultramage]
2008/04/06
	* Fixed a case where a dangling pointer was formed when a person was
	- invited to a party immediately after creating their own. (r12518) [Kevin]
	* Sight rasher now affects the wizard's own and other's icewalls. (r12516) [Kevin]
	* Sight rasher, sight blaster, and arrow shower are now the only
	- three skills that will affect traps. (r12516) [Kevin]
	* NPC earthquake now divides the atk2 bonus between players. (r12514) [Kevin]
	* Changed guild skills restore, regen, and battle order to only affect BL_PC. (r12513) [Kevin]
	* Reverted one of the changes in dynamic mobs that may
	- be causing the spawning problems. (r12512) [Kevin]
	* Equip speed buffs no longer stack with speed consumables. (r12509) [Kevin]
	- (Speed potion not included).
	* Sprint, Fusion, and Increase AGI now stack independently.
	- The others still don't take affect if you have any of these three. (r12508) [Kevin]
	* Mental Sensing no longer gives an xp bonus on bosses. (r12507) [Kevin]
	* Changed Union/Increase AGI stack fix (it should work now). (r12506) [Kevin]
	* Fixed seven wind not allowing ghost/shadow. (r12505) [Kevin]
	* Added Moscovia to the list of @go destinations [Toms]
2008/04/05
	* Unequip should no longer remove any buff from seven wind. (r12503) [Kevin]
	* Union and Increase AGI now stack. (r12502) [Kevin]
	* Union now consumes sp when not soul linked. (r12499) [Kevin]
	* Running into a wall/npc/pc/mob no longer enables spurt. (r12498) [Kevin]
	* Fixed unable to move after using a skill to break out of sprint. (r12497) [Kevin]
	* DMG no longer stops running. (r12488) [Kevin]
2008/04/04
	* PCs/Mobs/NPCs now block Leap(TK_HIGHJUMP) and sprint(TK_RUN). (r12485) [Kevin]
	* Disconnect user when receive select egg packet with no menu open. (r12484) [Kevin]
	* Fixed @rura between maps on more then one map server. (r12483) [Kevin]
	* Update to Auth Glitch fix: moved unit_free_pc back to where it was
	- and updated it so unit_free_pc just tells the script to end
	- (not hard delete). (r12481) [Kevin]
	* Updated mob_db.sql to latest.
	* Fixed a little bug in Kevin's commit (r12473) [Toms]
	* Bug fixes for Auth Glitch and Map server crash through script warp when
	- changing map servers.
	* When char receives the request to go back to char selection it sets
	- the character as "at char select" in the online_char_db, and
	- set_char_offline now deletes the entry in the online_char_db unless
	- the user is at the character screen (to prevent unecessary callocs/frees.
	* Script warp was just a simple misplacement of a free statement, freeing the
	- users session data before the scripting subsystem was finished with it. [Kevin]
2008/04/03
	* More login server work
	- Renamed 'connect_until_time' to 'expiration_time'
	- Renamed 'ban_until_time' to 'unban_time'
	- this also applies to login table columns (see upgrade_svn12464.sql)
2008/04/02
	* Rev. 12462 Updated MAX_GUILDCASTLE to support new castles. [L0ne_W0lf]
	* Added SV_KEEP_TERMINATOR option to not split the line terminator.
	* Added sv_split to strlib.c/h (similar to sv_parse). [FlavioJS]
2008/03/31
	* Fixed ACIDDEMO crash, thanks to Kaato&Konard [Lupus]
	* Added latest version of dbghelp.dll (from microsoft debugger package), to prevent Windows from loading other, outdated versions.
	  This caused the dbghelpplug plugin to omit information about structures when producing a backtrace. [ultramage]
2008/03/30
	* yet more login server stuff
	- jA data structure compatibility renaming / adjustments
	- mmo_account -> login_session_data, auth_data -> mmo_account
	- made gender variable usage consistent for the entire login server
	- rewrote TXT's new account creation procedure to match SQL's
2008/03/28
	* Some more txt/sql login server synchronization [ultramage]
	- removed the option to specify multiple IPs/subnets for 'ladminallowip'
	- removed the @gm command and all associated management code
	- removed the 'save unknown packets' code
	- removed the lengthy TXT ipban code (which was essentially a copy of
	  what's already handled by the socket layer/packet_athena.conf)
	- implemented 'start_limited_time' in SQL (expiration for new accounts)
	- applied some missing TXT changes from the last update
2008/03/27
	* Updated SQL Files (item & mobs) [Toms]
	* Partial rewrite of the login server's auth system.
	- replaced the cyclic, size-limited auth_fifo data structure with the
	  more appropriate DBMap-based alternative (stops some erratic behavior)
	- added code to simulate the pseudo-status "online on login server"
	- auth data will now expire after 30 seconds instead of persisting
	- better-than-aegis handling of login cancellation (the server will wipe
	  all previous auth data instead of making you wait for it to expire)
	- proper status message - no more generic "rejected from server", now
	  you'll get "the server still recognizes your last connection"
	- fixed a typo in r10110 which caused disconnect timer removal to fail
	- split off some parsing code to login_auth_ok() and login_auth_failed()
	- extended the auth confirmation packet so that the login_id1/2 values
	  are sent along with the associated account id (stops charserver from
	  making wrong choices if two incoming sessions have the same acc_id)
	- fixed a bug in the disconnect part of the main charserver parsing
	  loop, where a non-authed client would erase the online db entry for
	  a client that's already online, thus bypassing any dual-login checks
	- added code to stop the waiting_disconnect timer when the associated
	  online entry is removed right away, instead of doing checks later
	- removed code that would periodically wipe the online status of clients
	  that are in the auth process (producing yet more erratic behavior)
	- commented out some TXT-only reconnect prevention code (bugreport:1281)
	* merged the charserver acc modification code cleanup to TXT (r11324)
	* changed trunk's default server->client PACKETVER to 9
2008/03/26
	* Adjusted eAthena code to compile cleanly in C++ mode.
2008/03/25
	* Added proper checks to adoption processing (followup to r12428).
	* Cleaned up some code / fixed some typos. [ultramage]
2008/03/24
	* Reorganized the contents of the mapserver's header files.
	- map.h is no longer a generic dumping spot of all the shared structs,
	  and instead, each such structure now resides in its logical component
	- map.h now only holds mostly map-related things (needs more cleaning)
	* Fixed a problem in the new trade window implementation (from r11830) where no trade acknowledgement messages would get sent (bugreport:1217). [ultramage]
2008/03/22
	* Cart Termination now bypasses Parrying and Energy Coat (bugreport:476).
	* Mobs with no respawn information which don't have a master will not get unloaded by the dynamic mobs system.
	  This prevents script-spawned mobs (bio MVPs, Emperium/Guardians, ...) and dead-branched mobs from disappearing (bugreport:1246).
	* Added a missing null-pointer check to the timed player pvp/gvg respawn function (mistake in r12232) [ultramage]
2008/03/21
	* Added VS9 project files. Thanks to Konard [Lupus]
	- removed redundant map_getallusers() function
2008/03/19
	* Changed the dynamic mobs system to also unload mobs that have respawn
	  time but are already spawned - 22M less mem usage (bugreport:1197)
	- also added a check to not respawn mobs on maps with no players
	  (potentially unsafe operation, needs further inspection)
2008/03/18
	* Fixed invited party members not displaying correctly (bugreport:1199)
	* Fixed OnPCLoginEvent not working correctly (bugreport:1182) [ultramage]
	* Added missing WorkingDirectory value to vcproj-7.1, vcproj-8 projects.
	  Now you can flawlessly run your compiled server with RUN button in
	  the correct directory. Thanks to Konard [Lupus]
	- Reverted changes from the project files, due to incompatibility [Lupus]
2008/03/14
	* Fixed spawned mob count not being counted properly, causing yet more respawn problems.
	* extended the "npc_event: event queue is full" error message to also print the name of the event (so that the cause can be tracked down)
	* removed a strange (and undocumented) event name check for "GM_MONSTER" in the npc event execution code
	* added effects from recent sakexes to effects list
	* removed ladmin from vs8 sql builds
	* added int_auction.c/.h to vs6 and vs7 project files
	* some small cleanups
	* Fixed one condition incorrectly modified in r12358, which caused dynamically unloaded mobs to never spawn once they've been unloaded once (bugreport:1178) [ultramage]
2008/03/13
	* Replaced some foreach-based functions by their inlined iterator equivalents.
	* Changed the dynamic mobs system, so that the flag that indicates whether a particular mob can be unloaded is stored in the mob's respawn data structure.
	* Cleaned up related parts of the source code. 
	* Fixed one forgotten mob spawning function call causing mobs to duplicate when respawning (followup to r12350) (bugreport:1173) [ultramage]
2008/03/12
	* Removed one mob data variable related to dynamic mobs that I found to be redundant.
	* Changed MAX_MOBSKILL (max. amount of different skill entries per mob) from 50 to 40 to reduce memory consumption a bit more. [ultramage]
2008/03/11
	* Replaced one incorrect nullpo check in chat_deletenpcchat().
	* Replaced clif_countusers() with a more efficient alternative (thanks to the fact that pc_db now only holds fully authed players only). [ultramage]
2008/03/10
	* Added missing check to only allow the leader of a party to modify
	  its exp share settings (bugreport:12) [ultramage]
2008/03/09
	* Modified attack_walk_delay so it behaves on a 'per-object' basis, and
	  changed the default to 15 (all types).
	* Modified battle_delay_damage so damage is not delayed more than one
	  second for non-player attacks. 
	* Modified party_member_added with a hack so that the clif functions will
	  send the info of the new member since party_recv_info has not yet arrived.
	* Updated clif_calc_delay so the type sent to the client is based on the
	  number of hits of the skill (as Aegis packets reveal) [Skotlex]
	* Cleaned up and corrected some more land skill code [ultramage]
	- removed redundant skill_ganbatein() function
	- Added flag UF_PATHCHECK from jAthena which affects whether a skill's
	  cells will be affected by the surrounding terrain. Adjusted existing
	  flags so that they closely match jA's (for easier comparisons).
	- Fixed code that allowed placing of skill unit cells on 'gaps'.
	- Fixed code that prevented successful casting of land skills on 'gaps'
	  (officially it's possible, even though they will not deploy entirely).
2008/03/07
	* Script induced status changes can now be reduced by stats/cards (but
	  only trigger rate is reduced, not duration).
	* Battle delay timers will now check if the target player has the
	  invincible timer active or not.
	* Adjusted clif_damage and clif_skill_damage to set the endure type value
	  based on dmotion and damage, rather than hardchecking for SC_ENDURE.
2008/03/06
	* Fixed song/dance cells to appear even on top of walls and pits.
	* Fixed non-chatroom owners being able to kick others from the chatroom.
	  [Skotlex]
	* Fixed a crash when a homun kills a mvp and the char that did
	  the most damage is unable to carry the mvp reward (bugreport:1114)
2008/03/05
	* Added code to clear the Illusionary Shadow effect (followup to r12293)
	* Added some trim() calls into mapflag code (followup to r12238)
	* Fixed mvp exp reward packet not working right for big values
	* Added dbghelpplug plugin entry to the plugins configuration file
	* Added conf setting for auction table name (see r12287) [ultramage]
	* Implemented Firepillar's 'target cannot move for 0.2 sec x hit' property.
	* Corrected Earthquake so it behaves as explained in the development topics.
	* Added a missing line to actually unequip unallowed compounded cards when
	  changing maps.
2008/03/04
	* Updated the firepillar code so it behaves like the other traps.
	* Additional status changes now only get triggered if the attack did
	  damage, not if they get absorbed.
	* Properly set the opt3 value for Moonlight, Changeundead and Soul Link.
	* Fixed the "no equip" flag of cards not being properly applied when
	  attemting to equip items.
	* Some corections to the new auth db system. [Skotlex]
2008/03/02
	* New optimizations for mail system and adjust to use it on Auctions. [Zephyrus]
	- Added a Sql patch to clear all deleted mails. (There is no need to keep that data)
	- Added more code for Auctions. Not implemented but just for study.

2008/02/29
	* Rev. 12268 Added documentation for Cash shop NPC heading. [L0ne_W0lf]
2008/02/28
	* Added cash shop support [Zephyrus]
2008/02/27
	* Fixed 'cleararray' not able to erase array entry 127 (bugreport:864)
	* Fixed @reloadmobdb producing memory leaks in pet db (bugreport:1030)
	* Patched an unresolved case where knocking back a bard/dancer would
	  cause the mapserver to crash (bugreport:1043)
	* Fixed Apple of Idun not checking for bard soul link (bugreport:1028)
	* Fixed Advanced Adrenaline Rush not working barehanded (bugreport:1049)
	* Disabled idle_no_autoloot setting (bugreport:1051)
	* Removed NODAMAGE and ICEWALL cell types (mem usage back to normal)
	- Icewall now uses basic cell type 5 (nonwalkable, shootable)
	- as a consequence, you can now warp to a nonwalkable cell - but only
	  via gm command or scripted warp bug (hopefully :)
	* Added missing option changes for Illusionary Shadow and Soul Link
	  that disappeared when you left the screen (bugreport:1053)
	* Added support for the "view player equip" feature (see topic:174461)
2008/02/26
	* Added new settings for Autotrade. [Zephyrus]
2008/02/23
	* Now the server will print an error message if an invalid mapflag is
	  found during script loading (see bugreport:980 for the motivation)
	- removed one extra space that broke jail's noreturn mapflag loading
2008/02/22
	* Removed code in socket.c that tries to avoid send buffer overloading,
	  as there is a scenario (many players and charserver disconnect) where
	  mass char saving produces huge ammounts of data to send (see r11503)
	* Cleaned up player respawning code (bugreport:1022)
	* Increased the max amount of different autocast skills from 5 to 10
	* Fixed @whomap not unlocking the player db (bug in r12204) [ultramage]
	* Added $(CUSTOM_CFLAGS) into all Makefile.in to provide any custom defs
	  directly to all sub make files. How to use:
	  make CUSTOM_CFLAGS='-DSOME_DEF' sql [Lupus]
	* Fixed 2 problems in r12223 - incorrect variable used (bugreport:1031) and a missing global function declaration. [ultramage]
2008/02/21
	* Added status_calc_life to properly calculate hp/max_hp as a ratio taking
	  into accounts overflows (and for now also avoids divisions by 0). Applied
	  this function around clif.c, mob.c and pet.c
	* Implemented the correct walk-speed bonus from the Bard/Dancer spirit.
	* Fixed logarithmic drops turning 0% drop rates into 100%.
	* Restructured the login mechanism of the map-server. The goal was to make
	  sure players are not found  in the different dbs of the map while the
	  player has not yet been fully authed or while it is quitting, to avoid the
	  rest of the code from accessing and modifying it. It is a rather extensive
	  change, and I only had time to test the basic functionality, so if use with
	  care and report any bugs found.
	* Replaced player states auth, waiting_disconnect, finalsave with active,
	  and removed states party_sent/guild_sent.
	* Removed several of the old login methods/constants/player states which
	  are no longer needed due to this cleanup. [Skotlex]
2008/02/19
	* Rev. 12219 Fixed a typo in /map/clif.c (acount_id -> account_id) [L0ne_W0lf]
	* Forgotten update to the definition of script command 'input'.
	* Enabled DEBUG_MEMMGR only in DEBUG mode. 
	* Made autotrading characters be kicked instead of reporting double login.
	* Made create_session initialize session_data to NULL.
	* Fixed db_obj_get not handling deleted nodes correctly. (bugreport:999) [FlavioJS]
2008/02/17
	* corrected login_fd/char_fd being uninitialized in the char servers.
	* Added a check to prevent using consume-delay items when you cannot use
	  skills, since that opens an exploit if the item also has non-skill-casting
	  components to its script. [Skotlex]
2008/02/14
	* Removed/replaced all calls to map_getallusers (followup to r12195)
	* Trashed @whozeny (from r269) [ultramage]
	* Added some changes to @noks. Now it uses a SC and not vars in mob_data [Zephyrus]
	- Added support to Self|Party|Guild to @noks (default is Party)
2008/02/13
	* Changes to memory manager: [FlavioJS]
	- fixed blocks that are fully used not being detected (and not freed) in 
	  memmgr_final (unfill_prev is NULL for unused blocks and full blocks)
	- fixed memmgr_final giving the wrong address to _mfree (for small blocks)
	- added the pointer address to most error messages (and log)
	- made it append to the log file instead of rewriting it
	- implemented a function to verify if a memory location is active
	- other minor changes
	* Merged memory manager updates from old jA revisions (bugreport:663) [ultramage]
	- less overhead and better overflow detection (caution, experimental!)
	* Added some security checks in mail system [Zephyrus]
	- This supose to fix a bug reported in 622 to limit to MAX_ZENY.
	- Also add more checks to free space in your inventory to receive items.
	* Added some new config settings: [Zephyrus]
	- homunculus_autoloot, idle_no_autoloot, max_guild_alliance.
	- Added a code to activate a Kill Steal protection and the required mapflags.
2008/02/11
	* 'Forget me Not' no longer blocks ASPD bonuses from working or prevents
	  their re-casting, they are simply dispelled when the effect takes place.
	* Fixed a possible crash when a player logs out before their create-party
	  request is accepted. [Skotlex]
	* Expanded the script command 'input': (bugreport:811) [FlavioJS]
	- two new optional arguments 'min' and 'max'
	- return value indicating if it's in the correct range
	- config variables for the default value of the arguments:
	  'input_min_value' and 'input_max_value' in script_athena.conf
2008/02/10
	* Added two missing opt2 values, for Angelus and Bleeding status
	* Fixed Warp Portal code sometimes producing errors/crashes in the case
	  where a priest enters his/her own warp (bugreport:270)
2008/02/08
	* Fixed wrong message in item group loading code (bugreport:936)
	* Fixed 'charisalpha' not working for the first char (bugreport:940)
	* Disabled signed/unsigned warnings for visual studio 2005 [ultramage]
2008/02/07
	* Fixed the disguise commands using the wrong variable when attempting to
	  disguise as an npc.
	* Corrected and optimized npc_remove_map's npc array cleanup (Fixes
	  @reloadscripts reporting 'too many npcs per map' and related dangling
	  pointer crashes).
	* HP loss item scripts can no longer kill you.
	* Corrected the item-drop-rate check to avoid duplicate entries in
	  @whodrops after a @reloadmobdb. [Skotlex]
2008/02/04
	* Some code cleanups. [Zephyrus]
	- Added new Cell types (NoChat and NoDamage)
	- Added JobChangeLevel and FreeSKPoints to #stats
	- Added a Crash protection in clif_send with invalid fd values.
	- Merged a missing update in TK Mission.
	- Added script command 'getmapflag'
2008/02/03
	* Fixes to Devotion (see topic:153345) [ultramage]
	- removed totally fake Devotion packet from Marionette Control code
	- fixed one devoted chars array management code bug which caused chars
	  to be included in the array multiple times, producing various problems
	- the link will now re-display when coming into view range
	- the link will no longer break if the devotee walks away, but instead,
	  if he receives damage while being out of range of Devotion
	* Added an iterator to map.h/c. [FlavioJS]
	  Will be used instead of map_getallusers, which has problems with 
	  dangling pointers (returned array isn't updated).
2008/02/01
	* Fixed sql charserver crashing sometimes (bugreport:870) [ultramage]
2008/01/29
	* Plagiarize can no longer copy skill levels beyond their max skill_db
	  value.
	* Modified pc_dead so that the src is passed on to the master when it is a
	  pet or homunculus. [Skotlex]
2008/01/26
	* Small update to the dgbhelpplug plugin: [FlavioJS]
	- fixed only half of wide character strings being printed
	- fixed the memory validity check in Dhp__PrintDataValue being optimized 
	  out in release mode
2008/01/25
	* Updated conversion tools for mob_db & item_db
	* Updated SQL Files (item & mobs) [Toms]
2008/01/21
	* Fixed battle config loading not applying the side-effects of
	  battle_adjust_conf() side-effect if an import: operation fails.
	  This is what caused the odd slowdown reported in bugreport:260.
2008/01/20
	* Fixed item searches not working on exact "jname" matches.
	* Fixed hom_setting&0x2 conflicting with the 'view-range' limit check.
	* Merged the SA_MONOCELL and SA_CLASSCHANGE code. After changing class all
	  the status changes that cannot be triggered on bosses are dispelled.
	* SA_CLASSCHANGE now uses the bloody branch list to pick a target MVP
	  class. [Skotlex]
2008/01/19
	* Added plugin dbghelpplug to generate more extensive crash reports in windows. [FlavioJS]
	- see header of src/plugins/dbghelpplug.c to know it's capabilities
	- VS8 project file supplied at vcproj-8/dbghelpplug.vcproj
	- a dll compiled in release mode is supplied at plugins/dbghelpplug.dll
2008/01/17
	* Made battle_check_range fail whenever the distance between src/target is
	  greater than the viewing range. [Skotlex]
	* Icewalls can no longer be knocked back (see bugreport:38)
2008/01/15
	* Manner system fixing [ultramage]
	- better-than-aegis 'red bubble' packet updates; now it shows correctly
	- added support for /rc, which is basically mute for 60 minutes
	- fixed typo in r12076 making gm-mute start on the gm instead of target
	- fixed @mute not ending the status properly when using negative values
	- adde missing clif_manner_message(), sends info about manner updates
2008/01/14
	* Fixed missing mob_spawn call, which was making CR_CULTIVATION not
	  actually spawn the plant. [Skotlex]
	* Client packet corrections
	- 0x01df is not 'gmreqnochatcount', but for requesting a player's
	  account name via right-click menu (which currently can't be done)
	- added /remove and /recall, aliases to /shift and /summon
	- added /changemaptype, which alters a single cell's gat type
	- gm kick will no longer exit the client (now it goes to the login screen)
	- removed the quicksort invocation in /ignore code
	* Fixed card removal script functions' 'extra card' bug (bugreport:786)
	* Removed the hardcoded limit for numeric npc input boxes (bugreport:811)
	* Applied a temp patch to make some npc-executed atcommands work again
	* Added support for right-click-gm-menu kicking NPC objects [ultramage]
	* Fixed dangling pointer crashes when bleeding or Deadly poison kills a
	  spawn-once monster.
	* Fixed a possible ERS entry corruption when Deadly Poison kills a target
	  that has kaizel active.
2008/01/13
	* Fixed a possible ers_entry corruption if you die from bleeding while
	  under the effects of kaizel.
	* Updated Safety wall so it does not blocks melee magic. [Skotlex]
2008/01/12
	* Another possible fix to ers/status_change crashing.
	- same logic as r12058 but in status_change_timer.
	- look out for this error: "[Error]: status_change_timer: Unexpected NULL status change id: ### data: ###"
	  getting it means that a crash was avoided and the culprit found.
	* Modified npc_parsesrcfile to read the file as binary and let sv_parse handle LF/CRLF line endings.
	* Possible fix to ers/status_change crashing. [FlavioJS]
	- this patch is untested. Didn't find anyone willing to test it and I can't 
	  reproduce the crash so can't test the patch.
	  symptom:
	   status_change_entry.timer is being modified after the entry is freed.
	   ers uses that memory location as a pointer when the entry is freed, 
	   it crashes when accessing the contents when it points to an invalid location.
	  assumption:
	   status_change_start starts an already existing status.
	   as a consequence of something called inside status_change_start the status is ended.
	   when the sce is finally being modified, it's modifying a freed entry.
2008/01/11
	* Implemented the extra damage bonus to TK_JUMPKICK when it is used while
	  running (however what the bonus's equation is has been lost to time, so
	  someone else correct it).
	* Corrected CR_CULTIVATION to cause summoned plants to expire after 5
	  minutes.
2008/01/10
	* Fixed getmonsterinfo to return "null" when returning the name of a
	  non-existing mob instead of -1.
	* Corrected CR_CULTIVATION to fail when the target cell has some BL_CHAR on
	  it already.
	* Script command percentheal will no longer kill the player if the
	  specified amount is negative (and not -100).
	* Fixed Abracadabra unable to cast non-targeted skills (bugreport:186)
	* Another round of login server cleaning [ultramage]
	- fixed passwordencrypt on SQL not behaving correctly (since r10753)
	- corrected some column lengths in the login db (username, password,...)
	- fixed some places which used wfifo without first reallocating it
	- removed interserver packet 0x7532 (Request to end connection), as
	  there was no code that actually sent this packet
	- moved RFIFOSKIP actions to execute as soon as possible
	* Corrected @slaveclone/@clone behaving as @evilclone when you change the @
	  symbol.
	* Modified SC_ARMOR_ELEMENT so it grants elemental resist as if it they
	  were card granted bonuses.
	* fixed a SA_DISPELL crash when casted on an object with no status changes.
2008/01/09
	* Script command warpportal now places a warp in its initial state (as if a
	  real warp portal was casted).
	* Updated dispell to also not remove the following effects: Hindsight, Inc
	  Hit/Atk Rate (NPC_POWERUP), Nen, TK stances and tumble, warm and speedup1
	  (the other speed potion).
	* Chase-walking characters can now loot.
	* Hiding characters can't drop items now. [Skotlex] 
2008/01/08
	* Added missing session auth checks to charserver. [ultramage]
	  Packets from non-authed clients will now be discarded.
	* Fixed Wand of Hermod not starting the SC_HERMOD status change (which
	  blocks spells)
	* Fixed additional def/mdef from vit/int bonuses being lost when a status
	  change that affects def/mdef triggers (for homunculus) [Skotlex]
	* Added missing code to log main chat messages sent by whispering
	  to main_chat_nick (bugreport:424) [ultramage]
2008/01/07
	* Small change to potion pitcher to allow potion healing rate item effects
	  to be included in potion pitcher's heal rate. [Reddozen]
	* Changed the code in status_change_timer so that a null pointer no longer
	  causes a crash but prints an error instead.
	* Corrected clones not copying over a player's skills properly. [Skotlex]
2008/01/06
	* Extended the id range for npcs, now [400,700) will also be treated
	  as NPC objects (see topic:170845 and bugreport:727) [ultramage]
	* Fixed a visual itemdupple bug on mail system. [Zephyrus]
	- Fixed Overthrush status cannot being recalled at same skill lvl.
2008/01/04
	* Fixed a mistake in r11991 that let knockback work through walls
	* Modified the map_setcell() code to to use a boolean flag instead of
	  needing SET_ / CLR_ pairs of defines (topic:174323) [ultramage].
	  Also removed script object 'setcell', added script function 'setcell'
	- Now you can manipulate cell information without needing @loadnpc
	- You can also manipulate the terrain ('gat') type itself, using the
	  new cell_walkable, cell_shootable and cell_water constants
	  (currently the implementation uses bit flags too, so to get the type
	  you want, you need to adjust the flags one by one)
	- This breaks current scripts, so please adjust places that use setcell
	  (also be sure to _only_ use predefined constants, not direct numbers)
	- Details can be found in the script reference.
	* Fixed Music Lesson's effect on Assassin Cross of Sunset.
	* Fixed a possible crash in status_change_timer when debug mode is
	  disabled. [Skotlex]
2008/01/03
	* Changes to reduce the number of map cell types
	- Pneuma now again works via status change (see r3969)
	- removed unused CELL_SAFETYWALL
	- removed custom CELL_REGEN, it just increased regen rate (r1192, r1518)
	* Fixed npc unloading not clearing NPC touch cells (bugreport:595)	
	* Map cell mechanism rewrite (bugreport:426)
	- defined a data structure for map cells (replaces 3 various cell arrays)
	- both terrain (gat) and dynamic (cell) information is now stored as
	  C-style bit flags instead of #defines and bitmasks
	- added map_gat2cell() and map_cell2gat() for terrain type conversions
	- changing terrain information via 'setcell' is temporarily disabled
	- mapserver startup now takes longer, as it needs to adapt mapcache data
	  to internal representation, cell by cell (new mapcache format anyone?)
	* Moved extra junk from map_addblock/map_delblock to where it logically
	  belongs (loadendack/unit_remove_map), removed flags and _sub macros
	* Removed map_data's block_count, as (quote Yor/ja2160),
	  "Perhaps useful for debug, but uses memory AND CPU for nothing."
	  (block lists are linked lists, they don't need count tracking) [ultramage]
2007/12/31
	* Fixed a crash in txt char-servers that the memory manager was hiding.
	  online_char_db being used after being destroyed (since r4026)
	* Added code to reject double logins in clif_parse_WantToConnection and 
	  added debug messages to detect possible double logins that escaped.
	* Isolated accounts that are waiting for the quit ack. The rest of the 
	  game logic no longer has access to them though the id2sd/charid2sd dbs.
2007/12/30
	* Fixed get_val2 not using the stack, which automatically frees the data, 
	  causing memory leaks for string variables since r11976.
	  (bugreport:723 , part of bugreport:714 and part of bugreport:708)
	* Trully fixed the previous commits. (missing cast and incomplete size)
	* Made the memory manager set allocated memory to 0xCD and freed memory 
	  to 0xDD. The memory manager no longer 'hides' uses of freed memory.
2007/12/29
	* Fixed two missing @LDFLAGS@ in src/plugins/Makefile.in. [FlavioJS]
	* Implemented THE official Steal skill equation and game mechanics
	  (basically version from /stable plus a few tweaks) (see topic:116540)
	* Added missing bAddStealRate reference to doc/item_bonus.txt
	* Removed skill_steal_rate, as it was never used in the code (see r231)
	* Removed skill_steal_type, it's just a one-liner source mod (see r231)
	* Knockback now works through cells where there is a diagonal path, but
	  no horizontal+vertical (two 90` icewalls with a gap where they 'join')
	* Some dead code removal in path.c [ultramage]
2007/12/28
	* Fixed a memory leak in memitemdata_to_sql.
	* Reverted a bad modification in clif_produceeffect from r11290. [FlavioJS]
2007/12/27
	* Removed an incorrect range check and fixed a copypaste typo which
	  caused script engine errors / crashes (see r11984)
	* Re-added a missing mob last_thinktime timer initialization when a mob
	  spawns, causing mob AI to freeze (mistake in r11964) [ultramage]
	* Changed the configure script:
	- refined the mysql test (wasn't detecting 64 libraries compiled without -m64)
	- added a test for clock_gettime in -lrt (required for Debian)
	* Corrected description of scope and npc variables in script_commands.txt.
	* Made temporary character string variables not have a limited length.
	  (now all temporary string variables don't have limited length)
	* Made temporary character variables reuse free positions.
	* Tweeked the declaration and initialization defines for vectors.
	* Made do_sockets leave the for loop as soon as the readable number of 
	  sockets returned by select is found.
	* Made all posix compliant systems that support it and FreeBSD >= 5.1 
	  (implements it but doesn't have the posix defines) use the precise and 
	  consistent tick() implementation.
	* Minor tweek to HEAP_SEARCH (same variable can be used in from and to).
	* Fixed the map server not exiting when make_listen_bind fails and 
	  returns -1. [FlavioJS]
2007/12/26
	* Fixed the incorrect interpretation of the map-cell height information
	  stored in .gat files; this was causing an overall of 20000 cells to
	  be treated as water when officially they aren't [ultramage]
	* Fixed string variables dereferencing directly to the value instead of 
	  dereferencing to a copy of the value. (fixes bugreport:684 bugreport:641) [FlavioJS]
2007/12/23
	* Added a generic vector implementation (dynamic array) based on defines. [FlavioJS]
	* Fixed horrible handling of skill_abra_db which leads to memory corruption
	  (depending on the contents of yor abra_db.txt file) [Skotlex]
2007/12/22
	* Fixed droprate overflows when going over rate 2000x [ultramage]
	* Corrected mob spawn utilization of the delay1/delay2 values (one is
	  respawn delay base, the second is random variance added on top of it).
	  Cleaned up related code. [Skotlex]
2007/12/19
	* Fixed yet another buffer overflow, in @adopt [ultramage]
	* Changes to the configure script. [FlavioJS]
	- fixed the 'pointers can be stored in ints' test not working
	- fixed the linker trying to build 64 bit executables with 32 bit code on 
	  x86_64 (missing -m32 flag in LDFLAGS)
	- made MYSQL_CFLAGS be built from the --include option to be more portable
	- made --with-mysql check if the optional argument is an executable file
	- make --with-pcre check if the optional argument is a directory
	- other minor changes
	* Corrected SC_MIRACLE to trigger Bless of the Stars on all defeated mobs.
	  [Skotlex]
2007/12/18
	* Fixed a possible buffer overflow in @partyoption [ultramage]
	* Updated respawn time interpretation according to latest kRO update [Playtester]
	- this first time is the "min respawn time"
	- the second time is the "variance" which is added to the "min respawn time"
	* Corrected skill_db reading to properly trim the skill name/descs.
	* Added a mobid_db in map.c to handle mob lookups faster. [Skotlex]
2007/12/17
	* Added flag.server to indicate interserver sockets
	- replaces the previous way (setting 'client_addr' to 0)
2007/12/14
	* Guardian hp handling code removal (see bugreport:342)
	- removed guardian hp from the castle data structure, database,
	  savefiles and various script functions (use upgrade_svn11915.sql)
	- removed guardian hp calculation and manipulation from the castle
	  manager npc, now the hp values are updated by the server itself
	  (glitch: when castle defense changes, all guardians are healed to full)
	- tweaked script function 'guardianinfo' to provide some data needed
	  by the manager npc (currently available are hp, maxhp and visibility);
	  also, it doesn't need a player attached to execute
	* Added a precise and consistent tick() function for freebsd [ultramage]
	* Wand of Hermode now dispells buffs only of allies.
	* Fixed some null pointer checks in status_change_end.
	* Corrected a crashy Warning message. [Skotlex]
2007/12/13
	* Fixed possible segmentation faults in the script engine.
	- some strings that can be freed outside the script engine were being 
	  pushed into the stack as constant strings
	* Disabled ers until recent crashes are fixed.
	- ers entries are being corrupted, probably by modifying them after they 
	  are released or by releasing something else
	* Abstracted the windows socket code so that all fd's are in the range
	  [1,FD_SETSIZE[. (bugreport:604)
	- The socket of a fd is forgotten when executing sClose, so things that 
	  depend on the socket (like sFD_CLR) must be executed before closing.
	* Replaced the fd_set of the short list with a custom implementation
	 (works like the linux fd_set). [FlavioJS]
2007/12/12
	* Some preparations for the guild script update [ultramage]
	- cleaned up npc event execution code
	- cleaned up guild data loading/saving code; to be improved later
	- removed dummy 'account name' expulsion list management code
	- removed columns 'rsv1' and 'rsv2' from guild member data
	- removed columns 'rsv1' 'rsv2' 'rsv3' and 'acc' from guild expulsion data
2007/12/11
	* Added query_logsql script command to perform sql commands using the log
	  db connection.
	* Added some new cashitems and headgears.
2007/12/10
	* Cleaned up clif_setdisguise and fixed it for PACKETVER>=9.
	* Added missing range/skill-mask info to reflected damage (fixes autospells
	  not triggering on it) [Skotlex]
2007/12/09
	* Modified npc_parsesrcfile to parse the line as a 'tab-separated values' 
	  string and added data truncation warnings.
	- enforces a stricter adherence to the format (no multiple tabs)
	- avoids sscanf matching spaces, new lines and carriage returns when '\t' 
	  is used in the format string
	* Added a generic 'delimiter-separated values' string parser to strlib.c/h. [FlavioJS]
2007/12/07
	* Fixed ensembles skills.
	* removed the timer heap correction code when the timers overflow since
	  Flavio points out that it is not needed.
	* Modified a bit the changesex code so you get saved and quit before
	  changing your sex rather than afterwards.
	* Cleaned up #changesex
	* Signum Crucis now works on bosses. [Skotlex]
2007/12/06
	* Removed the attempts to recover from invalid syntax in npc_parsesrcfile 
	  since they can produce incorrect results (spaces in sscanf can match 
	  \n's and company).
	* Made script_rid2sd report the script source directly and changed related 
	  return 1's to return 0's to avoid double script source reports.
	* Added missing return 0's after script_rid2sd is used and an extra error 
	  message in buildin_set/buildin_setd. [FlavioJS]
	* The default event script behaviour is to trigger on labels rather than
	  NPCs now.
	* Removed several script config options which break NPC compatibility when
	  you mess with them (event_script_type, event_requires_trigger,
	  die_event_name, kill_pc_event_name, kill_mob_event_name, logout_event_name,
	  login_event_name, loadmap_event_name, baselvup_event_name,
	  joblvup_event_name)
	* LoadMap events no longer set the variable "@maploaded$" to the name of
	  the new map. [Skotlex]
2007/12/03
	* Fixed a bug on Mail System. Removed the possibility to lost the attachment on
	  a Map - Char server disconnection. [Zephyrus]
2007/11/29
	* pc_setoption no longer does view_data changes while disguised (as this
	  breaks things) [Skotlex]
	* Random cleanup/documentation.
	* Made common/Makefile get the svn version from the src directory, not src/common.
	* Added a warning message to the install and uninstall targets.
	* Renamed all obj directories to obj_all, obj_txt or obj_sql in the 
	  makefiles (if an obj/ directory exists, BSD make enters it before 
	  reading the makefile) [FlavioJS]
	* Allowed disguising while riding a peco-peco (this does not seem to cause
	  problems anymore).
	* The pvp rank packet is no longer sent to other players when disguised, as
	  this leads to crashes when you die.
	* Probably fixed splash damage.
	* Reflected spells no longer cause knockback. 
	* SG Blessing skills now grant the extra experience to everyone when the SG
	  killed the mob.
2007/11/28
	* Applied the required changes to handle def as a signed char (allows for
	  negative def)
	* Corrected skill_check_condition to not delete items right away for
	  certain skills that do the deletion themselves. Fixes several skills
	  consuming items twice.
	* Dispel's success rate is no longer affected by MDEF
	* You are no longer blocked from being warped when standing in a warp while
	  in a duel.
	* Duels are now automatically ended when you warp out of the map you are
	  in. [Skotlex]
	* Fixed reflected spells bypassing WoE no-knockback restriction, because
	  the code allowed that when cast on self; not anymore (bugreport:231)
	* Reverted the position of the max_hp/max_sp basic setting, modified the
	  max_hp/max_sp bonuses to use casting in order to work correctly with
	  negative bonuses. [Skotlex]
	* Reconstructed a list of all PACKETVER types, by reverse-engineering
	  it from places in the code where the define is used [ultramage]
	- recovered PACKETVER 6 which was added in r51, but overwritten by r141,
	  one of the dumbest commits that I have seen so far
	- since 6 was the 'new trade window' update, it and its corresponding
	  reply packet will now be used from now on instead the old version
2007/11/27
	* Added safesnprintf to strlib.c/h (bugreport:372) [FlavioJS]
	* removed login/char server_fd[] arrays, added server[].fd instead
	* TXT/SQL login server code synchronization [ultramage]
	- exported several core structures to login.h
	- split off ladmin communication code from the TXT login server
	- removed all occurences of login_log(); a unified function should be
	  added when SQL's loginlog_db logging code gets synced with TXT
	- removed conf setting login_log_filename
	- fixed ladmin getting timeouts since the ping system was changed
	* Moved basic max HP/SP calculation to before parsing equipment, fixes
	  negative absolute HP/SP bonuses not working.
	* Corrected the online_data_cleanup routine setting offline characters that
	  are still connected to the char-server.
	* Added a check in script command sc_end to properly end infinte endure
	* ASC_BREAKER no longer triggers status effect cards. [Skotlex]
	* Fixed fake_nd not being exported correctly and being unloaded when 
	  reloading scripts. (probably fixes bugreport:444) [FlavioJS]
2007/11/26
	* Normalized makefiles:
	- 3 sections: variables, public targets, private/support targets
	- object files always in a *_OBJ variable
	- header files always in a *_H variable
	- object files always generated to an obj* subfolder
	- all Makefiles can be executed individually, calling other makefiles if necessary
	- generic object targets when possible
	* Fixed buildin_query_sql using Sql_Query instead of Sql_QueryStr, 
	  wrongly processing all %f,%d,... (fixes bureport:218) [FlavioJS]
	* Fixed guild expulsion not working correctly [ultramage]
	* Fixed a memory leak in mail_savemessage (src\char_sql\int_mail.c). [FlavioJS]
2007/11/25
	* Rev. 11804 Giant Fly Wings are now blocked on noteleport maps and duels. [L0ne_W0lf]
2007/11/24
	* Fixed a crash when Slim Pitcher is cast
	* Fixed a crash when a taekwon hits a wall while Sprinting (bugreport:483)
	* Added support for latest official client/server packet changes [ultramage]
	- enable by setting PACKETVER to 9; note that this breaks older clients
2007/11/23
	* Changed the status_change structure to use dynamic rather than static
	  memory to hold the individual status changes, this should have a noticeable
	  impact on the server's memory consumption. However, since this is a pretty
	  large update (and I am unable to fully test all possible situations
	  relating to status changes), watch out for any bugs. [Skotlex]
2007/11/22
	* Moved the reset of references to after the empty script checks in 
	  parse_script. (fixes bugreport:222 and bugreport:449)
	* Renamed fakenpcname to setnpcdisplay, fixed and extended it. [FlavioJS]
	- See doc/script_commands.txt for information on how to use it
	* Modified mapserver login procedure to make clients from may 2007
	  and newer not crash when entering mapserver (bugreport:468) [ultramage]
	- this changes PACKETVER to 8, causing incompatibility with old clients
	- this makes the "Login" hex obsolete; please stop using it as it
	  causes a conflict with this update and may have negative sideeffects
2007/11/21
	* Fixed Sql_SetEncoding not setting the encoding of the connection 
	  properly. (fixes bugreport:30)
	* Added backward compatible target 'conf' to the Makefile. [FlavioJS]
	* Changed Lif's Emergency Avoid to just get a normal skill delay
	  (blocks all skills, cancelled by mapchange / re-summon) instead of
	  getting a persistent block on only this one skill (bugreport:13)
	* Homunculi now reset their can-act delay on call/resurrect/mapchange
	  (allows bypassing delays by doing rest/call instead of relog) [ultramage]
2007/11/20
	* Implemented SL_SUPERNOVICE erasing the death record 1% of the casts.
	* Implemented current exp being capped to the exp required to level up from
	  the previous level when we are at max level (required for some S. Novice
	  buffs) [Skotlex]
2007/11/19
	* Nullpo's disabled on release builds.
	* Added timestamps to the log of memory leaks.
	* Moved definition of __func__ to cbasetypes.h.
	* Configure script updated:
	- added option to select the memory manager
	- added option to enable MAPREGSQL
	- added option to enable DEBUG
	* common's Makefile deleting svnversion.h on 'clean' target. [FlavioJS]
2007/11/18
	* Implemented a small change that was long overdue: Displaying the
	  char-select screen now uses a single SQL query instead of up to 9.
	  [Skotlex] 
	* Replaced jA's way of allocating npc shop data with a simple dynamic
	  array that gets allocated during loading and freed on unload
	- automatically fixes bugreport:404, which would otherwise require
	  manipulating the npcname_db (the original author didn't, hence the bug)
	- now a supporting variable 'count' is used for tracking the length
	  instead of an extra dummy entry at the end of the shop list
	- partially removed the MAX_SHOPITEM restriction (if this was written
	  properly, the system could support an unlimited amount of entries)
2007/11/17
	* Removed battle_config.error_log as console_silent already handles this
	* Made OnTouch zone dimensions be stored as radius instead of diameter
	- cleaned up some overly complicated area calculations [ultramage]
2007/11/16
	* Added 2 new status changes for Life and Regeneration Potions [Zephyrus]
	- Fixed some items boxes giving wrong tamings.
	- Fixed another item giving 48 gladius[3]
	* Added error messages when trying to place objects on invalid map coords
	* Fixed Divine Protection working against players (bugreport:410)
2007/11/15
	* Fixed some homunculus skill offset calculation mistakes (bugreport:363)
2007/11/14
	* Fixed skill_castnodex_db.txt not being parsed correctly
	* Fixed a search&replace typo in skill_db.txt
	* Added error reporting for invalid rows in skill db files
	* Added error reporting to buildin_warp when it fails [ultramage]
2007/11/13
	* Fixed homunculus skills having unlimited range instead of being
	  capped to view_distance+1 (for details see bugreport:376) [ultramage]
	* Fixed @addwarp crashing the map server (bugreport:390). [FlavioJS]
	* The Forget-me-not status now behaves like Decrease AGI [ultramage]
	- doesn't cancel Impressive Riff, Wind Walker, True Sight (bugreport:187)
	- additionally, it doesn't cancel Cart Boost
	* Fixed some bugs on mail system. [Zephyrus]
	- Added the pc_candrop check (bugreport:305)
	- Added picklog to mail.
	- Added INCMDEFRATE status for Mdef potion.
2007/11/12
	* Now when job changing to another class tree, status changes from skills
	  that belong to your previous class are cleared. [Skotlex]
	* Applied Rayce's improvements to the npc script parser [ultramage]
	* Made on-touch areas work with walking npcs (is somewhat process
	  intensive, but people do not really care about that, do they?) [Skotlex]
	* Fixed a bug in r11384 letting you bypass requirements for some skills
2007/11/09
	* Expanded weapon_type enum with dual-wield constants (bugreport:384)
	* Replaced several 'int' variables with enums that they represent
	* Re-worked the login-char-map packet spam mechanism
	- mapserver no longer sends entire user list to charserver every
	  10 seconds; similar change done to the char-login connection
	- user count updates are only sent when the value actually changes
	  instead of servers polling each other every few seconds
	- the servers now prevent interserver connection timeout explicitly by
	  sending ping/ack packet pairs instead of relying on the usercount
	  polling to do so; keepalive is sent every 'stall_time'-2 seconds
	* Fixed socket.c checking time() incorrectly (bugreport:394) [ultramage]
	* Added a database iterator to db.c/db.h. [FlavioJS]
2007/11/08
	* Changed EXIT_SUCCESS back to 0 in console.c to avoid an unnecessary include.
	* Fixed gm_account_db not being deallocated in login-converter.c.
	* Refactoring names and documentation in db.h/db.c: [FlavioJS]
	- changed 'struct dbt' to 'struct DBMap' and 'DB' to 'DBMap*'
	- changed 'struct db' to 'struct DBMap_impl' and 'DB_impl' to 'DBMap_impl*'
	- changed COUNT to DB_COUNTSTAT and made it's existence not depend on DB_ENABLE_STATS
	- removed some @see links and corrected small typos in the documentation
	* Fixed a glitch where all packets immediately after the map->char
	  login packet would get discarded and the mapserver disconnected
	* Synced charserver char creation creation code [ultramage]
	- removed most of the creation failure messages printed to console
	- fixed sql charserver letting you use control chars in char names
	- new chars will not start with the 'Knife' and 'Cotton Shirt' equipped
	  anymore (charserver blindly placed magic values into the equip field)
	* Updated configure script: [FlavioJS]
	- small correction to the help text of --with-mysql and --with-pcre
	- added the -Wno-switch compiler option to suppress the 
	  "enumeration value '%s' not handled in switch" warnings
	* Added a new setting 'guild_skill_relog_delay' to activate the guild skills delay
	  on Guild Master relog. [Zephyrus]
2007/11/07
	* Some updates on the mail system packets [Zephyrus]
	- Corrected the mail database structure on main.sql
	- Added separated packets for get and set attachment on mail system.
2007/11/06
	* Fixed a crash caused by a mistake in the previous change
2007/11/05
	* Changed skill db loading code to work similarly to how itemdb/mobdb
	  is loaded (generic file loader + specialized function to process rows)
	- all skill db files are now checked for inconsistencies the same way
	* Corrected the max. allowed skill name length, and optimized code that
	  works with skill names according to latest changes [ultramage]
	* Reverted official drop rate estimation [Playtester]
	- although it really exists we don't have enough information about it
	- if server owners really want it they can implement it themselves
	  (it's just a one-line fix anyways)
	* Cleaned up skill db lookup code
	- added some well-behaved functions to replace macros (skill_get_index)
	- used skill_get_index() to replace often occuring blocks of code
	  that did the skill_id -> skilldb_index calculation in-line
	* Corrected skill db loading code which was using a totally wrong
	  column count in sevreal cases (or didn't do any checks at all)
	* Changed the skill_db.txt skill names in comments into actual columns,
	  now the server reads these instead of a hardcoded array [ultramage]
2007/11/04
	* Implemented official drop rate estimation [Playtester]
	- estimation is rounded on 2 positions after decimal point
	- this will effectively raise drop rates below 10% by 0.01%
2007/11/03
	* Added jA script function 'strnpcinfo', for increased npc awareness
2007/11/02
        * Fixed one wrong return value in buildin_getcharid (bugreport:33)
	* Removed the big list of BUILDIN_FUNC() declarations in script.c,
	  as they are not needed anymore and no code utilizes them
	* Moved the BUILDIN_DEF() block to the end of script.c [ultramage]
	* Modified trap related code so it behaves as explained by Playtester:
	  Traps trigger on everyone in their 'effect range' (skill_db's splash) for
	  every target that lies within its trigger range at trigger time (range and
	  interval in the skill_unit_db). [Skotlex]
2007/11/01
	* Removed code that queues OnAgitEliminate after the Emperium is broken,
	  this is now done properly by the gvg script instead [ultramage]
	- if you have any extra castles, update your scripts accordingly
2007/10/31
	* Added names to the SC_ and SI_ enums, now they can be used to properly
	  indicate where such values are to be used (replaces usage of 'int')
	* removed MIN_/MAX_PORTAL_MEMO, set MAX_MEMOPOINTS from 10 to 3
	* removed support for @go-ing to your memo points
	* simplified the overly verbose @memo command; now re-uses pc_memo()
	* cleaned up pc_memo(), now uses semi-correct packet replies
	* Minor code cleaning/formatting [ultramage]
	* Updated several mapflags - 'nomemo' 'noteleport' 'nosave' 'nowarpto'
	  'restricted' - due to Izlude Battle Arena release. [SinSloth]
	- Updated 'item_noequip' and 'skill_nocast_db' to match with 'restricted' mapflags.
2007/10/29
	* Updated the mail db structure on main.sql [Zephyrus]
	* Makefile creating the conf/import forder. [FlavioJS]
	* command code cleaning (refer to topic:169759) [ultramage]
	- separated the execution part of command code into interface part
	  and internal part to better see which checks are done and when
	  (fixes problem where 'nocommand' mapflag blocked server npcs)
	- moved the internal commands list (array) to the end of the file,
	  this let me discard that long block of ACMD_FUNC() declarations
	- removed enum AtCommandType from command headers and commands array;
	  its purpose was perhaps to identify aliased commands, but apparently
	  it was never finished because the rest of the code doesn't use it
	  (also doing aliases like this is not a very good idea)
	- internally, commands are now referenced to using their function name
	- removed the @/# symbols from the command lists; all lookup functions
	  will now properly deal with strings with- and without a command symbol
	  (commands interface still requires the symbol tho', so TODO for later)
	- removed several unneeded commands (*id2 code, dmalloc debug commands)
	- reverted atcommand config from alphabetically-sorted to how it was
	  before (with additional fixes; see /conf changelog)
	- added missing code for #dropall / #storeall
	- added a warning when trying to set gm level of an undefined command
	* The structure of the commands table has changed, please adjust
	  docs/guides to match the new format (sorry for the inconvenience)
2007/10/28
	* Minor adjustment to take into account the end of line.
	* Fixed the line count in the new error message of npc_parse_function.
	* Restricted more the parsing of npc code. (fixes bugreport:317) [FlavioJS]
	* Fixed a bug sending on the attachment message [Zephyrus]
2007/10/27
	* Fixed a typo in r11505 messing up the 'npcmove' command
	* Removed 'petid', a command from r284 to look up pet ids by name
	* Fixed TXT charserver doing periodic random-sized alloc (bugreport:312)
	* Set 'Create Converter's produce success rate to 100% (bugreport:302)
	* Added check that verifies weapon/ammo/state requirements also when
	  casting finishes (might have unwanted side-effects!) (bugreport:228)
	* Fixed Firewall knocking back undead/fire element mobs (bug in r11578)
	* Added dummy 'openmail' to txt server to fix a script error message
	* Improvements/fixes to the mail system improvements :) [ultramage]
	* Improvements to the mail system. Need Testing, [Zephyrus]
2007/10/26
	* Moved the new novending cell check from the internal code to the
	  client-server interface (allows server to force-open shop if needed)
	* Removed confusing map_nick2sd_nocase(), let the charserver handle it
	* Added correct packet for attachment retrieval failure when overweight
	* Fixed one more mistake in r11571 (Sql->SqlStmt) [ultramage]
	* Removed the config setting firewall_hits_on_undead setting, Firewall and
	  kaensin now automatically calculate the number of hits they should do per
	  iteration based on the skill trigger frequency (you may want to raise that
	  delay of 1ms in the db, though). [Skotlex]
2007/10/24
	* Corrected a fex misshaps from r11571:
	- disabling the memory manager
	- using the wrong length for the title and body in mail_savemessage
	* Removed the quick-fix in the npc duplicate check and the impossible condition 
	  that is generating the warning. [FlavioJS]
	* @/#jobchange no longer strips your equipment since pc_jobchange removes
	  any unequippables already.
	* Removed the wasteful define MAX_PC_CLASS and replaced it by the
	  CLASS_COUNT define + pc_class2idx function. This should save a bunch of
	  memory from the map server.
	* Merged the CELL_NOVENDING code (see topic #129209) [Skotlex]
	* Increased the max. send buffer size to 5M since 1M is not enough
	* Updated vs7 and vs6 project files
	* Added upgrade_svn11548.sql to convert the mail table to new format
	* Cleaned up the mail code, no more pointless dynamic allocation
	* Cleaned up some messy guild code (more to come) [ultramage]
2007/10/23
	* Fixed a compilation bug on linux (FALSE -> false) [Zephyrus]
2007/10/22
	* Heat isn't supposed to consume SP when used against players [Playtester]
	- please report if it still consumes SP in pvp
	* Added the new mail system implementation (Requires more test and
	  optimizations) [Zephyrus]
	- Updated the mail DB structure.
	* Removed some mail config settings and atcommands not required anymore.
	- Added documentation for script commands: openmail and homshuffle.
2007/10/21
	* Fixed a small mistake in r11503 causing a fatal error&exit on unix
	  when you try to do a graceful exit (by ctrl+c for example) [ultramage]
	* Removed SC_INCAGIRATE/SC_INCDEXRATE as they are not used anymore.
	* Added SC_INCASPDRATE, SC_INCFLEE2, SC_INCCRI, SC_INCDEF, SC_INCBASEATK
	  and SC_FASTCAST as these are required by the newer items. [Skotlex]
2007/10/20
	* Fixed 'unequip' removing items in the wrong position (bugreport:252)
	* Fixed #refine unequpping the caller's item by mistake (bugreport:265)
	* Fixed a nasty bug from r11410 which let people create chars with
	  already taken char names, and (in TXT's case) even cause a crash.
	- Bug was a variable name collision between the total number of chars
	  and a char's slot number (both were called 'char_num'). [ultramage]
	* Some more updates to the skill unit code [Playtester]
	- renamed SKILLUNITTIMER_INVERVAL to SKILLUNITTIMER_INTERVAL
	- Heat now depends on the interval settings rather than firewall_hits_on_undead
	- Icewall doesn't break anymore when the SKILLUNITTIMER_INTERVAL gets changed
2007/10/19
	* Added bonusautoscript and bonusautoscript2. These are used to attach a
	  script to a player which gets executed on attack (or when attacked). This
	  is very similar to the autospell bonuses, except that a script is executed
	  instead of a spell. See doc/script_commands for indepth description and
	  usage. NOTE that I am unable to test ingame, and even though I proofread
	  the code it could have bugs. Feel free to test and report. [Skotlex]
	* Applied some cleanups that should correct "Infinite Endure" ending
	  sometimes. [Skotlex]
2007/10/18
	* Rev. 11516 Uncommented the showwarning and showdebug from 11508. [L0ne_W0lf]
	* Fixed the incorrect map names on the debug messages (mapid->mapindex 
	  mishap from r11508).
	* Fixed the incorrect reporting of npc names being too long when the the 
	  length is 24 (from r11508). [FlavioJS]
	* Rev. 11511 Commented out ShowWarning and ShowDebug messages added [L0ne_W0lf]
	  in revision 11508. Aside from the ShowDebug being faulty, they
	  are both fare too annoying for public use for the time being.
	  If/when I get the NPC names fixed, we can add it back.
	* Further optimization of the skill unit code [Playtester]
	- removed code for Crimson Fire Formation it now uses the same code as Fire Wall
	- added same knockback behavior as Fire Wall for Fire Formation
	- Heat now does 50 hits a second in pvp too
	- please let me know of any bugs that might appear
	* Optimized the skill unit code [Playtester]
	- reverted the unit timer interval to 100ms to save CPU usage
	- rewrote the unit code of Fire Wall, Fire Formation and Heat so that they hit
	  every 20ms if the target wasn't knocked back despite of the unit timer interval
	- Heat now does 15 SP damage to players instead of 60 per hit
	- optimized memory usage
	- TODO: Renaming or removing firewall_hits_on_undead config
	* Clarified how npc names work in script_commands.txt.
	* Fixed a forgotten "return 0;" that stopped the parsing of the file 
	  after the first "script" of the file is parsed sucessfully (caused by r11502).
	* Applied the same parsing and restrictions of npc names to warps, duplicates 
	  and shops (other code expects unique names for them too). [FlavioJS]
	* Applied the new checking function to clif code, this fixes various
	  length mismatches caused by incomplete code in r11386
	* Added clif_process_message(), an unified way to validate all four
	  types of player message packets and retrieve their components
	* Removed the requirement to provide a character name in the message
	  string when calling is_atcommand() (needed for the previous fix)
	- currently both ways work, but old will be removed in the upcoming
	  command cleanup so please adjust your custom code if you use this!
	* Merged improved/cleaned up (WiP) code for clif_parse_WisMessage
	* Removed commented-out code for check_fake_id() [ultramage]
2007/10/17
	* Removed outdated copyright and version number from startup logo
	* Removed socket code that attempts to cope with code bugs at runtime
	* client_addr will now be properly set to 0 for server connections
	* Fixed subnet check message displaying incorrect ip addresses
	* Merged do_sendrecv() and do_parse() into do_sockets() [ultramage]
	* Reworked the parsing at npc.c.
	- Fixes npc.c discarding the '}' at the end of file, when there is no 
	  newline. (uncovered as a side-effect of r11487)
	* Empty script functions always have code now (won't report as missing 
	  when you try to call them).
	* Changed userfunc_db to not limit the name to 50 characters. [FlavioJS]
	* Ground skill now can trigger every 20ms [Playtester]
	- Firewall, Fire Formation and Heat now can do 50 hits a second
	- this was proven to be official behavior, but it will raise CPU usage
	* small timer.c cleaning
	- removed "with less than 4 values, it's speedier to use a simple loop"
	  as this case will never occur (premature optimization from r1284)
2007/10/16
	* Venom Splasher fixes according to bugreport:230
	- added passive skillv*30% bonus from Poison React
	- added official splash damage calculation - damage gets split by the
	  number of targets at range 1, then applied to all targets in range 2
	- reverted some very old code - clif_calc_delay() - that was preventing
	  skills from displaying properly, by erroneously assuming that
	  if the target has ddelay 0, it has endure effect activated
	* Fixed displaying of several splash skills (see bugreport:238)
	- added flag SD_PREAMBLE for skills that need the 'magic' packet
	  (fixes Grimtooth / Cart Revolution displaying out of sync)
	- hacked together Venom Splasher's "no animation for central mob"
	- hacked in a custom packet to make Dragonfear display semi-correctly
	* Made Venom Splasher a splash attack that distributes damage
	* Commented out clif_skill_damage2() as it is not used anymore
	* Fixed a copy-paste mistake in disguise code (from r5833) [ultramage]
	* Tweaked the loop in parse_script to better handle when the outer 
	  brackets aren't checked.
	* Fixed a typo in skip_space that stopped skipping characters when it 
	  encountered a '*' or '/' in a block comment. [FlavioJS]
2007/10/15
	* Fixed NPC_CRITICALWOUND to reduce heal by 20% per level [Playtester]
	* Fixing TK Mission asigning non spawning mobs. [Zephyrus]
	* Updated the item price/sell reading code to enable 'null' values. The
	  difference between a blank value and 0 is that when the value is blank, it
	  should automatically take half/double the other value. The previous
	  behaviour did this automatically and didn't let you specify, for example,
	  if you wanted a given item to sell for 0.
	* Also added a warning when an item in the db has an exploitable price
	  (through overcharge/discount). [Skotlex]
2007/10/14
	* Rev. 11476 Implemented new skill "Enlarge Weight Limit R", [L0ne_W0lf]
	  and increased MAX_SKILL_TREE by 1.
	* Fixed charsrever crashes, caused by r11410 [ultramage]
2007/10/13
	* Fixed up NPC_POWERUP and NPC_AGIUP [Playtester]
	- NPC_POWERUP: 3x ATK and 2x HIT for 10+5*level seconds
	- NPC_AGIUP: 2x MOVE and 2x FLEE for 10+5*level seconds
	* Some further changes to the delayfix function [Playtester]
	- aftercast delay is at least amotion no matter what skill
	  (this includes skills with cast time AND skills with skill delay!)
	- aftercast delay reductions can NEVER reduce the aftercast delay below amotion
	  (this includes Bragi and Soul Links)
	* Again modified the delayfix function to reflect the current skill delay
	  knowledge. Skills with 0 delay use amotion always (regardless of cast
	  times) [Skotlex]
2007/10/12
	* Further updates to skill_delayfix function [Playtester]
	- aftercast delay can never be lower than amotion
	- please report if this broke any skills
	* Fixed wrong index calculation in TXT char creation code (ref: r11410)
	* Fixed SQL itemdb loading crash on NULL column (ref: 11398) [ultramage]
	* Updated the skill_delayfix function to behave as recently discovered by
	  Tharis: Skills with no delay set will use amotion ONLY if the skill was
	  instant-casted. [Skotlex]
	* Fixed Bragi's aftercast delay reduction [Playtester]
2007/10/10
	* Fixed itemdb_read_sqldb blowing up the server with segmentation faults.
	* Added an option for parse_script to ignore the checks for the set of 
	  brackets around the script. [FlavioJS]
	* Implemented more official Warp Portal behavior
	- the transition from active to waiting mode is now done as a simple
	  appearance change instead of deleting one and creating the other
	- due to the above, an opening warp is now properly accompanied by
	  the log-in like sound effect
	- Removed the check that prevented Warp Portal from opening after you
	  picked the destination, if there was someone blocking the cell
	* Re-enabled packet 0x1ac to be sent when something gets ankle-snared
	* Partially removed the usage of 'flags' to direct the execution path
	  in skill unit code (some people seem to really like flags >_>)
	- wiped out r8478 and its multiple levels of useless flag propagation
	- skill_unit_onlimit (expiration) no longer executes in skill_delunit
	- added skill_unit_ondelete for proper handling of this event
	* Removed 'into_abyss' effect on traps; tests show that it works ONLY
	  for Gemstones (tho' iRO website claims otherwise) - bugreport:171
	- corrected code that was exploiting the flag as an 'expired' trap flag
	  (replaced it with a more jAthena-ish approach)
	* Fixed a messup in r11347 causing skill units to expire, trigger
	  or not trigger, completely randomly
2007/10/09
	* Added upgrade_svn11388.sql to correct some log column widths
	* Corrected string lengths according to bugreport:198 [ultramage]
	- CHATBOX_SIZE: 70 -> 70+1
	- removed some too aggressive checks in clif_parse_globalmessage()
	- removed CHAT_SIZE define as it actually doesn't apply anywhere
	- added CHAT_SIZE_MAX to serve as a custom limit to input string lengths
2007/10/08
	* Delayed the check for required items when a skill is cast to when they 
	  are consumed. Now skills only fail due to lack of items after being cast.
	- Please make a bug report if you know of any skill that doesn't work 
	  like this in official.
	* Fixed hp of other party members not being sent when you join a party.
	* Removed unused global array names_id and renamed some structures that 
	  are used with variables of the same name. [FlavioJS]
2007/10/07
	* Fixed a bug on sql char server not checking the namelength of a new
	  character. Bug ID #184: Char Creation With An Empty Name [Zephyrus]
2007/10/06
	* the mapserver won't exit when no mapcache is found, with use_grf: yes
	* Fixed some \r uses, now looks better; /thx to Ai4rei (topic:165952)
	* Removed that ridiculous spinner that displays during map/npc loading
	- and added a more informative progress indicator (idea from jA/eapp)
	* Removed loads of code that supported these functions
	- -230b per npc => -3MB of wasted memory
	* Fixed related npcs that erroneously used 'stoptimer'
	* Checked/fixed/removed some old script and npc commands
	+ cmdothernpc
	- a specialized 'donpcevent' with the event specified as two arguments
	+ enablearena/disablearena
	- completely equivalent to enablewaitingroomevent & co.
	- do we need these 'synonyms' ?
	+ inittimer/stoptimer
	- removed since its logic was incompatible with the code it depended on
2007/10/05
	* REALLY fixed emblem not displaying when a char logs in
	  (compromise between r10624 and r11033 that hopefully works)
	* Fixed 'Wink of Charm' - shouldn't work on boss mobs (topic:166115)
	* Removed a broken remnant of code from old gospel code (r4349) that's
	  _supposed_ to clear the gospel status (no item use?) when you step
	  out of its zone; 1) the constant UNT_GOSPEL was used in a switch()
	  instead of PA_GOSPEL (thus actually ending 'NPC_STUNATTACK' status),
	  and 2) this code path is never taken, because Gospel is not recorded
	  in skill_unit_temp[] (it has a periodic timer and is not DUALMODE)
	* Now the first empty spot in the 'skill_unit_temp' array will be used
	  when tracking movement between land skills; reduced its length to 20
	* Fixed the skill unit mechanism that is supposed to track whether
	  you're still standing in a certain land skill's AoE or not, which
	  was not working correctly since the time it was added (r3133)
	- solves the nasty problem of Loki, Quagmire, ... status not ending
	  even after stepping out of it in some cases, if there was another
	  song overlapping the skill's area (fixes bugreport:34) [ultramage]
2007/10/04
	* Completed the SC_LIFEINSURANCE status and it's status icon. [Zephyrus]
	- Updated Item_db.txt.
	* Added SC_EXPBOOST (Field Manual), SC_ITEMBOOST (Bubble Gum) to const.txt.
	  Allready working [Zephyrus]
	- Added SC_LIFEINSURANCE and SC_BOSSMAPINFO (not implemented)
	- Updated Field Manual and Bubble Gum in the itemdb.txt file.
	- As L0ne Wolf reported to me and based on Doddler information, the Bubble Gum
	  only do a second try of the item drop, and it don't increase the drop rates.
	* Fixed a mistake in r10919 messing up logged values (bugreport:167)
	* Added code that compacts the vending list after a purchase; fixes
	  the problem with empty positions appearing in the list (bugreport:168)
	* Corrected Icewall skill to be closer to official behavior
	- now works on occupied squares (previously it disappeared)
	- now you can walk out of an icewall square (removed code that blocked
	  pathfinding if the origin cell was of a nonwalkable type)
	- added back the hack where mapcell changes are broadcast to whole map
	  (prevents client from leaving the cells non-walkable if you warp away)
	* Removed integer mob skill state/target definition support (unused)
	* Added script source error reporting to countitem() (topic:167165)
	* Fixed a compile problem when hotkey saving is disabled (topic:167265)
	* Added MAX_HOTKEYS to supplement the HOTKEY_SAVING define [ultramage]
2007/10/03
	* Added the code for Bubble Gum (SC_BONUSDROP) and Field Manual
	  (SC_BONUSEXP). items updated as it supose to work. [zephyrus]
	* Cleaned up parts of skill.c related to skill units [ultramage]
	- removed some nonsense code in skill_dance_switch() (from r8876)
	- removed 'security system to prevent forgetting timer removal' (r1213)
	- renamed some skill-related data structs (had same name as variables)
	- commented out custom Venom Splasher countdown messaging code
	* Bosses now can use teleport on Land Protector [Playtester]
	- Moved the homunculus shuffle code to mercenary.c, fixing the bug in the
	  atcommand not using the bonus evolution stats for homunculus.
	- Adding a new script command "homshuffle" to fix homunculus using NPCs.
2007/10/01
	* Fixed various trading/vending glitches [ultramage]
	- fixed vending_tax not working at all (integer division in r10182)
	- undid change from r8273 where pc_getzeny() treated zeny overflow as 
	  an error condition; officially, the value is just bounded to MAX_ZENY
	  (this fixes stuff like shops that you can't buy items from).
	- fixed stupid code that, instead of properly checking and filtering
	  invalid items during shop setup, opted to 'hide' these items from
	  the vending list instead...
	- removed some custom error message packets related to vending
	- fixed a glitch where the server would open a shop with no items
	  when all entered items were tagged as invalid
	- split zeny handling from trade_tradeadditem() into a separate func
	- removed loads of redundant code from vending.c
2007/09/30
	* Removed redundant 'subnet' s_subnet structure variable. [ultramage]
2007/09/28
	* Changed back the query to get the friends of a character to a LEFT JOIN.
	* Setting the item script variables to NULL when they are freed. (bugreport:142 ?)
	  (a double @reloaditemdb might result in a double free) [FlavioJS]
	* Rev. 11325 Corrected Summer Outfit not included as a PC class. (Zephyrus_CR) [L0ne_W0lf]
	* Rev. 11321 Implemented Summer Outfit care of Zephyrus_CR. [L0ne_W0lf]
	- Increased MAX_GUILDCASTLE in mmo.h to 29 for future implementation
	  of the 12.1 Guild Castles.
	* Fixed sql target not including the save target in the Makefile, needed 
	  by the map server for save/mapreg.txt. (bugreport:131) [FlavioJS]
2007/09/27
	* Loot code using charid's instead of id's in pick priority.
	* configure script using svn:eol-style LF and require mysql/pcre when 
	  --with-mysql/pcre is used.
	* Reimplemented mmo_char_fromsql using sql statements. (fixes bugreport:93)
	* Fixed buildin_gethominfo not being included in the script engine. (bugreport:124)
	* homunculus_evolution -> homevolution in script_commands.txt.
	* Deleted item DEFAULT from item_db.txt and regenerated item_db.sql. (bugreport:103)
	* Skip empty lines and give more feedback (for invalid lines) when reading 
	  item_db.txt/item_db2.txt. [FlavioJS]
2007/09/26
	* Rev. 11307 Implemented Token of Siegfried effect care of Zephyrus_CR. [L0ne_W0lf]
2007/09/25
	* Modified a bit the hard/lazy ai triggers to match aegis (you can alter
	  these changing the defines near the beginning of mob.c):
	- Mobs go into active AI when they are 2 cells from entering a player's
	  view (ACTIVE_AI_RANGE)
	- Mobs in passive AI no longer use skills.
	- Mobs in passive AI do not random walk UNLESS they have entered active AI
	  before (random walk frequency is not lost during passive AI).
	* Added an additional check to prevent support skills from being blocked if
	  the target has an armor element that blocks it. [Skotlex]
	* Fixed the double free's caused by r11290 (wrong option in the database 
	  constructors). [FlavioJS]
	* Corrected being able to cast multiple Gravitation Fields before the
	  previous one is cancelled. [Skotlex]
	* Disabled tick cache (to enable it: define TICK_CACHE to the number of 
	  calls that should be cached).
	* Added a charid2sd database for fast charid searches.
	* Reworked the nick cache to only contain offline characters. [FlavioJS]
2007/09/24
	* Ignore %MDef bonuses now only reduce target's base MDEF, not MDEF2.
	* Updated the 'skills that cause no damage are blocked now if the skill
	  element is blocked by the target' to only apply if the skill has a status
	  change associated (fixes Resurrection/Heal being blocked).
	* Added a warning to prevent loading mobs with IDs that belong to the clone
	  range. [Skotlex]
	* Limited manual detection of data truncation to string/enum/blob columns.
	* Renamed conf-tmpl to conf. [FlavioJS]
2007/09/23
	* Added flag svn:executable to the configure script.
	* Added code for MySQL versions (below 5.0) that don't have 
	  MYSQL_DATA_TRUNCATED.
	* map_addflooritem and struct item_drop_list using id's instead of 
	  struct map_session_data's (fixes bugreport:36).
	* Fixed buildin_escape_sql not properly escaping in sql servers. [FlavioJS]
2007/09/22
	* Fixed a severe bug in inventory saving code (caused by r11192)
	* Applied changes to clif_parse_globalmessage() from my WiP code
	- clearer processing of the individual packet components
	- proper code ordering, some more integrity checks
	- fixes to some poorly chosen ShowWarning() format strings
	- global chat logging no longer logs the entire string (w/ player name)
	* Fixed global chat logging always crashing on a null pointer
	* Added 'safestrnlen' to prevent null pointer crashes [ultramage]
	* Updated sql files [Playtester]
	* Added a sanity check for MAX_ZENY (doesn't compile if too big).
	* Redid the buildin_query_sql function. (fixes bugreport:81). [FlavioJS]
2007/09/21
	* itemdb.c/h using a static array of 32k struct item_data* entries (faster 
	  itemdb loockup and a first step to remove map_session_data->inventory_data).
	* Fixed a typo in the configure script that replaced CFLAGS with CPPFLAGS 
	  when -Wno-pointer-sign is supported by the compiler. [FlavioJS]
	* Fixed a typo in the status-change saving code (wrong variable used)
	* Fixed a case of bad sql code conversion breaking homun skill loading
	* Corrected skill Charge Attack as described in bugreport:67 [ultramage]
	- cast time is between 100% and 300% (+ infinite waiting fixed)
	- damage is also between 100% and 300% (doesn't increase past range 9)
	- added knockback that's equal to the distance to target
	- no longer causes teleportation on WoE grounds
	- if target runs behind an obstacle, the skill will still teleport you,
	  but will not perform the attack or do knockback
	- this should be official behavior, so enjoy the weirdness!
	* Makefile deleting .svn in save folder.
	* Limited the number of packets parsed per cycle to 3.
	* Fixed sql login throwing an out-of-place debug message and escaping too 
	  much of the name string when creating a new login with _M/F.
	* Configure script detects 64bit distributions of MySQL.
	* Generated the configure script with cygwin's autoconf. [FlavioJS]
2007/09/20
	* Merged the tmpsql branch: [FlavioJS]
	- Abstraction for the sql code (sql.c/h).
	- New configure script and makefiles.
	- Restored txt zeny logging code. (r10814)
	- Rewrote mapserver's sql code - itemdb, mobdb, mapreg, logs. (r10814)
	- Fixed a precedence issue (&& and ) in char_sql/char.c. (r10833)
	- Improved db reading code a bit for consistency. (r11077)
	- Added separate atcommand for mail deletion. (r11077)
	- Corrected a few messages that said "new" instead of "unread". (r11077)
	- Broadcast (*) messages now use "*" as the target's name (not ""). (r11077)
	- Moved StringBuf code from utils.c/h to strlib.c/h. (r11084 r11117)
	- Some misc login server cleanups (reformatting etc). (r11136)
	- Corrected/modified some header entries. (r11141 r11147 11148)
	- Adjusted VS project files. (r11147)
	- Adjusted the way the sql charserver does item saving. (r11192)
	- Corrected usage of reserved keyword 'friend' in mmo.h. (r11192)
2007/09/17
	* Several skills with a splash area (except ground based ones) will now hit
	  Ice-walls when casted by mobs.
	* Cleaned up and fixed monster_ai&0x40 (chase through warps). It works
	  correctly now regardless of the number of players on the source/destination
	  maps.
	* Updated sql files [Playtester]
	* Applied various crash-protections to script commands that deal with the
	  equip-position array.
	* Corrected and simplified the skill_magic_reflect function. Fixed damage
	  reflection being based on the caster rather than the target.
	* Potions are now usable inside Gospel by the casting Paladin (as per Aegis
	  tests done by AuronX)
2007/09/14
	* Some changes brought up by AuronX (see topics 160295 and 149176):
	* Gravitional Field is now a MISC type of attack.
	* Magic reflection now effectively switches the caster/target (after damage
	  has been calculated). Moved magic return and Magic Mirror code together
	  with Kaite.
	* Now when GTB completely blocks a spell, the spell animation will still
	  come off, but with a single bolt and MISS damage.
	* Removed hom_setting&0x2 since Homunculus can be hit by land spells.
	* Monster Property now gives a Skill Failed message when attempted on
	  players.
2007/09/13
	* Corrected SG Miracle to trigger per attack, not per walked tile. Trigger
	  rate is now 0.02%
	* Corrected the warmth skills not clearing up correctly the previous field
	  when you place another one down.
	* Corrected vit not affecting the HP bonus that Super Novices, Ninjas and
	  Gunslingers get. [Skotlex]
2007/09/12
	* Fixed a typo in r11179 causing party invitation to fail
	* Added SI_STEELBODY properly (value from packet capture) [ultramage]
2007/09/10
	* Corrected /invite letting you invite people even if you are not the party
	  leader.
	* Added some reply messages when you try /invite and a. the character is
	  not found or b. you are not the party leader.
	* Added a check so that the 'save on crash' routine won't get stuck if it
	  happens to crash while attempting to save characters.
	* People in chat-rooms no longer receive @main messages. [Skotlex]
2007/09/10
	* Added a safeguard to skill_get_unit_layout() against incorrectly
	  defined layout ids (will give weird results but won't crash at least)
	* Fixed Firewall/Icewall being oriented backwards (no real difference..)
	* Removed some junk Landprotector/Graffiti code
	- Graffiti doesn't get placed randomly anymore
	* Icewall can now be cast on yourself
	- TODO: for some reason, the cell on yourself immediately expires...
	* Merged together functions clif_set0192() and clif_changemapcell()
	- also removed its "send to whole map" mode which is just plain wrong
	  (although aegis actually does use it to 'inform' caster about changes)
	* Added config option to adjust exp gained by 'getexp' [ultramage]
2007/09/09
	* Removed bonus bAddEffWhenHitShort as it is unneeded and unused.
	* Corrected getpetinfo so it actually returns "null" when there's no pet
	  and you request the name (the docs state it so).
	* Added gethominfo (which behaves in the same way as getpetinfo).
	* Corrected bonus3 bAutoSpell(WhenHit) to select target enemy (rather than
	  self) for skills with inf self and inf2 'don't target self' (aka:
	  auto-select target skills).
	* Corrected map_foreachinpath to do a wall check for targets beyond the
	  initially selected tile.
2007/09/09
	* Modified bonus3 bAddEff/bAddEffWhenHit so that the last parameter is now
	  passed directly as "trigger" flag. The possible trigger values are
	  ATF_LONG, ATF_SHORT, ATF_TARGET, ATF_SELF. Explanation added to
	  doc/item_bonus.txt [Skotlex]
	* Updated sql files [Playtester]
2007/09/08
	* Adjusted a spot that still blocked GL's skills on login [ultramage]
2007/09/07
	* Added support for the new party invite/reply packets from the latest
	  client version.
	* Added auto-rejecting party/guild invites when the target is disconnected
	  from the server.
	* Changed the default @Main format to prevent crashes in the newer
	  clients.
2007/09/04
	* bonus3 autospell (and autospell when hit) will now select for spell
	  target self when the skill is tagged a support skill.
	* Increased the amount of autospells that can be held at a time from 10 to
	  15
	* Changed the "autocasted strip skills don't have a duration" to apply only
	  to Full Strip.
	* Magic Mirror's duration now is reduced /15 when used on players.
	* Removed bonus bAddDamageByClass since it is not needed, and implemented
	  bAddDefClass which can be used for the same purpose (but previously was
	  doing nothing).
2007/09/03
	* Added bonuses bSPRegenRate, bHPRegenRate. They behave like the opposite
	  of bHPLossRate/bSPLossRate, making you gain x Hp/Sp every y ms.
	* Added bonus bIgnoreMdefRate, used to ignore a % of the target's mdef when
	  using magic attacks (bonus2 will ignore part of the mdef of all targets,
	  bonus3 receives a race argument)
	* You can now use bonus2 bCastRate to adjust the cast rate of a single
	  skill.
	* Cleaned the code for bleeding (hp-loss) and extended it to handle regen
	  as well.
	* Some small cleanups in the pc_bonus functions.
	* Removed bonus3 bHpLossRate since it was doing nothing and is not used.
	* Corrected bGetZeny bonus to be like in Aegis. The amount received is from
	  1 to the given amount, you can use negative zeny values to use an amount
	  dependant on mob's level (amount*lv).
	* Updated doc/item_bonus.txt with all these changes.
	* Anti-Magic/Stone-Skin now increase/decrease def/mdef only and in an
	  absolute mode (+20*lv rather than +20%*lv). Also the duration is greatly
	  decreased (x/15) when used on players.
	* Now when a player uses a strip skill without having it in the skill tree
	  (auto-casted) the duration will be 0, the equipment will be stripped
	  without causing the status change that blocks reequipping.
2007/09/02
	* Added @whereis command (displays normal spawn maps for given mobs).
	  Defaults to a lv10 command. [Skotlex]
	* Updated Refined Sakkat Box to give only 1 Sakkat instead of 10. [Paradox924X]
2007/08/31
	* Added some comments to clif_changechatowner()
	- totally broken, see the code + topic:163829
	* Implemented the chatroom display packet properly
	- now has 4 types: public, private, npc and non-clickable npc chatroom
	* Implemented the chatroom leave packet properly
	- now utilizes the 'kicked' flag when the user was forced to leave
	- TODO: banlist support to prevent re-entry, see jAthena code
	* Documented/cleaned up chatroom code and packetry [ultramage]
2007/08/30
	* Updated sql files [Playtester]
2007/08/29
	* Added bonus bSkillHeal to distinguish offensive skill damage increases
	  from healing power boosts.
	* Moved battle_skillatk_bonus to pc.c, cleaned up the related skillatk
	  bonus code to consider the skillheal bonus option. [Skotlex]
2007/08/23
	* Updated athena-start & start to Shazeya's hack. Please test them! [DracoRPG]
	- Simplest way is to run ./start that is equivalent to Windows runserver_sql.bat
	- To run TXT instead, edit the beginning of athena-start with proper filenames
2007/08/22
	* Fixed Dragon Fear's status change selection and duration.
	* Fixed Metamorphosis not displaying a speed-change update on the client.
	* Status changes that were blocked by element are no longer blocked,
	  instead, now no-damage skills are blocked if they have an element which is
	  absorbed by the target (This is the behaviour that Tharis believes is
	  correct). [Skotlex]
2007/08/19
	* Set proper limits to drop rates, prevents int overflow during calc
	* Cleaned/clarified some #include relationships between headers
	- TODO: pc_read_gm_account() still accessses the RFIFO directly!
	* Again removed the IG_ list from itemdb.h (see r10100 and r10113)
2007/08/18
	* Fixed a deallocation mistake and some buffer overflows in npc_chat.c
	  after doing rtfm@pcre.txt (all caused by incorrect usage of pcre api)
	* Removed underscores in npc_chat.c's variable names (easier to read)
	* Moved npc pcre-data deallocation from npc_remove_map to npc_unload
2007/08/17
	* Implemented the official dual-wield aspd equation [ultramage]
	- using 0.7 instead of 0.66 as modifier (so aspd will be lower now)
	- see topic:151132 for details
2007/08/16
	* Fixed eAthena's wrong interpretation of the respawn times [Playtester]
	* Added icons for NPC_CRITICALWOUND and NPC_SLOWCAST [Playtester]
	* Fixed npc chatrooms not being deleted on npc unload/reload (crash)
	* Modified chat code a bit for more clarity [ultramage]
	- replaced double-indirection on 'owner' with a normal pointer
	- separated some common functionality to 'chat_createchat()'
2007/08/15
	* Merged and completed Latio's work on server-side hot-key saving
	  (http://www.eathena.ws/board/index.php?s=&showtopic=159388&view=findpost&p=884453):
	  Now hotkeys are stored server-side (table hotkey in SQL servers, file
	  save/hotkeys.txt for TXT servers). You can disable this behaviour by
	  commenting out the 'HOTKEY_SAVING' define in mmo.h
	* Apply upgrade_svn11018.sql to create the hotkey table. [Skotlex]
	* Some serious code cleanups
	- adjusted @reloadbattleconf to not depend on variable ordering
	- changed all battle vars to 'int' (removes pointless duplicit coding)
	- added min, max and default columns to battle config data structure
	- added properly bounded values for these columns (or at least tried to)
	- battle-conf loading will now complain if it finds unknown settings,
	  and will reject values that are outside of the allowed range
	- added CHATROOM_TITLE_SIZE and CHATROOM_PASS_SIZE 
	- partially cleaned up chatroom manipulation code
2007/08/13
	* Modified map_foreachinrange so that you can also specify the max length
	  of the path to use. The max_count field in the skill_db is used to specify
	  this range for path-type skills (Sharpshooting, Kamaitachi and the NPC
	  Breath skills.
	* Implemented the 'new' NPC skills described here:
	  http://ro.doddlercon.com/wiki/index.php?title=Monster_Skills . It is mostly
	  complete, but the new status changes (slow cast, critical wounds, etc)
	  don't have any visual effects yet (icon or opt changes? I don't know if
	  they should have). Also I could not find the unit_id for Evil Land, so it
	  looks just like Sanctuary for now. Apart from those, the only skills which
	  I couldn't get to display properly are the Breath skills (with the
	  exception of Fire Breath).
	* Corrected gtb_sc_immunity setting not taking effect if your block value was
	  the same (that is, if the config said 30%, then you would only get status
	  change immunity at 31%, nor 30%) [Skotlex]
	* Fixed a small error in the script_commands documentation about getpartyleader. [Paradox924X]
	* Corrected skill-based hp/sp regen, expect slight increase [ultramage]
2007/08/10
	* Updated item_db.sql [Playtester]
2007/08/09
	* The new functions now clear junk from the output buffer [ultramage]
2007/08/08
	* Moved damage logging to mob_log_damage, now non-damage targetted (or
	  splash) skills also get logged into the monster's 'damage history' which
	  affects the exp-bonus per attacker setting.
	* Implemented the evolution stat growth bonuses for homunculus.
	* Updated the @homstats command to show evolution bonuses
	* Corrected initial intimacy of a newly created homunculus (should be
	  21/1000) [Skotlex]
	* Cleaned up junk left in the code by the mapcache/mapindex update
	- Added mapindex_getmapname(_ext) to help with ".gat" adding/removing
	- Moved related processing to the interface (prevents duplicity)
2007/08/07
	* Expanded isloggedin script command to support an optional argument (char id)
	* Expanded warpparty command to accept target "Leader", this will warp the
	  party to the leader.
	* Added a summon structure to handle non-dead-branch mob-groups since the
	  current implementation totally fails for mob groups that don't have MANY
	  integrants.
	* Fixed mobs not attempting an IDLE skill right before unlocking a target.
	  [Skotlex]
2007/08/06
	* Slightly deobfuscated the max-hp calculation functionality
	- fixed hp/sp calc code adding extra few points from item bonuses
	* Added a null-pointer check to skill_initunit() to prevent a crash
	* Added a while() loop to the client packet processor (for performance)
	* Added support for kRO 2007-05-14aSakexe langtype 0 login packet 0x2b0
2007/08/04
	* Removed weird mvp reward item drop behavior (see topic:160077)
	* Fixed Cart Revolution not transferring status effects on attack,
	  and Cart Termination doing it when it shouldn't (see topic:156745)
	* Fixed #refine not accepting names with spaces in them
	* Fixed disguises not doing sit-down properly (missing self packet)
	  broken since r6299 stable / r5833 trunk [ultramage]
2007/07/30
	* Updated sql files [Playtester]
	* Corrected pet taming code; items are consumed immediately and only 1x
	- TODO: add proper code for people who want delayed consumption
2007/07/28
	* Removed ridiculous refine_posword config switch
	- TODO: remove getequipname() func, it can be fully replaced by editing
	  a few scripts, plus it doesn't do what the docs say it should do
	* Fixed a silly mistake in the main script engine loop ('pos' variable)
	* Fixed monter -> monster typos
	* Compacted some script function code (fewer LoC -> faster trac ^^)
2007/07/27
	* Simplified exp gain equations (now more FPU-friendly and precise)
	- also fixes the uninitialized variable problem... sorry 'bout that >.>
	* Changed the way hit bonus is applied.
	   http://www.eathena.ws/board/index.php?showtopic=157438 [Vicious]
	* Cleaned up mob drop code, crashfix is still needed though...
	* Reduced ignore-list length to 20, added proper reply packet
	* Cleaned up some very poorly written pm-ignore code (see r141)
	* Fixed a typo in Warp Portal code displaying an incorrect map name
2007/07/25
	* Fixed a missing homunculus info packet when doing @refresh
	* Added support for character rename packet (only dummy code for now)
	* Added support for langtype-12 char deletion packet (tested, works)
	* Synchronized txt/sql charserver code a bit
	* Adjusted motd.txt to not crash new clients
	* Removed some dead code from the charserver (see r352)
2007/07/24
	* Fixes on Venom Splasher and the like (see topic:152975) [DracoRPG]
	- VS / Envenom / Throw Venom Knife poison chance raised to 10+4*lv %
	- Removed chance to be poisoned when hit if you're a VS time-bomb
	- Adjusted bomb timer to correct values (5.5+0.5*lv sec)
	- Removed damage boost from Poison React
	- Now ignores EDP damage boost
	- Prevented use on bosses
	- Fixes still needed for recast restriction and splash damage
	* Removed Emperium-damaging ability from Gloria Domini [DracoRPG]
2007/07/23
	* Changed the restricting mapflag for @jump from nowarp/nowarpto
	  to noteleport. Adjust your scripts if you were using it this way.
2007/07/20
	* Corrected packet_db.txt. See topic:158382 for details.
	  As a side-effect, the latest packet version is now 22 instead of 21.
	* Added a charserver config option for the character renaming flag,
	  along with a detailed comment on what it's supposed to be. This
	  eliminates all that "change PACKETVER to 8 and recompile" mess.
	* Moved PACKETVER back to clif.h, cleaned the related code a bit.
2007/07/18
	* Added delay_dependon_agi since people actually use and need it...
	* Small update to the effects list (new exe's effects by Au{R}oN)
	* No sending of the pet_equip packet when pet has no equip (thx2Skotlex)
	* Added back exp gain limiting for old formula to stop exploits (see r8177)
	* Now a message is printed when the packet_ver filter rejects someone
	* Renamed two structs using same name as variables (MSVC debugger issue)
2007/07/13
	* Fixed yet another script engine typo, this time in 'copyarray' [ultramage]
2007/07/09
	* Rev. 10872 Removed a comment I had placed on line 6879 in Skill.c. [L0ne_W0lf]
	* Rev. 10870 Alchemist skill "AM_CANNIBALIZE" ("Summon_Flora") now [L0ne_W0lf]
	  summons the proper monsters.
2007/07/07
	* Fixed typo in 'deletearray' messing up the script engine
	* Added a check to pc_skill() to prevent crashes on unknown skill ids
2007/07/06
	* Cleaned up some nasty code related to skill_blown
	- split 'direction' value from flags
	- moved (almost) entire direction calculating code to the outside
	- bowling bash now has the 'suck-in' effect (knockback is now done
	  in the direction you were last facing, not in your-target direction)
2007/07/05
	* Fixed pet equip and pet hairstyle packet sends [ultramage]
	* Fixed NPC_STOP's visual effect not clearing when the status ends
	* Corrected @homshuffle making the skill tree be lost.
	* Corrected homunculus skills being unusable if the master was sitting or
	  inflicted by a disabling status (eg: petrify, stun)
	* Some fixes to the cell no stacking mod (mainly mobs would just get stuck
	  behind each other and not properly surround you). [Skotlex]
2007/07/04
	* Fixed a copy-paste typo messing up script variables pretty bad D:
2007/07/03
	* Fixed a typo in script engine erroring when working with char params
	* Made Homun Resurrection only fail on cast-end (see topic:155223)
	* Re-coded 'soundeffectall'; removed the third parameter ('coverage')
	- adjust your scripts if you use this command [ultramage]
	* Defined out a problematic piece code in conv_num.
	* Added reporting of constant and param script data.
	* Fixed an incorrect check in menu script command. [FlavioJS]
2007/07/02
	* Undid the change from r10298, frozen status again modifies def/mdef
2007/07/01
	* TXT->SQL converter fixup [ultramage]
	- Added missing char_id insert which totally messed up the conversion
	- Fixed login converter ignoring many columns (although it had the data)
	- Pointed out that Login-stored account variable conversion is MISSING!
	- Pointed out that Status, Homunculus and Mapreg conversion is MISSING!
	- Blocked the config functions from exiting server when file not found
	- Finally added VS8 project files for this thing
2007/06/28
	* Added a missing line to enable @displayskill atcommand [DracoRPG]
2007/06/26
	* Changed the string hash of the script engine to SDBM.
	* Reporting information about script data when an error occurs.
	* More work on ticket #41 (array functions). [FlavioJS]
2007/06/22
	* Changed behavior of some guild-related code (according to X.4 tests):
	- removed code that prevented Homunculus Resurrection during WoE
	- logging in doesn't activate the 5 minute guild skill block anymore
	- non-Urgent guild skills can now only be cast on WoE grounds during WoE
	- all guild skills now have no cast delay (previously was 1 second)
	- casting guild skills will now block FreeCast sages from walking
	- Battle Orders and Regeneration are now instacast
	- Restoration now has a 10 second cast time, reducible only by dex
	- Urgent Call's cast cannot be reduced anymore (not even by items)
2007/06/15
	* Fixed script command sc_end not supporting the extra argument as stated 
	  in script_commands.txt.
	* Script command getarg supports an extra argument with a default value 
	  that is returned if the requested argument doesn't exist. [FlavioJS]
2007/06/11
	* Fixed NPC_PROVOCATION (now the casting mob doesn't keep attacking)
	* accumulated clif.c fixes [ultramage]
	- Fixed pet equip not displaying correctly at all
	- Removed old fixpos packet (the 'new' one is way smaller)
	- Fixed some major logical typos in the code, cleaned up many places
2007/06/10
	* Rev. 10745 Updated itemdb.h with the two new item group values.
	  (38 and 39) Why are they static anyway? [L0ne_W0lf]
2007/06/09
	* Added 'nosave' mapflag to que_bingo for Bingo system purposes. [SinSloth]
2007/06/04
	* Fixed the compilation problem from r10668
2007/06/03
	* Fixed a bad copy-paste from r10028 letting players escape jail
          (char was dead on login, so statuses (SC_JAILED) couln't be applied)
	* Fixed missing client update when 'return to savepoint' fails [ultramage]
2007/06/02
	* Displaying op names instead of numbers in script engine errors.
	* Fixed a bug introduced in the last rework of the fame ranking.
	* Created safestrncpy that ensures the string is nul-terminated. [FlavioJS]
2007/06/01
	* Updated sql files [Playtester]
	* Fixed ircbot not processing new users
2007/05/29
	* Hopefully fixed the vsnprintf incompatibility
2007/05/28
	* Fixed an infinite char-server loop on the map connection [ultramage]
	* RFIFOREST returns 0 when the session is eof (input data is implicitly 
	  discarted).
	* Reworked the player fame update: [FlavioJS]
	- would crash if an invalid pos was received
	- the wrong player could be updated on certain conditions
2007/05/26
	* Identified several more glitches, too tired to fix these...
	* Fixed server not removing member minimap dot when you leave a guild
	* Fixed server not sending party/guild info when you enter a map
	* Fixed guild emblem not showing when you log in (caused by r5359)
2007/05/25
	* Fixed @statall giving you +99 stats instead of setting them to 99
	* Fixed npctalk and @npctalk displaying the # part of the name
	  (client filters these when you request the name of the npc, btw...)
2007/05/23
	* Added new flag to skill_castnodex.txt, to allow per-skill tweaking 
	  of cast time and delay reducibility by item scripts (cards and such)
	* Fixed Martyr's Reckoning never triggering for gms with all skills
	* Added MO_TRIPLEATTACK and RG_SNATCHER to @skillall's skill filter 
	* Made gm_skill_unconditional bypass skill blocking (guild timer, etc)
	* Reverted the weird delay_dependon_agi thing (r8923, r9055, r9059)
	* Changed a few memsets to strncpy (reading past buffer is a bad idea)
	* Sped up some memset operations (multiples of 4 are faster)
	* Fixed a typo in Chase Walk code, /thx to zephyrus_cr [ultramage]
2007/05/22
	* Updated sql files [Playtester]
2007/05/21
	* Since the fifohead mess is gone, fixed leftover bad code structuring
	* Removed the TURBO socket mechanism - it was in fact just using a
	  variable to cache a few arithmetic operations (premature optimization)
2007/05/20
	* Fixed Chase Walk having a deactivation cast time (should be instant)
	* Changed status calc to allow value 0 stats; aegis allows
	  negative values, but eA is unsigned in this regard, so ...
	* Added positional music effect to Battle Chant / Gospel
	- see r10588 on how to disable it if it annoys you ^^;
2007/05/19
	* Added Global chat and Main chat logging
	- lowered the priority of the 'logging off during gw' filter
	* Fixed server crashes when you use long hostnames (/thx to Ancyker)
	* Removed the wtf-y mmo_char_fromsql_short() from r2527 [ultramage]
	* Fixed drops of Thanatos Dolor & Thanatos Odium regarding the quest. [SinSloth]
	* SQL files fixup
	- extended convert_engine_myisam and added innodb version
	- changed the max. email length to 39 (to match value in source code)
	- added comment for storage/guild storage picklog entries
	- changed SETs to ENUMs, which is the proper data type in logs
	- fixed incorrect defaults, shortened mapname lengths to 11
	- use upgrade_svn10575_*.sql to apply changes
	* Removed the vsnprintf->_vsnprintf define for VS9 [ultramage]
	* Corrected the problem with countitem2 [ultramage]
2007/05/14
	* Updated sql files [Toms]
2007/05/11
	* Updated the effect list a bit, changes by Au{R}oN
	* Re-phrased the attacker flee/def penalty config descs [ultramage]
	  Ref: http://www.eathena.ws/board/index.php?showtopic=150918
	* Attempt to fix unwanted teleporting of immobile mobs [Playtester]
2007/05/10
	* Adapted the shortlist to use a static array instead of a linked list and 
	  enabled it.
	* Added Buuyo-Tama's shortlist for send/eof sockets (defined out for now). 
	* Replaced toupper/tolower in ladmin by TOUPPER/TOLOWER defines. [FlavioJS]
2007/05/07
	* Fixed warpwaitingpc not working (bug introduced in r10471). [FlavioJS]
	* Added a check to login_sql against too long db-stored emails [ultramage]
	* Removed an unused variable in script.c [Toms]
	* Fixed Converters not overwriting each other [Playtester]
	- thanks to scerez for the fix
2007/05/06
	* Removed the dependency on winsock.h for definitions, it's all winsock2.h now.
	* Minor documentation/re-coding in chat.c.
	* More work on ticket #41. [FLavioJS]
	* Fixed Red Pouch overriding nobranch mapflag [Playtester]
	* Attempt to fix Kyrie Eleison not castable on enemy players [Playtester]
	- please test, I can't double client to test it in pvp
	- don't forget to recompile before testing
2007/05/04
	* Added an optional read-from-GRF/GAT map loading system back in.
	- It can be turned on with the use_grf flag in map_athena.conf.
	- The conf/grf-files.txt becomes relevant again. [blackhole89]
	* Removed the cyclic map.h<->status.h dependency, which allowed me to 
	  also remove the annoying/memory-wasting MAX_STATUSCHANGE define
2007/04/30
	* Ladmin fixes
	- Added vs8 project file for ladmin
	- Replaced all occurences of printf in ladmin.c with ShowMessage
	- Fixed ladmin working with ips using the wrong byte orer
	* Fixed @jumpto displaying the incorrect player name
	* Added more safeguards to socket.c against socket ids out of range
	  TODO: session[] array isn't explicitly zeroed; is that a good thing?
2007/04/29
	* Fixed login_sql ipbans not working
	* login server will now bind only after finishing the init phase
	* Tried and fixed md5 password encryption [ultramage]
	- login_sql was doing stupid things like re-using one pre-generated
	  key for all connections, and escaping binary md5 data (destroying it)
	- added missing code to login_txt when creating new accounts, showing
	  that storing passwords as md5 hashes never really worked for txt
	- removed PASSWORDENC's conditional compilation effect, now just a flag
	- greatly simplified md5 password checking code, credits to eapp
	* Internal changes to the script engine: [FlavioJS]
	- modulus division detects division by 0.
	  dividing by zero stops the script and gives an error
	- underflow/overflow messages differentiated (warnings)
	- when a script function doesn't return a value, a C_NOP value is pushed 
	  instead (avoids stack corruption)
	- op_add merged with op_2+op_2num/op2_str
	- better type checking in the operators, int/string is never assumed.
	  The script ends when an invalid type is found.
	- other minor code cleanups
2007/04/26
	* Corrected High Jump so it works on Guild Castles when WoE is off.
	* Moonlit petals now always knocks to the back of the character rather than
	  pushing the character away from it's center.
2007/04/25
	* Modified the mob ai think time update after using skills from
	  adelay/amotion to 100ms since the previous method adds a large delay before
	  the AI activates again (which screws up with the timing of idle/walk
	  skills)
	* NPC_MAGICALATTACK now starts a state similar to Sacrificial Ritual, in
	  the sense that every normal attack afterwards becomes a Magical Attack. The
	  skill duration is 15 secs. [Skotlex]
	* Added missing Rachel quest map [Playtester] 
	* Ganbantein now deletes individual skill cells instead of the whole skill
	  in the area it is casted.
	* Modified the mob total damage code to prevent overflows when mobs receive
	  over 2kM damage. [Skotlex]
	* Spider Web / Fiber Lock status cannot be dispelled now [ultramage]
2007/04/24
	* All mob casted skills have a fixed range of 9 now.
	* Pressure no longer vaporizes plants.
2007/04/23
	* Fixed bug which totally broke item group bonuses.
	* Added warnings when setting a pvp/gvg flag removes the other flags on the
	  same map (gvg and pvp can't coexist on the same map)
	* Removed the check that prevented you from casting soul-collect when you
	  already have 5 spirits.
	* Corrected Magic Rod so it doesn't displays any skill-use animation until
	  it triggers.
	* Corrected Steel Body's icon (it actually belongs to AutoBerserk)
	* Debuff on logout&2 is again set to default, instead of removing food
	  bonuses now it removes Maximize Power, Maximum Overthrust and Steel Body.
	  [Skotlex]
	* Extended the functionality of StringBuf - length and appending a string.
	* menu/select/prompt script functions support grouped and empty options.
	  The selected option number is consistent with them.
	* More work on ticket #41. [FlavioJS]
2007/04/22
	* Corrected crash if itemskill is used without an attached player.
	* Removed range checks for autospells as per UltraMage Aegis tests.
	* Added chatID skill fail check to skill_check_condition
	* Corrected @refresh not re-displaying your spirit spheres nor re-setting
	  your cloth dye.
	* Now the "number of attackers" in mob_dead is counted only from online
	  characters on the same map.
	* Updated the autospell bonus scripts so you don't have to specify all the
	  attack type criteria. If neither of BF_LONG/BF_SHORT is specified, the
	  spell will trigger on both. If neither of BF_WEAPON/BF_MAGIC/BF_MISC is
	  specified, the spell will trigger on BF_WEAPON, if neither of
	  BF_NORMAL/BF_SKILL is specified, BF_SKILL is used if the trigger is
	  BF_MAGIC/BF_MISC and BF_NORMAL is used if the attack is BF_WEAPON. This way
	  the default when nothing is specified is
	  BF_NORMAL|BF_WEAPON|BF_SHORT|BF_LONG. [Skotlex]
2007/04/21
	* Removed the +25% mdef, -50% def effect from Freeze status
	* Changed autocast skills, they now only work with normal attacks!
	  Ref: http://www.eathena.ws/board/index.php?showtopic=138159
	* Fixed a few spots where attack_type was getting truncated
	* Hopefully fixed the cygwin + size_t problem (using stddef.h as source)
	* Added ntows() to properly handle that client port number deficiency
	* Adjusted the packet_db array for a more consistent look [ultramage]
2007/04/20
	* Cleaned up the doc folder. Removed outdated, untranslated, useless files
	  and began normalizing a bit other ones~ [DracoRPG]
2007/04/18
	* Added MEXP overflow checks. [LuzZza]
	* Added bonus5 bAutoSpell/bAutoSpellWhenHit. The new parameter is used to
	  specify when the spell should trigger (melee/range + weapon/magic/misc
	  attack), see doc/item_bonus.txt for details. [Skotlex]
	* Changed some %lu to %u in login_sql/login.c because uint32 is now 
	  an unsigned int [Toms]
	* Discarded extra deflate function needed for afm reading [ultramage]
	- as a result, discarded the whole chain of support functions, .c files
	  and includes needed to make that one function run
	- also removed zlib compile/link dependencies where they are not needed
	- reduced the whole zlib package into two core include files
	- adjusted makefiles / project files to reflect this change 
2007/04/17
	* Massive at+charcommand cleanup, big thanks to HiddenDragon [DracoRPG]
	* Partially deobfuscated the grfio module
	* Finally fixed mingw problems, managed to build both TXT and SQL
	* Fixed the uint32 platform problem (Microsoft failed so I removed it :)
	* Removed the cbasetypes.h dependency from the mapcache generator
	* Removed some random compilation warnings [ultramage]
	* Small bugfixes and enhancements to the map cache generator [DracoRPG]
2007/04/15
	* Fixed 'randomtarget' picking dead characters.
	* Adjusted Spiral Pierce, Shield Boomerang and Shield Chain to use atk2
	  instead of weight when used by non-players.
	* Adjusted skills blindAttack, SilenceAttack, StunAttack, PetrifyAttack,
	  CurseAttack, SleepAttack, Lex Divina and Dispell to be area effect skills,
	  if the used skill level has a splash-range different from 0.
	* Mob used Meteor Assault is able to hit icewalls now. [Skotlex]
2007/04/15
	* Fixed TXT char creation blocking characters with nonstandard names
2007/04/13
	* Committing some accumulated stuff [ultramage]
	- makefile typo, maps_athena typo, svn:eol-style native for some files
	* Changed the meaning of inf2=0x1000. Now it is used to "disable usage on
	  enemies", which only works for non-aggressive (inf!=1) skills.
	* If a skill is party/guild only (inf2 0x400/0x800) it will also be
	  castable on enemies if the skill's inf is 1 (offensive target)
	* Corrected the mob behaviour when it locks into an enemy it can't chase.
	  Previously it would get stuck on a lock->unlock->lock loop, with each
	  unlock resetting the "random walk" timer, causing the mob to just idle in
	  place. Now they will attempt idle skills and no longer reset the "random
	  walk" timer, so they behave as if they were in Idle state properly.
	* Now the bonus bAtkEle will be transferred directly to the weapon when the
	  script is in the ammunition, and you are wielding a weapon that consumes
	  ammo per atttack.
2007/04/12
	* Trade-requests now fail if the target is in a NPC.
	* Some cleaning of the castend_map code to prevent the menuskill variable
	  from not being cleared if you made a choice but the skill was not triggered
	  (due to silence, stun or whatever)
	* Cleaned up a bit the Charge Attack casttime equation, should prevent
	  infinite casttime when the distance is 0.
2007/04/11
	* Now when an object changes speed, the old move-packet will be used on the
	  next movement, which should update the object's speed from that point and
	  on-wards. This is done since there appears to be no way to tell the client
	  a given object's speed has changed.
	* Modified spirit of Wizard so that the consumption of 'Fragments' when
	  blocking bounced spells will only consume 1 Fragment per skill casted,
	  regardless of how many hits were reflected.
	* Modified status_get_sc_def to handle both rate and tick reductions. This
	  way it can take care of the fact that curse rate/duration reductions are
	  not reduced by the same stats. Curse duration is now reduced by vit.
	  [Skotlex]
	* Removed an ugly cast in socket.c
	* Fixed Makefile (-Wno-unused-parameter was added twice with gcc4) [Toms]
2007/04/10
	* Recoded and renamed the trim function in strlib to normalize_name.
	* Added a proper trim function to strlib.
	* Cleanups at npc source file adding/removing.
	* Changed db key from 'unsigned char*' to 'const char*'.
	* Defined out the dump function in util.h/c. [FlavioJS]
	* As an experiment Corrected many /W4 warnings on the txt login server
	* Played around with MinGW a bit today... [ultramage]
	- adjusted code so that it handles mingw-specific compatibility problems
	- adjusted the makefile, mingw is not a subset of cygwin
2007/04/09
	* Now when saving a character, only the cart/peco/falcon 'option' states
	  are saved, the rest should be handled by the status change load/save
	  functions. This saves 'permanent' cloaking/hiding and other such oddities
	  if the server is unable to save your status changes on logout.
	* Updated some Guild WoE rules to behave as explained here:
	  http://www.eathena.ws/board/index.php?showtopic=146581 [Skotlex]
2007/04/08
	* Fixed the platform-specific stricmp compilation problem
	* Fixed inverted vending tax equation (!) and made it more precise
	* Moved e_mail_check() and config_switch() to strlib.h
	* Synchronized the login servers a bit
2007/04/07
	* Disabled the exception handler on windows debug builds
	* Fixed Devotion using WE_BABY's status icon (now uses no icon);
	  if you have a way to determine the correct number, give feedback
	* Updated the server's PCRE components to 7.0
	- dll, library, header
	- cleaned the only existing example and moved it to /samples
	- changed the interface, now $@ is used instead of $ to store the result
	- /!\ adjust your scripts if you are using npc regexp parsing /!\
	* Fixed the start_point setting smashing t3h stack in some situations
	* Fixed some over/under-dimensioned arrays (defines already cover the '\0')
	* Fixed an unupdated define making Warp Portal fail with an error [ultramage]
	* Final touches to the whole map crap [DracoRPG]
	- changed MAP_NAME_LENGTH to 12, now there's MAP_NAME_LENGTH_EXT at 16 for
	  uses where there is / may be the .gat extension, code adjusted accordingly
	- moved map_normalize_name to mapindex_normalize_name so that everything
	  handling map names uses the same extension-removing function
	- greatly enhanced the map cache generator, complete documentation on the
	  tool and the map cache format can be found in doc/
	- the map cache format changed a bit as a consequence, but of course a new
	  valid one is included (contains latest Nameless Island maps)
	- and I'm sorry for the number of times I've moved around and renamed files,
	  now the final structure should have been reached
	* Capped clif_heal's heal field (the argument received is int, but the
	  packet field is short, meaning that if the heal is high enough, the client
	  would receive a negative heal amount). [Skotlex]
2007/04/06
	* Made a crazy attempt to at least partially synchronize login&char code
	* Major edit to the way the servers handle ip addresses, making them obey
	  the "host byte order inside, network byte order outside" rule [ultramage]
	- hopefully covered all entry- and exit-points for IP address data
	- discovered several places where Gravity's client breaks the convention,
	  will need to come up with a suitable countermeasure for that
	- other than that, the code should be portable, except for printing and
	  ipban mask testing (those still assume a specific byte order)
	- tested both txt and sql in all usual situations; tested single- and
	  multi-server setups, all seems to work (but watch out for hidden bugs!)
2007/04/05
	* Cleaned @whogm. It will display the name of all gms online. If their GM
	  level is above your own, it will only display their name, otherwise level,
	  position, and party/guild info is displayed. GM's using gm-hide will not
	  appear on this list.
	* Corrected song/dances/encores reducing SP at the incorrect intervals
	  (either never, or every second).
2007/04/04
	* Corrected Longing for Freedom, it should triple SP cost rather than
	  modifying SP cost to 1/sec
	* SC_ENCHANTARMS will no longer fail to start if it's already running with
	  a "higher elemental level".
	* When trying to trade an untradeable item, the add-item-fail packet will
	  be sent so the client does not gets stuck. [Skotlex]
2007/04/03
	* Some spring-cleaning in sql-files, only left SVN 8k+ files [DracoRPG]
	* Updated sql files [Playtester]
	* Fixed char-server crash on @changegm use.
	* Cleaned up mmo_auth, this function wasn't only poorly coded, it also had
	  a SQL-related memory leak in it!
	* Corrected the attack_attr_none check being backwards (ie: this config was
	  working backwards!)
	* All pets can now move regardless of their Mob counter part setting.
	  [Skotlex]
	* Some source code cleaning
	- Fixed the badly worded messages during mapserver startup
	- Cleaned up socket config reading
	- Split resolve_hostbyname() into 2 separate functions for clarity
	- Moved the probably obsolete LOWER/UPPER macros to db.c (TODO: remove)
	- Moved the badly placed compare_item() function to storage.c (see r779)
	* Fully removed the msvcr80.dll dependency from the vs8 project files
2007/04/02
	* Removed some overly verbose item group messages & code
	* re-added the item_group_list for consistency's sake, moved to itemdb.h
	  (after some hacking to remove the ugly map.h dependency)
	* Fixed the server crashing on a timer-queued disguise / undisguise
	* Fixed the server crashing on startup due to bad define [ultramage]
	* Removed bonus 'bAspdAddRate'. bAspdRate now behaves on a stackable
	  matter, so it's no longer needed.
	* Reimplemented the bonus 'bAspd' (raw Aspd increase) [Skotlex]
2007/03/31
	* Added all the missing defines for ctype.h functions and converted all 
	  the direct uses to the defines. [FlavioJS]
2007/03/30
	* Added "do_abort" function to the core. It is invoked when the server has
	  received a Segmentation Fault or Floating Point Exception signal. Currently
	  the only one that uses it is the map-server, which then attempts to save
	  all online characters before aborting. Note that due to the current
	  coding of the sig plugin, do_abort will not be invoked if you use it!
	  This plugin needs to be updated... [Skotlex]
	* Continued script.c cleanup [Toms]
2007/03/29
	* Corrected OPTION_XMAS since 2007 clients have split it up from
	  OPTION_FLYING (on previous clients both were the same option value).
	* Corrected statp array not being long enough to actually hold the status
	  points of ALL levels up to and including MAX_LEVEL. Fixes reaching final
	  level and resetting giving you an unpredictable amount of status points.
2007/03/28
	* Negative aspd rate bonuses will be handled as aspd add rate since the
	  default non-stackable bonus is useless on penalty bonuses.
	* Added check to prevent the client from using passive skills. [Skotlex]
	* Updated sql-files [Playtester]
	* Removed a missing file reference in the athena-start script
	* Fixed a #error "<malloc.h> has been replaced by <stdlib.h>" problem
	* Fixed the msg_silent setting not being announced every time [ultramage]
2007/03/27
	* Cleaned up some the mob skill use code. The skill re-use delay is set at
	  the time the skill is used rather than when it finishes casting. The
	  invalid target check was also moved to the mob skill db reading function.
	* Skills can be used now when the autoskill menu is open (since there's no
	  packet sent by the client when you hit on cancel). [Skotlex]
	* Added some svn:ignore properties [Toms]
	* Solved console plugins compilation error [Toms]
	* Changed MAX_LEVEL to the standard value 99. Memory consumption-= 55MB.
	- !!!WARNING!!! If your server uses higher levels, be sure to adjust
	  this appropriately! (the define can be found in /src/map/map.h)
	* Corrected SC_COMA's success chance (X.4 says it's unconditional 100%)
	* Changed the vs8 used crt library to static linking [ultramage]
2007/03/26
	* Coma now reduces SP to 0 (with the exception of Dark Blessing) [Skotlex]
	* Corrected "format '%lu' expects type 'long unsigned int', but argument 4 
	  has type 'unsigned int'" warning on login.sql [Toms]
2007/03/24
	* Corrected change r10051 which prevented Ice Pick from working [ultramage]
	- the 'ignore_' variables are bitflags and therefore need enough bits
	  to store all info; 8 bits wasn't enough in this case
2007/03/23
	* Major reconfiguration of the vs7 project files (+vs8 while I was at it)
	- added definitions _DEBUG and NDEBUG to tune system-specific stuff
	- reduced the build requirements (Pentium 4 was a bit too much)
	- changed build settings and project structure to match the vs8 projects
	- corrected some vs8 inconsistencies
	* Some generic typo fixes [ultramage]
	* Corrected Ankle Snare/Spider Web having a 1% chance to trap rather than
	  100%
	* Food boosts are now dispelled on death only.
2007/03/22
	* Corrected setitemscript not correctly updating the item's script.
	* Added define MAX_CHARS so you can easily mod the server to support a
	  different amount of characters per account (however, there is still the
	  issue of hexing the client to support this change)
	* Updated msg_athena.conf so it no longer uses broken english on several
	  entries. Thanks to Scerez for the updated file.
2007/03/21
	* getpetinfo 5 will now return the pet's rename flag.
	* Autoloot will now only work on items dropped a certain distance from the
	  player. The distance is defined by AUTOLOOT_DISTANCE in atcommand.h and
	  defaults to AREA_SIZE.
	* Removed Magic Rod's cast bar.
	* Gravitation no longer causes damage flinch. [Skotlex]
2007/03/20
	* Increased MAX_STATUSCHANGE to 300 to make room for new statuses [DracoRPG]
	* Reverted mapindex reading from map_list.txt for the map-server [DracoRPG]
	* Patched the MAX_STATUSCHANGE startup error [ultramage
	* Removed the last argument from script command skillitem.
	* Added skill ITEM_ENCHANTARMS, this is what weapon enchanting items should
	  use.
	* Added support for specifying different elements per skill level in the
	  skill_db
	* Added bonus bNoKnockback.
	* Corrected login sql server not reseting your account state to 0 when the
	  banuntil duration expires.
	* Made the skillatk bonus it's own function, it can now be used to boost
	  Heal/Sanctuary/Potion Pitcher and Slim Pitcher as well.
	* Corrected Teleport's save map entry being sent without the .gat
	  extension.
	* Corrected Warp Portal not sending the map names with the .gat extension.
	* Probably corrected Disarm's strip animation.
2007/03/19
	* Rewrote the jail logic to always use a status change. This means that the
	  character's save point is not changed when jailed, and the char is always
	  warped back to the point where it was before being jailed on unjail.
	* Modified @adjcmdlvl so you can't set a command to require higher level
	  than yourself, and so you can't edit the level of a command which is higher
	  than your own.
	* Corrected attack_attr_none setting disabling elemental resist cards.
	* Corrected Dispell removing Jailed status.
	* Corrected being able to revive with 0 hp.
	* Modified the "Restart" code so that it makes you stand on spot when
	  pc_setpos fails to move you back to your originating location. [Skotlex]
	* Fixed some wrong sql login logic
	* Fixed some compiler warnings, cleaned up mapserver sql-related vars
	* Removed the old 'mapserver charsave' mechanism [ultramage]
	* Globalised use of script_pushint and script_getdata in script.c
	  If someone need them, the regexp used was : 
	  sed -i "s/& *(st->stack->stack_data\[st->start *+ *\([^]]*\)\])/script_getdata(st,\1)/g" script.c
	  sed -i "s/push_val(st->stack, *C_INT *, *\([^)]*\))/script_pushint(st,\1)/g" script.c
	* Little clean of unused variables in script.c [Toms]
	* Script engine:
	- calling functions without using the return value doesn't generate warnings
	- more work on Ticket #41
	* Took care of two warnings and a minor change to the makefile. [FlavioJS]
2007/03/18
	* Added missing VC++ 7.1 project files for mapcache. [Lance]
	* A followup to the login_sql server changes:
	  Due to a missing 'else' in the case_sensitive config setting loading
	  code (see r483 and r3316), the option was always being set to 'off'.
	  Now that I have corrected it, make sure to set it exactly how you
	  want it to behave (usually case-insensitive)!
	  Failure to do so can result in half the server spamming you with
	  messages about how they are getting 'unregistered id' errors.
2007/03/17
	* committing my work on the login server (mostly SQL) [ultramage]
	- removed the check_ip_flag from login&char (there since r1)
	- removed the CMP_AUTHFIFO_IP and CMP_AUTHFIFO_LOGIN2 defines (also r1)
	- removed dynamic_account_ban, gm_db settings, weren't doing anything at all
	- modified the date_format setting to take the format string directly
	- removed overly verbose config loading messages
	- removed/simplified many more useless actions
	- renamed the dynamic_pass_failure_ban_ settings to make more sense
	- collected relevant config settings into a login_config structure
	  and documented their purpose
	- allowed usage of yes/no instead of the user-unfriendly 1/0 method
	  in config settings (and added 1/0 as a possible option)
	- fixed dnsbl which was always taking only the first entry into account
2007/03/16
	* Corrected the structure and added info on the skill fail packet (0x110).
	* Added packet 0x223 as clif_upgrademessage (not used yet).
	* More work on Ticket #41. [FlavioJS]
2007/03/15
	* Added SC_CHANGEUNDEAD to differentiate it from the other elemental change
	  skills. It now fails on Undead/Dark elemental targets.
	* Corrected party item share settings not being properly updated on logon.
	* Corrected battle_attr_none setting applying to elemental attacks instead
	  of neutral ones. [Skotlex]
2007/03/14
	* Finished polishing the new mapcache system [DracoRPG]
	- common/grfio.* now empty except zipping functions (to read mapcache)
	- servers do not use .gat internally anymore
	 => YOU CAN (and should) STOP USING .gat IN YOUR SCRIPTS
	- moved files for the mapcache builder to db/ for now
	- the char-server now uses the same index list as the mapcache builder
	 => poring_c01, poring_c02 and ng_quest mapindex have changed, beware
	* Updated sql files [Playtester]
	* Adjusted @pvpoff, @gvgoff, @killer, @killable to make characters stop
	  attacking when used.
	* Dispell no longer removes food boosts.
	* Players will stop attacking when they change their look.
	* Applied Alydis's fix to the mvp item logs logging mvp items even if the
	  player couldn't get the item.
2007/03/13
	* Corrected the new packet version entries for skilluseposinfo
	* Corrected item reloading not unsetting the "delay consume" flag if the
	  item had changed it's type.
	* the Attack_Type variable in skill_attack now inherits the damage.flag
	  properties, this fixes ranged status effects not triggering.
2007/03/12
	* Added player not attached crash prevention to countitem/countitem2.
	* Probably corrected delitem not deleting pet eggs at all.
	* Hopefully fixed hidenpc/disablenpc not working on Guild flag sprites.
	* Mob skill state "anytarget" no longer triggers when the mob has an
	  item-target (looting).
	* @storage/@gstorage will no longer work if you have a trade or a storage
	  opened already.
	* Corrected script command movenpc so it properly moves the ontouch npc
	  cells as well.
	* Changed the unit-walk packet to be 0x86 as pointed out by FlavioJS. This
	  new packet is much smaller, and should greatly decrease bandwidth usage.
	  The only drawback is that the character will not display at all if the
	  client didn't know of it's existance previously, but eA should always be
	  sending a spawn packet when an object gets into/out of sight anyway, so
	  it should work correctly.
	* Modified the guild master change ack packet to return the aid/cid of the
	  new guild master instead of the index where it was, the previous method
	  could cause problems in situations where the order of guild members would
	  not match exactly between char/map servers.
	* Updated the Soul Linker's Rogue Spirit Stealth's speed bonus to +60%,
	  according to forum infor from ragnagate. [Skotlex]
2007/03/09
	* Mapcache can run on system with any endianness.
	  The generated file contains data in little endian.
	* Added info on packet 0x86 (simple move packet). Not usable until a clear 
	  separation between entering sight/leaving sight/walking in sight is done.
	* Propagating const char* from the script engine.
	* ".gat" is appended to the map name before sending the changemapserver
	  packet to the client. [FlavioJS]
	* Normalized the mapname in guild get/set castle data, should fix guild
	  flags.
	* Added log options 0x800/0x1000 to log storage moves ('R') and guild
	  storage moves ('G')
	* Added upgrade_svn9976.sql to include 'R'/'G' on the picklog type column
	  set.
	* Updated the logs_athena description to include the letter of each type
	  (512 - M, 32 - N, etc)
2007/03/08
	* Corrected the pet/homunc data not being free'd if the player logs out
	  before being authed.
	* Initialized player's speed on pc_setnewpc to prevent homunculus copying a
	  speed of 0.
	* Corrected ranged add-status only triggering if the attack is arrow
	  based.
	* Updated counter add-status so they trigger on ranged attacks instead of
	  using "arrow_atk" state. [Skotlex]
	* Here comes the new mapcache system! [DracoRPG]
	- The last and only big "feature" (kind of cleanup in fact) you'll see
	- Totally removes GRF/GAT handling from map-server that only reads from cache
	- The cache now also contains map indexes, and is mostly zipped (1.5MB atm)
	- It is shipped with eA => 100% client-independant, no more missing maps
	- If you want to add custom maps, the mapcache builder is available, doc
	  and Unix Makefile coming as soon as possible (VC8 project only ATM :/)
	- Removed now useless AFM/AF2 support, as well as the startup screen notice
2007/03/07
	* Corrected the define for NK no cardfix (def).
	* Fixed the char sql server not escaping the server name before inserting
	  it on the ragsrvinfo table.
	* Corrected @lvup not doing the party even share check.
	* Corrected breaker's misc part not ignoring element.
2007/03/06
	* Added NK value 0x80: ignore target's cards (0x8 will now only ignore
	  attacker's cards).
	* Corrected Soul Breaker ignoring target's cards instead of the caster's.
	  [Skotlex]
	* Fixed an infinite loop if script name contains a single ':' [Toms]
	* Simplified the Utsusemi/Bunsinjyutsu check to only block weapon skills
	  that do not ignore offensive cards. [Skotlex]
	* Added support for the 2 new packet versions. [Zephiris]
	* Fixed the loginlog's `user` column length (use upgrade_svn9957.sql)
2007/03/05
	* More tweaks to socket.c to simplify the code [ultramage]
	- many generic cleanups - reformatting, useless code removal, etc
	- made the mode_neg setting a compile-time decision, not a run-time one
	- removed the silly frame_size setting (there since r1)
	- added some TODOs to http://www.eathena.ws/board/index.php?showtopic=127988
	* Added the +20hit that were missing the NPC elemental attack skills.
	* Added support for autospells using "a random skill level". The last value
	  of bonus4 bAutoSpell is used for determining this as well as the target. &1
	  is to cast on target (otherwise cast on self), and &2 is to use a random
	  level UP to the level specified in the script (otherwise always cast the
	  specified level)
	* Updated item_bonus.txt with the documentation for the
	  bAutoSpell/bAutoSpellWhenHit changes.
	* Corrected @refresh not reupdating the basic stat bonuses.
2007/03/03
	* Modified a bit the storm gust counter code to see if it fixes storm gusts
	  sometimes freezing on first hit.
2007/03/02
	* Tatami Gaeshi state (proyectile blocking) now ends when you move.
	* SG Union will consume now SP if you use it while not soul linked.
	* Added variable "skip" to the mob spawn data, to know how many mobs to
	  skip when spawning because they were not removed due to the
	  "mob_remove_damaged" setting.
	* Corrected the Hp/Sp regen formulas from Hp/Sp/Spirit Recovery and
	  Happy/Peaceful break according to recent forums discussions (formula is
	  changed from x*lv +max*lv/500 to lv*(x+max/500). [Skotlex]
	* Added new script function: setiteminfo. Now you can make custom items [Lupus]
	- Updated script function setitemscript(itemID,script,WhichScript)
		now u can set one of 3 item scripts: use/update, equip, unequip
		But it works only if the original item had 3 non empty scriptsin ITEM_DB
		can't fix this issue yet
		1201,Knife,Knife,4,50,,400,17,,1,3,0xFE9F7EEF,7,2,2,1,1,1,1,{dispbottom "1";},{dispbottom "2";},{dispbottom "3";}
		and... if u've used this function, later @reloaditemdb may crush the map server ^_-
	- Check npc/sample/npc_test_setitemx.txt as example of setiteminfo & setitemscript
2007/03/01
	* Corrected raid not doing the "can hit?" check on splash area targets.
	* Fixed the definition of warpwaitingpc so that it allows an optional
	  argument (number of people to warp).
	* Modified the Palm Strike packet so the initial hit animation does not
	  displays "Miss".
	* Added a check to prevent trades from being commited if either character
	  is in final-save state.
	* Checked and cleaned up the online_check code in the char-server. Further
	  connections to the char-server are rejected when the account already has a
	  connection (previously this would happen only if there was already another
	  character IN game, not just waiting on the char-select screen). [Skotlex]
2007/02/28
	* Added the source and VC8 project for my experimental mapcache generator;
	  it is NOT compatible with eA's current mapcache but uses a brand new format
	  that I still have to embed into the map-server [DracoRPG]
2007/02/27
	* NPC_AGIUP now boosts flee by 100% and duration is 5+5*lv secs, as stated
	  on the Ragnarok Bible.
	* Fixed Soul Breaker's misc part not ignoring flee.
	* Fixed misc attack's flee check being backwards (the less hit%, the more
	  chance you had to connect)
	* Corrected the range check in vending.c [Skotlex]
	* Added map & distance check to vending to prevent WPE hacks. [Lupus]
		E.g. buying items from WoE castle
	* Fixed a compiler warning in char_sql\login.c
	* Minor source documentation/cleanup. [FlavioJS]
2007/02/26
	* You are allowed to expel guild mates that are not online now.
	* Corrected damage of BloodDrain
	* Moved the "already connected" checks to pc_authok, since a dual login
	  doesn't needs to be checked until the new connection is accepted.
	* You are allowed to attack/use skills now when your cloaking level is
	  below 3.
	* Small change to Stone Curse that may fix the permanent "semi-stone"
	  status.
	* Corrected "taming monster" having your skill-use be stuck if you cancel
	  the target selection process.
	* config setting party_show_share_picker now displays the jname of the item
	  picked as well.
	* Corrected some typos and small details
	  (forgotten bInfiniteEndure [r6487], mysterious '1' in help file, etc)
2007/02/25
	* Added Krade's makefile fix for 64bit compilers [ultramage]
	- ref: http://www.eathena.ws/board/index.php?showtopic=136622
	* Minor cleanup/documentation on the script engine. [FlavioJS]
2007/02/24
	* Fixed the mob_override_name setting not working on summoned mobs.
	* The server now prints an error message when it the produce_db reaches the
	  max number of allowed produce recipes.
	* The NK value of the skill_db has been made a hexadecimal value, and
	  expanded to include more information about a skill's damage properties: 0x8
	  ignore caster's cards, 0x10 ignore element adjustments, 0x20 ignore
	  target's defense, 0x40 ignore target's flee. Note that magic attacks
	  always ignore flee, and misc attacks always ignore defense.
	* Autoguard will no longer work on skills that don't take in card
	  adjustments
	* utsusemi & bunsinjyutsu no longer work on skills that don't take in card
	  adjustments.
	* Corrected damage of the NPC elemental attack skills, Blood Drain and
	  Energy Drain
	* Adjusted menu-based skills so you can't reuse the same skill until you've
	  dealt with the menu.
	* Adjust autospells so that removing an autospell works when the script of
	  the card that removes the autospell is triggered before the script that
	  adds the spell.
	* The "requested name of gm-hidden char" warning will not be displayed when
	  the object in question is an NPC (since you can use Intravision to do
	  this).
	* Venom Knife no longer takes into accounts cards or EDP.
2007/02/23
	* Guild expulsion now will fail when the character to be kicked is in a
	  guild castle (rather than checking for the character doing the expulsion)
	* pk damage reduction settings now will take effect only on Player VS
	  player damage.
	* Fixed produce_db2.txt entries overwriting produce_db.txt ones.
	* Fixed item-granted/plagiarized skills unlocking skill trees when only
	  your real learned level should. [Skotlex]
2007/02/21
	* Applied a consistent look to all header files (copyright, ifdefs)
	* Minor stuff (typos, socket.c, junk in login reply packet) [ultramage]
2007/02/19
	* Fixed @cartlist info message typo [Lupus]
2007/02/17
	* Fixed a typo from r9778, allowing non-gm chars to use /kill [ultramage]
2007/02/16
	* Fixed the structure of packet 0x6d (new char info). It's the same as the 
	  one used for packet 0x6b (chars info). [FlavioJS]
	* Updated script commands startnpctimer, stopnpctimer, initnpctimer so you
	  can attach a player to them, this is done because the attach/detach
	  functions can't be used to attach to a different script than the one
	  currently running.
	* Updated the script_command reference with the new flag values of
	  [start/stop/init]npctimer.
	* Modified the "guardian" spawn script command, it no longer receives a
	  "amount" argument (since that only leads to trouble), if the class is
	  negative, it'll pick a random class the same way the monster spawn script
	  command does, and if you pass a spawn position with coordinates equal or
	  less to 0, a random spot in the map will be taken. However you can't use
	  "this" as a map name anymore since these script commands do not need an
	  attached player.
	* Guardian spawning will now fail if you attempt to spawn a guardian that
	  already exists on the same position.
	* Miracle of the Sun, Moon and Stars can now retrigger to lenghten it's
	  effect, and it is cancelled on warp/map-change. [Skotlex]
2007/02/15
	* Reverted some of my mobdb code
	* Cleaned up clif_party_info a bit
	* Cleaned up set_reg (the same procedure as get_val) [ultramage]
	* The default packet version is now 8. Clients from November2006 and before
	  can no longer get past the char-server unless you change it back to 7.
	* Fixed Storm Gust counter freezing on fourth hit instead of third.
	* Fixed @homstats not taking into consideration that the stat growth
	  decimals get discarded on level up (so the real minimum/maximum displayed
	  was off).
2007/02/13
	* Applied Rayce's dangling pointer fix when returning a temporary npc
	  string variable (those starting with .@)
	* Required Weapon, ammo, and skill state are now only checked on begin
	  casting, instead of both on begin and end casting.
2007/02/12
	* Fixed Resurrect Homunculus and Wedding skills failing. [Skotlex]
	* A bit more work on Ticket #41.
	* Added 'r' (variable reference) to the script argument definitions.
	* Added a simple define for suspitious actions. (empty at the moment)
	* Added clif_clearcart and moved sending cart packets to pc_setoption.
	* clif_parse_ChangeCart checking the player level. [FlavioJS]
	* Fixed clif_parse_GMmessage cutting off messages randomly [ultramage]
	  (due to a typo in revision r9778)
	* Fixed Wand of Hermod
	* Corrected Spider Web casting around caster instead of target's position.
	* Corrected a possible crash during login due to checking for the incorrect
	  variable (lets pc_calc_status be invoked when it shouldn't)
	* Added bounds checking to map_foreachincell.
	* Opt2 values (poison, blind, and so on) are now resent on warp/map-change.
	* Corrected description of isloggedin script command. [Skotlex]
2007/02/11
	* Fixed the inverted behavior of display_skill_fail, caused by r9823
	* Fixed @loadnpc not updating the script_event[] array
2007/02/10
	* Fixed clif_party_message using an incorrect buffer length [ultramage]
	* Cosmetic changes to the buildin section of script.c (use defines for 
	  function names/definitions). [FlavioJS]
2007/02/09
	* Updated the 'unit walk' to functions so they stop your attack if it's
	  possible to walk.
	* Fixed char server SQL not sending the guild info update to other map
	  servers when a new member is added.
2007/02/08
	* Modified Spider Web so it can instantly retrap a target, rather than
	  idling on the ground waiting for a new target.
	* Cleaned up some the rude-attacked code, being attacked while under spider
	  web now triggers rude-attacked. [Skotlex]
	* Added code for SQL that will automatically detect the ping interval
	  at startup, and copy-pasted it around the code; removed the conf setting
	* Added a missing null pointer check in clif_parse_globalmessage
	* Fixed the new socket code, which was triggering the inactivity timeout
	  on the servers' listening sockets
	* Fixed the TURBO code not working since r4468 (parse func never called)
2007/02/07
	* More aggressive cleaning up of the socket code [ultramage]
	- removed unused session_data2 entry in sd
	- added a new create_session() function, helps keep things cleaner
	  (although it's ad-hoc and not perfect, since this is C)
	- undid r4978 since it was getting in the way (re-add it if you need it)
	- added defines for the recv, send and parse func pointers
	- added null functions for the three actions, and made create_session()
	  calls use those instead of NULL pointers; insignificant penalty and now:
	- since all three funcs are always initialized, removed all those NULL checks 
	- removed the efd set, since as the people from the developernet forums
	  pointed out, it's only for out-of-band data and NOT for error checking
	  (in fact, select() bails out without giving any info if it errors out)
	- reorganized the randomly placed socket.c contents somewhat
	- it'll be a miracle if this works like it should ^^;
	* Modified spider web so that the skill_unit_db flag restrictions may take
	  place. [Skotlex]
	* Cleaning up of the socket code [ultramage]
	- Shuffled includes around for files that were leeching off of socket.h
	- Added code that enforces standard shutdown behavior for sockets
	- Wiped out the poorly written parse code from r2211
	* Removed old script bonuses bMatk, bMatk1, bMatk2.
	* Fixed char-server not sending online notification when a party member
	  logs in.
	* When skill range by distance is set, the distance checked for is now 5
	  cells rather than 3.
	* Fixed bMatkRate bonuses not applying to status earned modifications to
	  int/matk. [Skotlex]
	* Removed deprecated console code.
	* Moved CHAT_SIZE back to map.h because log_atcommand uses it on sql 
	  builds. (moved to clif.c in r9811) [FlavioJS]
2007/02/06
	* Cleaned up the script engine's get_val() function [ultramage]
	- changed the long if-spaghetti into a compact switch statement
	- changed its behavior so that it exits if !sd and it requires one
	- upon exiting, it will now ensure that meaningful values get returned
	  (the old code had no qualms about returning random junk from memory
	   for integer queries, and crashing for string queries)
	- removed many !sd checks since they are done at the beginning now
	* Fixed #lvup having the gm level check backwards.
	* Fixed the stormgust freeze counter going up even if the attack is
	  blocked/cancelled.
	* Cleaned up homunc attack request parsing. Homunculus no longer goes into
	  auto-attack (ctrl+click) mode since the client does every attack request
	  individually.
	* Fixed char-server not sending party status update when a member logs
	  on/off.
	* Fixed crash when parsing guild member information change from the
	  char-server if the specified character is not found in the guild.
	* Fixed MvP mobs giving exp when killed even if they shouldn't.
2007/02/05
	* Fixed @lvup, #lvup not doing a stat reset and lowering your status points
	  if you had 0 status points at that time.
	* Fixed MvP exp and item rewards being given even when the mob_dead flag
	  specifies you should not receive exp or items.
	* Updated the code so that now a range of a skill is determined by the
	  skill's range in the db. Now only skills with less than 5 cells of range
	  are melee.
	* The inf2 parameter of the skill_db is now red as an hexadecimal.
	* The super novice self-revive angel will now trigger only once per
	  session, if you relog you can have it trigger again. [Skotlex]
	* Fixed the skill tree not always updating when using @allskill
	* Probably fixed the target-change on melee attack setting not working.
	* Moved the deletion of the invincible timer when using skills so that it
	  is not deleted for skills such as Ashura (when just selecting a target)
	  [Skotlex]
2007/02/03
	* Continuing the checking of script buildin functions and stop the script 
	  execution when an attached player is required but not found.
	  This task will be referenced as Ticket #41 from now on. [FlavioJS]
	* Updated the TXT login server's account id checker
	  (it was still saying the minimum is 700000 instead of 2000000)
	* Changed the 'getpartyleader' script command so that it returns a map
	  name instead of the useless mapindex number. Also fixed it so that it
	  doesn't throw a 'args of aFree is not valid pointer' error.
	  (although I'm not at all sure that the fix is correct)
	  Ref: http://www.eathena.ws/board/index.php?showtopic=137274
	* Removed the silly and misleading 'firewall detected' message
	* Added missing vc6 project file
	* Corrected a lie in the script documentation [ultramage]
2007/02/02
	* Fixed the flag parameter not working on npcshopattach.
	* Updated the walk delay code so that it parses homunculus as well as
	  players. What this means is that a homunculus walk request won't go ignored
	  if it's issued during the 'can't walk delay' after being hit.
	* Added a possible crash protection in clif_skillfail when the player is
	  without a connection. [Skotlex]
	* Fine-tuned the global message processing function [ultramage]
	- now detects access-out-of-rfifo attempts (idea from eA++)
	- uses the new CHAT_SIZE define to restrict message lengths
	- detects Frost Joke/Dazzler and gives them more freedom (from Freya)
	- more strict non-conformant message detection 
	- logging every problem to the mapserver console
	* Resetting skills will now automatically remove peco, falcon, cart and
	  homunculus (vaporize).
	* Fixed random mob picking choosing clones.
	* Fixed critical spots that could be exploited [Skotlex]
	- The define MESSAGE_SIZE was wrong! It is only used for input boxes.
	  Therefore now it is only used for Vending, Talkie box and Graffiti
	- Added new define CHAT_SIZE which holds the max length that a client
	  can send from the chat buffer
	- Added define msg_len_check which crops incoming client text if it's
	  longer than CHAT_SIZE. Added cropping to all incoming messages except
	  normal chatting which is already accounted for.
	- Removed variable talkie_mes, this is now handled by sd->message
	- Cleaned up parser functions for /b /lb, gm kick, /shift, /recall
	- Added crash protection to the logging functions when they receive
	  a too long string.
2007/02/01
	* Restricted global messages to 255 characters (client shows only ~80 anyway,
	  wanted to use 127 but frost joke's lines are longer than that ...)
	- prevented using a ~22+kB long message to crash everyone on screen
	- prevented faking the message length to cause an out-of-bounds access crash
	- removed the unneccessary 'buf'ffer (inspiration from jAthena)
	- Ref: http://www.eathena.ws/board/index.php?showtopic=137770
	* Corrected the chat system to allow 8-letter passwords
	* Minor details (pdb file location, improved debug, npc typo) [ultramage]
	* Cleaned up the npcshop(add/del)item script commands, fixed a possible
	  dangling pointer crash caused by their improper use of realloc. They no
	  longer automatically attach the script to the shop, and they will return
	  true/false based on whether the shop was found or not.
	* Added script command npcshopattach to enable attaching/detaching your
	  script from any npc shop.
	* Updated doc/script_commands.txt with entries for npcshopitem,
	  npcshopadditem, npcshopdelitem and npcshopattach [Skotlex]
	* A followup to r9761, a header include that somehow didn't commit [ultramage]
	* Item search is now a bit smarter. When no item is found with the same
	  'aegis name', then the 'normal' name is used instead.
	* Updated the @/# commands that take an item name so that you can use
	  quotes when specifying item names with spaces in them. For example, @item
	  "poring card" 1 will work now. Note that only the commands that work on ONE
	  item have been updated, those that do an item list need to be updated as
	  well. [Skotlex]
	* Updated the old vs6 files to latest, thanks to k3dt for contributing them
	* Reorganized the vs6 project files (update will follow)
	* Fixed an accidental change in r9758 (edit&continue) [ultramage]
	* Added support for mob skill target 'randomtarget', when specified, it
	  will pick a random enemy from within the skill's cast range. [Skotlex]
	* Added string function strnlen [ultramage]
	- This thing is useful for removing potential out-of-bounds crashes.
	  Had to #ifdef it because some systems implement it, some don't provide
	  the header, and some don't have it at all. Adjust/improve as neccessary.
	* Corrected homunculus's aspd being halved after using some aspd adjusting
	  skill.
	* Removed the log info message 'created homunc...', and the 'loaded homunc'
	  message will only show if the save_log is enabled.
	* When when a party-member levels up, the level change is sent to the
	  char-server to update the even-share range values.
	* When joining a gvg_dungeon, the pvp packet will be sent to signal
	  versus. With this gvg dungeons should be working correctly now. [Skotlex]
2007/01/31
	* Changes in the VS8 project files: [FlavioJS]
	- synchronized the settings between the projects
	- joined all .h and .cpp files and grouped them based on the src subfolder
	- added Debug/Release build targets that build txt/sql only
	- other minor changes
	* Removed graph, httpd and webserver
	* Wiped out the old night code (use svn if you want it) [ultramage]
2007/01/30
	* 'Long Range Attacked' mob skill conditions will no longer trigger on
	  magic attacks.
	* Corrected char deletion not working (column is called homun_id, not
	  hom_id...)
	* Collapsed config settings produce_item_name_input,
	  produce_potion_name_input, making_arrow_name_input, holywater_name_input,
	  cdp_name_input into a single config produce_item_name_input which uses
	  bitmasks to determine what it affects.
	* Updated arrow_decrement to have 3 possible values: Disabled, Enabled, and
	  Enabled + Autoguess (gives arrow consumption as appropiate to
	  plagiarized/acquired skills).
2007/01/29
	* Corrected the homunculus deletion functions so that the homunculus is
	  deleted together with the character.
	* Added npc_check_areanpc so that Wand of Hermod will correctly check for
	  nearby warps.
	* Emergency avoid now stacks with other speed boost statuses
	* Item skills and skills that bring up a menu now are cleared on death.
	  [Skotlex]
	* Added a nasty hack to prevent multilanguage clients from breaking guild notices
2007/01/27
	* Made @reloadscript wipe ALL previous mobs that the script engine spawned
	- this way it is manageable via global vars; the other way doesn't allow that
	* Some misc cleanups (typos, formatting, forgotten changelog entry etc)
	* Reformatted and translated atcommand.c
	- in the process improved @marry, allowing spaces after the first comma
	* Simple cleanup
	- removed atcommands @w, @server_date/time, @red, @happyhappyjoyjoy, @shuffle
	- synced gm level of @jailfor, @charjailtime, @npcmove, @chardropall,
	  @charstoreall, @send, @mute, @changelook, @exp and @nuke
	- added conf entries for @whozeny, @kamic, @tonpc, @petid, @identify, @adopt,
	  @trade, @changelook, @send
	- reorganized the atcommand_athena.conf file a bit
	* Corrected indentation of the atcommand table (editor compatibility)
	* BEGIN atcommand cleanup process
	  (according to http://www.eathena.ws/board/index.php?showtopic=111996)
	* Fixed a C language restriction preventing compilation [ultramage]
2007/01/26
	* Removed all those useless read-from-GRF features noone would ever use,
	  also removed cutincard script command as a consequence [DracoRPG]
	  - this is only the beginning of full grfio disparition from map-server
	* Now assassins can equip arrows, and status arrows trigger on any ranged
	  physical attack: mimics Grimtooth + status arrow "Aegis bug" [DracoRPG]
	* Added some random Storage Password packets thingies [DracoRPG]
	* Kaite and Assumptio no longer stack. One will remove the other in the
	  same way Assumptio and Kyrie do.
	* Made homunculus renaming go through the char-server so it can be
	  validated against the allowed characters setting.
	* Added battle config hom_rename so you can enable renaming multiple times
	  your homunc.
	* Fixed the normalizing function not sending first classes back to novice
	  if they do not have basic skill maxed.
	* Added a wrapper to delete_timer so it prints out from where the
	  invocation was done.
	* Fixed Splash attacks consuming 2 ammo on each attack. [Skotlex]
	* Added some more freedom for the txt log paths since 32 wasn't enough
	* Removed log_uptime that was accidentally introduced in r1208 [ultramage]
2007/01/24
	* Cleaned up some more the Joint Beat implementation, so the status don't
	  take effect until the attack connects. [Skotlex]
2007/01/23
	* Fixed int/dex foods using an incorrect icon for their status [ultramage]
	* Changed the night status from 149 to 160, which seems to work so much
	  better, and also enabled simplifying the night code.
	* A skill's walk delay will also delay your can-attack time when the skill
	  connects, since this is the behaviour of Sonic Blows as described by
	  Tharis.
	* Added view_data support to mercenary.*, so that the Homunculus entries
	  are no longer required on the mob_db.
	* Added the status icon to NPC_CHANGEUNDEAD and the Flee/Hit foods.
	* Corrected the check that lets you walk when vending/chatting/etc.
2007/01/22
	* Reverted the battle_calc_return_damage code as the previous one was
	  correct, ninja self-targetted skills CAN be reflected. [Skotlex]
2007/01/21
	* Fixed while statements not "reserving" the curly before parsing the test 
	  expression. [FlavioJS]
2007/01/20
	* Fixed some joker's code trying to dereference a null pointer
	* Fixed the server not reacting properly to atcommands/charcommands when using
	  langtype 10/11 (the |XY codepage indicator wasn't being trimmed) [ultramage]
	* Updated @homshuffle so that the skill tree and current skill points are
	  not messed up.
2007/01/19
	* Fixed the label dup code, it now works correctly with const.txt switch
	  labels.
	* Reverted the dup-label check code since it has a bug that needs to be
	  fixed first (it fails to recognize const.txt values) [Skotlex]
	* Fixed a client crash during SQL char selection if you for some reason had
	  more than 9 characters in your account (thanks to Daegaladh) [ultramage]
	  - note that the TXT version already guards against this since long ago
	* Merged Rayce's cleanups of the script engine that account for duplicate
	  labels, non-numeric labels and makes the engine case-insensitive towards
	  keywords like if/case/switch/etc/
	* Added the icons for the Food boosts (need packet version 8 to get them,
	  as these icons will just display Gloria, or crash you, when used on older
	  clients).
2007/01/18
	* Modified the Storm Gust freeze counter code. It now takes into
	  consideration the ID of the skill before increasing the counter, which
	  should effectively yield the closest aproximation to official (even though
	  the counter will reset if you step out of a SG and into another one, we do
	  not know yet what should happen in such a case).
	* Added @homshuffle. It recalculates the homunculus stats, as if the homunc
	  was sent back to level 1, and then releveled. This command is mean to help
	  fix those previously created Homunculus that are much stronger than they
	  should be.
	* Fixed overflow on the mob delay adjustment setting.
	* Fixed characters being unable to trade again if you attempt a trade on
	  someone who is on storage/npc when you accept the trade. [Skotlex]
	* Fixed a crash when a castle from [0..MAX-1] wasn't in the db [ultramage]
2007/01/17
	* Corrected atcommand @homstats so it shows the correct minimum/maximum
	  possible values.
	* Simplified the hom level up function, now decimal stats are no longer
	  stored. This should correct eA's homunculus on average being much stronger
	  than Aegis's.
	* Cleaned up pc_allskillup, @allskills should work correctly now.
2007/01/16
	* Added atcommand @homstats so you can check your homunculus stats and
	  compare them to the minimum/maximum values that you could have at your
	  current level. This command is meant to help figure out if homuncs are
	  indeed getting a faster stat growth than they should have.
	* Fixed the next invoked skill after AbraCadabra not having requirements
	  even when it is a different skill than the one chosen by AbraCadabra.
	* Implemented Intravision as it should be. Thanks to HelloKitty2 for the
	  captured packets.
	* Some cleaning on the mob_ai to enable mobs to run away from their current
	  target when they are rude-attacked by them.
2007/01/15
	* The NPC elemental attacks will display a skill animation again.
	* Mob instant cast skills will use their adelay now.
	* Spirit of Wizard won't work on Ganbantein
	* The pc normalize job function will consider you as novice if you don't
	  have maxed out basic skill.
	* Cleaned up pc_calc_skilltree and related functions so that the id is left
	  as 0 when you can't raise the skill even if you meet the prerequisites.
	  This is to prevent raising quest/soul/marriage skills through packets.
	* Slaves should lock unto their master's target even if they are not
	  attacking yet (eg: in chase mode)
	* Updated the Summon Slave skill to use the slave distance define as valid
	  distance to spawn from master.
	* Fixed Joint Beat's speed penalty.
	* Added a pc_authok check to prevent the case in which somehow another
	  character of the same account manages to log in as well.
	* The pc normalize job function will now recognize you as a novice if you
	  don't have NV_BASIC maxed.
	* Accessories will now by default go into the rigth-side rather than the
	  left-side of the equip window.
	* Added a check in the mob_ai_subhard function to make mobs unlock targets
	  which have their invincible timer set.
	* Probably fixed the registration flood protection code being broken.
	* Joint Break should only re-start the bleeding timer when it currently IS
	  the one that causes bleeding. [Skotlex]
2007/01/12
	* Cleaned up the ip rules/DDoS section of the code. (the allow,deny and 
	  deny,allow cases were switched)
	* Fixed autotrading characters not being able to reconnect. Seams like I 
	  misunderstood how id_db and pc_db are used. [FlavioJS]
2007/01/11
	* Fixed the script engine not parsing strings in multibyte charsets 
	  correctly (should have been done in r9532).
	* Console plugin working when built as Windows native. [FlavioJS]
2007/01/10
	* Combined most of the txt/sql mobdb reading code [ultramage]
	- mob.c is now some 10kB less redundant (now using a common function)
	- automatically filled in some missing parts of the txt part
	  (view_range_rate, chase_range_rate, line counting, etc)
	- also cleaned it up significantly
2007/01/09
	* Changes to script buildin functions: [FlavioJS]
	- functions checking if a player is attached as soon as possible.
	- functions that required a player attached and would crash if none was 
	  there terminate the script now. (others keep the current behaviour to 
	  maintain full backward compatibility)
	- removed the unused flag argument in guildskill.
	- bonus,bonus2,bonus3,bonus4 use the same function now (remains the same 
	  script-wise)
	- added an optional parameter to setcart,setfalcon,setriding so it's 
	  possible to remove the cart/falcon/mount or select a specific cart
	- other cleanups
2007/01/08
	* Hotfix: Freeing of freed pointer when replacing script functions. [Lance]
	* Unimportant cleanups
	* Moved the plugin.def file to the plugins dir and added console.def
	* Found the reason why the console didn't want to run on windows
	  (Microsoft uses !0 and unix uses 0 in pipe_create)
	* Commented out a login_log call (sql doesn't implement that function!)
	* Fixed an old debug message displaying %d instead of a number
	* Silenced the plugin export messages during startup [ultramage]
	* Added a precompiler error when the shutdown defines are not found.
	* Added parse_console to the plugin API.
	* Added plugin for parsing the console. (working with cygwin)
	* Copied the parse_console code form login txt to login sql and char.
	* Added proper plugin version compatibility tests.
	* Better output when a plugin fails to load. [FlavioJS]
2007/01/07
	* Fixed the sleep timers not being removed when the an npc was being 
	  unloaded and when reloading scripts. [FlavioJS]
	* Updated the documentation to match the agitcheck() behavior
	* Undid the memset->malloc_set replacement
	  (let's be compatible and leave such optimizations to system devs, ok?)
	* Small reformatting of conf-tmpl
	* Renamed atcommand_sub to is_atcommand_sub (charcommand too)
	* Re-added the duplicit nj/gs name messages in msg_athena [ultramage]
	  (the code was using those and they look better in that position)
2007/01/06
	* Now winsock 2 is required.
	* Cleaned up do_close and socket_init a bit.
	* Fixed the weight icon dissapearing and reappearing when attacking.
	  (introduced by me at r9600, fix based on ultramage's code) [FlavioJS]
2007/01/05
	* Also discarded some veeery old utils code that has got equivalents
	  in the std libs (and therefore is silently causing a nasty collision).
	* Major reconfiguration of the VS8 project files. [ultramage]
	- Removed the migration binding to a VS71 template.
	- Disabled the setting that defines char -> unsigned char (non-conformant).
	- Switched all projects to use the common C runtime library DLL
	  instead of linking the static version to each exe.
	- Enabled edit&continue on the TXT version (SQL already had it).
	- Reconfigured the linker to use only the really required dependencies.
	- Enabled full optimization and whole program optimization,
	  with additional speed-improving settings for the release build.
	- Set the compiler/linker to produce detailed debug information even for release builds
	  (no performance penalty because the debug info is stored in a separate .pdb file!).
	- I tested all 4 build combinations and it works for me, and it should work for you.
	- There is still one very useful thing missing - setting the working dir to '..'.
	  I don't know how to do that, tho' since VS stores it in a separate user file.
2007/01/04
	* Fixed old @go bug (it ignored einbech) [Lupus]
	* Added Au{R}oN's updated version of the effect list.
	* Completed adding of the new cities to @go.
	  > that function is ugly and needs a complete rewrite, asap.
	* Updated thor volcano warps.
	* Updated /doc from jAthena. [ultramage]

2007/01/03
	* Added Rachel and Veins to the list of @go destinations.
